#include <cstdio>

typedef long long i64;

i64 phi(i64 n) {
    i64 res = n;

    for(i64 p = 2; p * p <= n; p++) {
        if (n % p == 0) {
            while (n % p == 0) {
                n /= p;
            }
            res -= res / p;
        }
    }
    if (n > 1) {
        res -= res / n;
    }
         
    return res;
}
  
int main() {
    i64 t, n;
    scanf("%lld", &t);
    while (t-- > 0) {
        scanf("%lld", &n);
        #ifdef DEBUG
        printf("phi(n) = %lld\n", phi(n));
        #endif
        printf("%lld\n", (phi(n) + 1) / 2);
    }
}