#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <functional>

using namespace std;

void solve(int test_ind){
	int n, l, VV;
	cin >> n >> l >> VV;
	vector<int> v(n);
	for (int i=0;i<n;i++)
		cin >> v[i];
	
	long double L = l;
	long double V = VV;

	auto f = [&](long double t){
		long double res = 0;
		for (int i=0;i<n;i++){
			if (v[i] * t >= L)
				res += L / v[i];
			else
				res += t + (L - t * v[i]) / (v[i] + V) * 2;
		}
		return res / n;		
	};

	auto ternary_search = [&](long double l, long double r){
		for (int k=0;k<100;k++){
			long double m1 = (l * 2 + r) / 3;
			long double m2 = (l + r * 2) / 3;
			if (f(m1) < f(m2))
				r = m2;
			else
				l = m1;
		}
		return l;
	};

	printf("%.13Lf", f(ternary_search(0, L / V)));
}

int main(){
	int t=1;
	//cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
