///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>
 
using namespace std;
 
const int N = 100005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

int n, m;

struct node {
  int x, y, z;
};

vector < pair<int, int> > g[N];

pair <int, int> d[N][2][2];
node parent[N][2][2];

int main() {
  cin >> n >> m;

  for (int i = 1; i <= m; i++) {
    int a, b, c;
    scanf("%d%d%d", &a, &b, &c);
    g[a].push_back(make_pair(b, c));
    g[b].push_back(make_pair(a, c));
  }

  for (int i = 1; i <= n; i++) {
    for (int j = 0; j < 2; j++) {
      for (int h = 0; h < 2; h++) {
        d[i][j][h] = make_pair(-1, -1);
      }
    }
  }

  set < pair< pair< pair<int, int>, int >, pair<int, int> > > q;
  q.insert(make_pair(make_pair(make_pair(0, 0), 1), make_pair(0, 0)));
  d[1][0][0] = make_pair(0, 0);
 
  while (!q.empty()) {
    int v = (*q.begin()).first.second;
    int x = (*q.begin()).second.first;
    int y = (*q.begin()).second.second;
    q.erase(q.begin());
 
    for (int i = 0; i < (int)g[v].size(); i++) {
      int to = g[v][i].first;
      int len = g[v][i].second;
 
      for (int xx = x; xx <= 1; xx++) {
        for (int yy = y; yy <= 1; yy++) {
          int val_x = (xx == x) ? 0 : len;
          int val_y = (yy == y) ? 0 : len;

          auto A = make_pair(d[v][x][y].first + 1, d[v][x][y].second - val_x + val_y);

          if (d[to][xx][yy].first == -1 || A < d[to][xx][yy]) {
            q.erase(make_pair(make_pair(d[to][xx][yy], to), make_pair(xx, yy)));
            d[to][xx][yy] = A;
            parent[to][xx][yy] = {v, x, y};
            q.insert(make_pair(make_pair(d[to][xx][yy], to), make_pair(xx, yy)));
          }
        }
      }
    }
  }
 
  vector <int> answ;
  int gag = n;
  int x = 1, y = 1;
  while (true) {
    answ.push_back(gag);
    if (gag == 1 && x == 0 && y == 0) break;
    node A = parent[gag][x][y];
    gag = A.x;
    x = A.y;
    y = A.z;
  }
  reverse(answ.begin(), answ.end());

  cout << (int)answ.size() - 1 << endl;
  for (int i = 0; i < (int)answ.size(); i++) {
    printf("%d ", answ[i]);
  }
  cout << endl;
  return 0;
}
