#include <bits/stdc++.h>
using namespace std;
typedef pair<int, int> pii;
typedef pair<pii, int> ppi;
typedef pair<int, pii> pip;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const int N = 300010;
long double eps = 1e-9;

map<char, int> t[N];
int sz = 1;
int leaf[N];
void add(string s) {
    int cur = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (!t[cur][s[i]]) {
            t[cur][s[i]] = sz++;
        }
        cur = t[cur][s[i]];
    }
    leaf[cur] = 1;
}

int n, k;
int cnt;
void dfs(int x) {
    vector<int> v;
    for (auto it : t[x]) {
        dfs(it.second);
        leaf[x] += leaf[it.second];
        v.emplace_back(leaf[it.second]);
    }
    sort(v.begin(), v.end());
    while (leaf[x] > k) {
        leaf[x] -= v.back();
        v.pop_back();
        cnt++;
    }
}

void solve() {
    scanf("%d%d", &n, &k);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        add(s);
    }
    dfs(0);
    if (leaf[0]) cnt++;
    cout << cnt << endl;
}

int main() {
#ifdef HAMLET
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}