#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int K = 26;
const int N = 3e5 + 7;
const int MAXN = N * K;

int n, k;
int cnt[MAXN];

struct node {
    int next[26];
    int leaf = 0;
};

node t[N];
int sz = 0;
int ans = 0;

void add(string &s) {
    int v = 0;
    for (int i = 0; i < (int) s.length(); i++) {
        char c = s[i] - 'a';
        if (t[v].next[c] == -1) {
            memset(t[sz].next, 255, sizeof t[sz].next);
            t[v].next[c] = sz++;
        }
        v = t[v].next[c];
    }
    t[v].leaf++;
}

void dfs(int v) {
    cnt[v] = t[v].leaf;
    for (int i = 0; i < 26; i++) {
        if (t[v].next[i] != -1) {
            dfs(t[v].next[i]);
            int nxt = t[v].next[i];
            cnt[v] += cnt[nxt];
        }
    }
    if (cnt[v] > k) {
        vector <int> w;
        for (int i = 0; i < 26; i++) {
            if (t[v].next[i] != -1) {
                w.push_back(cnt[t[v].next[i]]);
            }
        }
        sort(w.rbegin(), w.rend());
        int ptr = 0;
        while (cnt[v] > k) {
            cnt[v] -= w[ptr++];
            ans++;
        }
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    memset(t[0].next, 255, sizeof t[0].next);
    sz = 1;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(s);
    }
    dfs(0);
    if (cnt[0] > 0) {
        ans++;
    }
    cout << ans << endl;
    return 0;
}