#include <bits/stdc++.h>
namespace std {
 
  bool __LOG_ = false;
  #define db(x) if (__LOG_) cerr << (#x) << " = " << (x) << endl;

  #define sz(x)  int((x).size())
  #define all(x) (x).begin(), (x).end()
 
  typedef long long   ll;
  typedef long double ld;
  typedef pair < int, int > pii;
  typedef pair < ll,  ll  > pll;
 
  typedef vector < int > vi;
  typedef vector < ll  > vl;
 
  const int  N         = 200002;
  const int  logN      = 20;
 
  const int  MOD7      = 1000000007;
  const ll   MOD9      = 998244353;
  const ll   MODL      = 1000000007;
  const int  INF       = 1000000007;
  const ll   INFL      = 4ll*1000000007ll*1000000007ll;
  const ld   PI        = acos(-1);
  const int  HPRIME    = 31;
  const ld   EPS       = 1e-30;
 
  inline void No() {
    cout << "NO" << endl;
  }
  inline void Yes() {
    cout << "YES" << endl;
  }
 
  #define fi first
  #define se second
 
  #define pb push_back
 
  template<typename T1, typename T2>
  std::istream& operator>>(std::istream& in, std::pair < T1, T2 > &p) {
    return in >> p.fi >> p.se;
  }
 
  template<typename T1, typename T2>
  std::ostream& operator<<(std::ostream& out, const std::pair < T1, T2 > p) {
    return out << p.fi << " " << p.se;
  }
 
  template<typename T>
  std::istream& operator>>(std::istream& in, vector<T> &vec) {
    for (auto &x: vec) {
      in >> x;
    }
    return in;
  }
 
  template<typename T>
  std::ostream& operator<<(std::ostream& out, const vector<T> &vec) {
    for (auto x: vec) {
      out << x << " ";
    }
    return out;
  }
 
  template<typename T1, typename T2>
  std::vector<T1>& operator+=(std::vector<T1> &a, const std::vector<T2> &b) {
    assert(a.size() == b.size());
    for (size_t i = 0; i < a.size(); ++i) {
      a[i] += b[i];
    }
    return a;
  }
 
  template<typename T1, typename T2>
  std::vector<T1>& operator-=(std::vector<T1> &a, const std::vector<T2> &b) {
    assert(a.size() == b.size());
    for (size_t i = 0; i < a.size(); ++i) {
      a[i] -= b[i];
    }
    return a;
  }
 
  template<typename T1, typename T2>
  std::vector<T1>& operator*=(std::vector<T1> &a, const std::vector<T2> &b) {
    assert(a.size() == b.size());
    for (size_t i = 0; i < a.size(); ++i) {
      a[i] *= b[i];
    }
    return a;
  }
 
  template<typename T1, typename T2>
  std::vector<T1>& operator/=(std::vector<T1> &a, const std::vector<T2> &b) {
    assert(a.size() == b.size());
    for (size_t i = 0; i < a.size(); ++i) {
      a[i] /= b[i];
    }
    return a;
  }
 
  template<typename T>
  std::vector<T> operator+(const std::vector<T> &a, const std::vector<T> &b) {
    std::vector<T> ans(a);
    ans += b;
    return ans;
  }
 
  template<typename T>
  std::vector<T> operator-(const std::vector<T> &a, const std::vector<T> &b) {
    std::vector<T> ans(a);
    ans -= b;
    return ans;
  }
 
  template<typename T>
  std::vector<T> operator*(const std::vector<T> &a, const std::vector<T> &b) {
    std::vector<T> ans(a);
    ans *= b;
    return ans;
  }
 
  template <typename T>
  std::vector<T> operator/(const std::vector<T> &a, const std::vector<T> &b) {
    std::vector<T> ans(a);
    ans /= b;
    return ans;
  }
 
  template<typename T>
  T max(std::vector<T> v) {
    T ans = v[0];
    for (auto x: v) {
      ans = std::max(ans, x);
    }
    return ans;
  }
 
  template<typename T>
  T min(std::vector<T> v) {
    T ans = v[0];
    for (auto x: v) {
      ans = std::min(ans, x);
    }
    return ans;
  }
 
  template<typename T1, typename T2>
  std::pair<T1, T2> operator+(const std::pair<T1, T2>& a, const std::pair<T1, T2>& b) {
    return std::pair<T1, T2>(a.first + b.first, a.second + b.second);
  }
 
  template<typename T1, typename T2>
  std::pair<T1, T2> operator-(const std::pair<T1, T2>& a, const std::pair<T1, T2>& b) {
    return std::pair<T1, T2>(a.first - b.first, a.second - b.second);
  }
 
  template<typename T1, typename T2>
  std::pair<T1, T2> operator*(const std::pair<T1, T2>& a, const std::pair<T1, T2>& b) {
    return std::pair<T1, T2>(a.first * b.first, a.second * b.second);
  }
 
  template<typename T1, typename T2>
  std::pair<T1, T2> operator/(const std::pair<T1, T2>& a, const std::pair<T1, T2>& b) {
    return std::pair<T1, T2>(a.first / b.first, a.second / b.second);
  }
 
  ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
  }
  ////////////////////////////////////////////////////////////////////////////////////////////
 
  // template <>
  // struct hash<pair<int, ll>>
  // {
  //   std::size_t operator()(const pair<int, ll>& k) const
  //   {
  //     using std::size_t;
  //     using std::hash;
  //     using std::string;
 
  //     return (hash<int>()(k.first) ^ (hash<ll>()(k.second) << 1));
  //   }
  // };
 
  void fastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.setf(ios::fixed);
    cout.precision(10);
  }
 
  bool prime(ll n) {
    if (n == 1) return false;
    if (n == 2) return true;
    if (n % 2 == 0) return false;
    for (ll i = 3; i * i <= n; i += 2) {
      if (n % i == 0) return false;
    }
    return true;
  }
 
  ll binpow(ll a, ll b, ll mod = MOD7) {
    ll res = 1;
    while (b) {
      if (b & 1) {
        res = (res * a) % mod;
      }
      a = (a * a) % mod;
      b >>= 1;
    }
    return res;
  }

  ll hak(ll a, ll mod = MOD7) {
    return binpow(a, mod - 2, mod);
  }
}
using namespace std;
 
void precalc() {
}

char c[302][302];

void solve() {
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; i++)
  {
    for (int j = 0; j < m; j++)
    {
      cin >> c[i][j];
    }
  }
  int f = 0, q = 0;
  for (int j = 0; j < m; j++)
  {
    for (int i = 0; i < n; i++)
    {
      if (c[i][j] == '#')
      {
        if (i + 4 < n && c[i + 4][j] == '#')
        {
          c[i][j] = c[i+1][j] = c[i+2][j] = c[i+3][j] = c[i+4][j]
          = c[i][j+1] = c[i][j+2] = c[i+2][j+1] = '.';
          f++;
        }
        else
        {
          c[i][j] = c[i+1][j] = c[i+2][j] = c[i][j + 1] = c[i+2][j+1]
          = c[i][j+2] = c[i+1][j+2] = c[i+2][j+2]=c[i+3][j+2] = c[i+4][j+2] = '.';
          q++;
        }
      }
    }
  }
  cout << q << " " << f << endl;
}
 
int main() {
  __LOG_ = true;
  cout.setf(ios::fixed);
  cout.precision(20);
  fastIO();
  precalc();
 
  ll t = 1;
  // cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
