#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

ll cf[4][4];

ll val[21][21];

int dx[] = {0, 1, 0, -1};
int dy[] = {1, 0, -1, 0};

int found[2][2][2];
int fun[2][2][2][4][4];

void gen(int a, int b) {
    if (a + b > 3) {
        for (ll x = -10; x <= 10; x++) {
            for (ll y = -10; y <= 10; y++) {
                ll v = 0;
                ll xn = 1;
                for (int i = 0; i <= 3; i++) {
                    ll yn = 1;
                    for (int j = 0; i + j <= 3; j++) {
                        v += cf[i][j] * xn * yn;
                        yn *= y;
                    }
                    xn *= x;
                }
                val[x + 10][y + 10] = v;
            }
        }
        int lmax = 0, lmin = 0, lplat = 0;
        for (int x = 0; x <= 20; x++) {
            for (int y = 0; y <= 20; y++) {
                if (x && y && x < 20 && y < 20) {
                    bool ismax = true;
                    bool ismin = true;
                    for (int dir = 0; dir < 4; dir++) {
                        if (val[x + dx[dir]][y + dy[dir]] >= val[x][y]) {
                            ismax = false;
                        }
                        if (val[x + dx[dir]][y + dy[dir]] <= val[x][y]) {
                            ismin = false;
                        }
                    }
                    if (ismax) {
                        lmax++;
                    }
                    if (ismin) {
                        lmin++;
                    }
                }
                for (int dir = 0; dir < 4; dir++) {
                    if (x + dx[dir] >= 0 && x + dx[dir] <= 20 && y + dy[dir] >= 0 && y + dy[dir] <= 20 && val[x + dx[dir]][y + dy[dir]] == val[x][y]) {
                        lplat++;
                        break;
                    }
                }
            }
        }
        if (!found[lmax > 1][lmin > 1][lplat > 0]) {
            cerr << "fond for " << lmax << ' ' << lmin << ' ' << lplat << endl;
            cout << "fond for " << lmax << ' ' << lmin << ' ' << lplat << endl;
            found[lmax > 1][lmin > 1][lplat > 0] = 1;
            for (int i = 0; i < 4; i++) {
                for (int j = 0; j < 4; j++) {
                    cout << cf[i][j] << ' ';
                    fun[lmax > 1][lmin > 1][lplat > 0][i][j] = cf[i][j];
                }
                cout << endl;
            }
            cout << endl;
        }
        return;
    }
    int nxta = a, nxtb = b + 1;
    if (nxta + nxtb > 3) {
        nxta++;
        nxtb = 0;
    }
    for (int val = -2; val <= 2; val++) {
        cf[a][b] = val;
        gen(nxta, nxtb);
    }
}

int solve2() {
    freopen("out.txt", "w", stdout);
    gen(0, 0);
    return 0;
}

vector<vector<vector<int>>> coeffs {
{
    {-2, -2, -2, -2},
    {-2, -2, -2, 0},
    {-2, -2, 0, 0},
    {-2, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -2, -2, 0},
    {-2, -2, 0, 0},
    {0, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -2, 0, 0},
    {-2, 2, 0, 0},
    {-2, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -2, -2, 0},
    {-2, 1, 0, 0},
    {2, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -2, -2, 0},
    {-2, 1, 0, 0},
    {1, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -2, -1, 0},
    {-2, 2, 0, 0},
    {1, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -1, 1, 0},
    {2, 2, 0, 0},
    {-1, 0, 0, 0}
}, {
    {-2, -2, -2, -2},
    {-2, -2, -2, 0},
    {-2, 2, 0, 0},
    {2, 0, 0, 0}
}
};

vector<string> mon = {
    "",
    "y *",
    "y y * *",
    "y y y * * *",
    "x *",
    "x y * *",
    "x y y * * *",
    "x x * *",
    "x x y * * *",
    "x x x * * *",
};

int solve() {
    string a, b, c;
    getline(cin, a);
    getline(cin, b);
    getline(cin, c);
    int lmx = (a.back() == 's');
    int lmn = (b.back() == 's');
    int lpl = (c.back() == 's');
    int msk = lmx * 4 + lmn * 2 + lpl;
    bool firstt = true;
    int ind = 0;
    for (int i = 0; i < sz(coeffs[msk]); i++) {
        for (int j = 0; j < sz(coeffs[msk][i]); j++) {
            if (i + j <= 3) {
                if (!firstt) {
                    cout << ' ';
                }
                cout << coeffs[msk][i][j];
                if (ind) cout << ' ' << mon[ind];
                ind++;
                if (!firstt) {
                    cout << " +";
                }
                firstt = false;
            }
        }
    }
    return 1;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
