#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

int solve() {
    int n;
    if (!(cin >> n)) {
        return 1;
    }
    vector<int> b(n, 0), w(n, 0);
    vector<int> used(n, 0);
    vector<pair<pair<int, int>, char>> e;
    set<pair<int, int>> qw, qb;
    queue<int> q;
    int sw = 0, sb = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i] >> b[i];
        if (w[i] + b[i] == 0 && n > 1) {
            cout << "No\n";
            return 0;
        }
        if (w[i] + b[i] == 1) {
            q.push(i);
        }
        qw.insert({-w[i], i});
        qb.insert({-b[i], i});
        sw += w[i];
        sb += b[i];
    }
    if (sw % 2 != 0 || sb % 2 != 0 || sw + sb != 2 * n - 2) {
        cout << "No\n";
        return 0;
    }
    if (n == 1) {
        cout << "Yes\n";
        return 0;
    }

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (b[v] == 1) {
            if (qb.empty()) {
                break;
            }
            auto u = qb.begin()->second;
            qb.erase(qb.begin());
            while (u == v || used[u] || b[u] == 0) {
                if (qb.empty()) {
                    break;
                }
                u = qb.begin()->second;
                qb.erase(qb.begin());
            }
            if (u == v || used[u] || b[u] == 0) {
                break;
            }
            b[v]--;
            b[u]--;
            e.push_back({{v, u}, 'B'});
            if (b[u]) {
                qb.insert({-b[u], u});
            }
            if (b[u] + w[u] == 1) {
                q.push(u);
            }
        } else if (w[v] == 1) {
            if (qw.empty()) {
                break;
            }
            auto u = qw.begin()->second;
            qw.erase(qw.begin());
            while (u == v || used[u] || w[u] == 0) {
                if (qw.empty()) {
                    break;
                }
                u = qw.begin()->second;
                qw.erase(qw.begin());
            }
            if (u == v || used[u] || w[u] == 0) {
                break;
            }
            w[v]--;
            w[u]--;
            e.push_back({{v, u}, 'W'});
            if (w[u]) {
                qw.insert({-w[u], u});
            }
            if (b[u] + w[u] == 1) {
                q.push(u);
            }
        }
        used[v] = 1;
    }

    int kekster = 0;
    for (int i : used) {
        if (i == 0) {
            kekster++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (b[i] != 0 || w[i] != 0) {
            kekster = 100;
        }
    }
    if (kekster > 1) {
        cout << "No\n";
        return 0;
    }
    cout << "Yes\n";
    for (auto [pr, c] : e) {
        auto [v, u] = pr;
        cout << v + 1 << ' ' << u + 1 << ' ' << c << '\n';
    }
    return 0;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
