#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll
 
const int N = 505;
const int T = 27;
const int K = 305;
const int MOD = 998244353;
 
int fp(int a, int p) {
    int x = 1;
    for (; p > 0; p >>= 1) {
        if (p & 1) {
            (x *= a) %= MOD;
        }
        (a *= a) %= MOD;
    }
    return x;
}
 
int inv(int x) {
    return fp(x, MOD - 2);
}
 
int n, m, k;
 
// kn[i][j] = подмножества размера i с суммой j
void add(int kn[T][K], int a) {
	for (int c = m - 1; c >= 0; --c) {
		for (int s = 0; s <= k - a; ++s) {
			(kn[c + 1][s + a] += kn[c][s]) %= MOD;
		}
	}
}

void del(int kn[T][K], int a) {
	for (int c = 0; c < m; ++c) {
		for (int s = k - a; s >= 0; --s) {
			(kn[c + 1][s + a] += MOD - kn[c][s]) %= MOD;
		}
	}
}
 
int a[N][T];
int fac[N];
int kn[N][T][K];
int prob[N][T][K];
int pprob[N][T][K];
int total[T][K];
int fs[N][T];
 
signed main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0); cin.tie(0);
    fac[0] = 1;
    for (int i = 1; i < N; ++i) {
        fac[i] = fac[i - 1] * i % MOD;
    }
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
        kn[i][0][0] = 1;
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            if (a[i][j]) {
                add(kn[i], a[i][j]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int S = 0;
        for (int j = 0; j < m; ++j) {
            S += a[i][j] > 0;
        }
        for (int j = 0; j < m; ++j) {
            if (!a[i][j]) {
                continue;
            }
            del(kn[i], a[i][j]);
            for (int t = a[i][j]; t <= k; ++t) {
                int sum = 0;
                for (int w = 0; w < S; ++w) {
                    int cur = fac[w] * fac[S - 1 - w] % MOD;
                    (cur *= kn[i][w][t - a[i][j]]) %= MOD;
                    (sum += cur) %= MOD;
                }
                prob[i][j][t] = sum * inv(fac[S]) % MOD;
            }
            add(kn[i], a[i][j]);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int t = 0; t <= k; ++t) {
                pprob[i][j][t + 1] = (pprob[i][j][t] + prob[i][j][t]) % MOD;
            }
        }
    }
    fill_n(total[0], T * K, 1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int t = 0; t <= k; ++t) {
                (total[j][t] *= MOD + 1 - pprob[i][j][t]) %= MOD;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int t = 0; t <= k; ++t) {
                int cur = total[j][t] * inv(MOD + 1 - pprob[i][j][t]) % MOD;
                (cur *= prob[i][j][t]) %= MOD;
                (fs[i][j] += cur) %= MOD;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int answer = 0;
        for (int j = 0; j < m; ++j) {
            (answer += fs[i][j]) %= MOD;
        }
        cout << answer << "\n";
    }
    return 0;
}