#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#ifndef MY
    #define endl '\n'
#endif
#define int long long
#define sz(x) (int)x.size()

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;



const int inf = 1e9 + 7;
const int N = 2e4 + 5;
string name[N];
int val[N];
int clr[N];
map < string, int > last, used;
pii ind[N];

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << clr[a] << ' ';
    out << endl;
    return out;
}


void parse(int v) {
    string s;
    cin >> s;
    bool dig = 0;
    for (int i = 0; i < sz(s); i++) {
        if (s[i] == '=') {
            dig = 1;
            continue;
        }
        if (dig) {
            val[v] = val[v] * 10 + (s[i] - '0');
        } else {
            name[v].pb(s[i]);
        }
    }
}

void stop() {
    cout << "No";
    exit(0);
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
    //freopen("f.out", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int sum = 0;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        for (int j = 0; j < m; j++) {
            clr[sum + j] = i + 1;
            parse(sum + j);
        }
        sum += m;
        ind[i] = {sum - 1, m};
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        string s;
        int x;
        cin >> s >> x;
        last[s] = x;
    }
    vector < int > ans;
    for (int i = 0; i < sum; i++) {
        bool ok = 0;
        for (int j = 0; j < n; j++) {
            if (ind[j].S == 0) {
                continue;
            }
            int k = ind[j].F;
            if (used[name[k]] || last[name[k]] == val[k]) {
                used[name[k]] = 1;
                ans.pb(k);
                ind[j].F--;
                ind[j].S--;
                ok = 1;
                break;
            }
        }
        if (!ok) {
            stop();
        }
    }
    cout << "Yes" << endl;
    reverse(all(ans));
    cout << ans;
    return 0;
}
