﻿#include <math.h>
#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <complex>
#include <ctime>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

//#define int long long

#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

mt19937 mrand(random_device{}());

const double pi = acos((double) -1);
const ld eps = 1e-8;
const int inf0 = 1023 * 1024 * 1024;
const ll inf = 4e18;
const ll mod = 1e9 + 7;
//const ll mod = 998244353;

void solve();

signed main() {
#ifdef DEBUG
  freopen("test.in", "r", stdin);
  freopen("test.out", "w", stdout);
#endif
  cin.tie(nullptr);
  cout.tie(nullptr);
  ios_base::sync_with_stdio(false);
  cout << fixed;
  cout.precision(15);
  solve();
  return 0;
}

ll gcd(ll a, ll b) {
  while(b) {
    a = a % b;
    swap(a, b);
  }
  return a;
}

ll lcm(ll a, ll b) {
  return a * b / gcd(a, b);
}

void solve() {
  ll n, m, c; cin >> n >> m >> c;
  ll g = gcd(m, c);
  ll l = lcm(m, c);
  ll t = n / l;
  ll a1 = (c / g) * t, a2 = 0;
  ll x = 0, y = 0;
  for(ll i = 0; i <= c; i++) {
    for(ll j = 0; j <= m; j++) {
      if(abs((a1 + x) * m + (a2 + y) * c - n) > abs((a1 + i) * m + (a2 + j) * c - n)) {
        x = i;
        y = j;
      }
    }
  }
  cout << (a1 + x) << " " << (a2 + y) << endl;
}