#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    ll n;
    while (t--) {
        cin >> n;
        if (n % 2 == 1) {
            cout << (n - 1) / 2 << endl;
        } else if (n == 2) {
            cout << 1 << endl;
        } else {
            for (ll i = n / 2; i >= 0; i--) {
                if (gcd(i, n) == 1) {
                    cout << i << endl;
                    break;
                }
            }
        }
    }
    return 0;
}
