#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>
#include <numeric>
#include <bitset>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
const int mod = 1000000007;
const int iinf = (int)1e9 + 10;
const ll linf = (ll)1e18 + 10;

int pw(int x, int n){
    int res = 1;
    while (n--){
        res *= x;
    }
    return res;
}

const int sz = 10;

int cnt[2][2][2];

void kek (vector <int> & degx, vector <int> & degy, vector <int> & coef, int n){
    for (int i = 0; i < n; i++){
        cout << "x " << degx[i] << " ^ ";
        cout << "y " << degy[i] << " ^ ";
        cout << "* " << coef[i] << " * ";
        if (i > 0) cout << "+ ";
    }
    cout << "\n";
}

void solve(){
    vector <int> f(3);
    for (int i = 0; i < 3; i++){
        string s; getline(cin, s);
        if (s.back() == 'o') f[i] = 0;
        else f[i] = 1;
    }
    for (int t = 0; t < 100; t++){
        int maxn = 5;
        vector <int> degx(maxn), degy(maxn), coef(maxn);
        for (int j = 0; j < maxn; j++) {
            degx[j] = rand() % 5;
            degy[j] = rand() % 5;
            coef[j] = rand() % 5 - 2;
        }

        vector <vector <int>> val(2*sz+2, vector <int>(2*sz+2));
        for (int i = -sz; i <= sz; i++){
            for (int j = -sz; j <= sz; j++){
                for (int m = 0; m < maxn; m++){
                    val[i+sz][j+sz] += coef[m] * pw(i, degx[m]) * pw(j, degy[m]);
                }
            }
        }
        int mn = 0, mx = 0, plat = 0;
        for (int i = 1; i <= 2*sz; i++){
            for (int j = 1; j <= 2*sz; j++){
                if (val[i][j] == val[i-1][j] && val[i][j] == val[i+1][j] &&
                        val[i][j] == val[i][j-1] && val[i][j] == val[i][j+1]){
                    plat++;
                }
                if (val[i][j] > val[i-1][j] && val[i][j] > val[i+1][j] &&
                    val[i][j] > val[i][j-1] && val[i][j] > val[i][j+1]){
                    mx++;
                }
                if (val[i][j] < val[i-1][j] && val[i][j] < val[i+1][j] &&
                     val[i][j] < val[i][j-1] && val[i][j] < val[i][j+1]){
                    mn++;
                }
            }
        }
        //cout << mn << " " << mx << " " << plat << endl;
        int f1 = (mn >= 2);
        int f0 = (mx >= 2);
        int f2 = (plat >= 1);
        if (f0 == f[0] && f1 == f[1] && f2 == f[2]){
            kek (degx, degy, coef, maxn);
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t; // cin >> t;
    t = 1;
    while (t--){
        solve();
    }

    return 0;
}