// #pragma GCC optimize("Ofast,no-stack-protector,unroll-all-loops,unroll-loops")
// #pragma GCC target("abm,mmx,sse,sse2,sse3,ssse3,sse4a,popcnt,tune=native")
 
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <map>
#include <ctime>

#define prev asldasd
 
using namespace std;

typedef long long ll;
typedef long double dbl;


const int maxn = 1e5 + 7;

const int inf = 1e9 + 7;

void process(
    int id,
    vector<vector<pair<string, int>>>& orders,
    map<string, int>& ass,
    map<string, vector<int>>& wait,
    vector<int>& result
) {
    while (orders[id].size()){
        auto[name, val] = orders[id].back();
        auto f = ass.find(name);
        if (f == ass.end()){
            result.push_back(id);
            orders[id].pop_back();
        } else {
            if (f->second == val){
                result.push_back(id);
                ass.erase(f);
                orders[id].pop_back();
                for (int x : wait[name])
                    process(x, orders, ass, wait, result);
            } else {
                wait[name].push_back(id);
                break;
            }
        }
    }
}
 
void solve(){
    int n;
    cin >> n;
    vector<vector<pair<string, int>>> orders(n); 
    for (int i = 0; i < n; i++){
        int k;
        cin >> k;
        for (int j = 0; j < k; j++){
            string ass;
            cin >> ass;
            string name;
            int val;
            for (int l = 0; l < ass.size(); l++){
                if (ass[l] == '='){
                    name = ass.substr(0, l);
                    val = stoi(ass.substr(l + 1, ass.size()));
                    break;
                }
            }
            orders[i].push_back({name, val});
            // cout << name << ' ' << val << endl;
        }
    }
    int k;
    cin >> k;
    map<string, int> ass;
    for (int i = 0; i < k; i++){
        string name;
        int val;
        cin >> name >> val;
        ass[name] = val;
        // cout << name <
    }
    map<string, vector<int>> wait;
    vector<int> result;
    for (int i = 0; i < n; i++)
        process(i, orders, ass, wait, result);
    for (int i = 0; i < n; i++){
        if (orders[i].size()){
            cout << "No\n";
            return;
        }
    }
    reverse(result.begin(), result.end());
    cout << "Yes" << endl;
    for (int x : result)
        cout << x + 1 << ' ';
    cout << endl;
}

 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
    return 0;
}