﻿#include <bits/stdc++.h>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

#define int ll

const int MAXN = 3e5 + 15;

int nxt[MAXN][26];
int depth[MAXN];
int par[MAXN];
int cnt[MAXN];
int root = 0, timer = 1;
bool deleted[MAXN];
set <pi> q[MAXN];

void Add(const string& s) {
    int v = root;
    cnt[v]++;
    for (auto u : s) {
        u -= 'a';
        if (nxt[v][u] == -1) {
            par[timer] = v;
            depth[timer] = depth[v] + 1;
            nxt[v][u] = timer++;
        }
        v = nxt[v][u];
        ++cnt[v];
    }
}

void FindLimited(int v, int k) {
    if (cnt[v] <= k) {
        q[depth[v]].insert({cnt[v], v});
        return;
    }
    forn(i, 26) {
        if (nxt[v][i] != -1)
            FindLimited(nxt[v][i], k);
    }
}

inline void CheckNbrs(int v, int k) {
    for (int p = par[v]; p != -1; p = par[p]) {
        //cout << "check " << p << endl;
        cnt[p] -= cnt[v];
        if (cnt[p] > k) {
            forn(i, 26) {
                if (nxt[p][i] == -1) continue;
                if (cnt[nxt[p][i]] <= k)
                    q[depth[p] + 1].insert({cnt[nxt[p][i]], nxt[p][i]});
            }
            for (int p2 = par[p]; p2 != -1; p2 = par[p2])
                cnt[p2] -= cnt[v];
            break;
        } else {
            forn(i, 26) {
                if (nxt[p][i] == -1) continue;
                q[depth[p] + 1].erase({cnt[nxt[p][i]], nxt[p][i]});
            }
            q[depth[p]].insert({cnt[p], p});
        }
    }
}

void Solve() {
    memset(nxt, -1, sizeof(nxt));
    memset(par, -1, sizeof(par));
    int n, k;
    cin >> n >> k;
    forn(i, n) {
        string s;
        cin >> s;
        Add(s);
    }

    /*forn(i, timer) {
        forn(j, 4)
            cout << nxt[i][j] << ' ';
        cout << endl;
    }

    forn(i, timer) {
        cout << cnt[i] << ' ';
    } cout << endl;*/

    int ans = 0;
    FindLimited(0, k);
    for (int d = MAXN - 1; d > -1; d--) {
        while (!q[d].empty()) {
            // it->first >= k + 1
            auto it = prev(q[d].end());
            int v = it->second;

            /*cout << "v = " << v << endl;
            forn(i, timer) {
                cout << cnt[i] << ' ';
            } cout << endl;
            for (int i = 0; i < 5; i++) {
                cout << "d: ";
                for (pi p : q[i])
                    cout << p.second << ' ';
                cout << endl;
            }*/

            if (it->first == 0) {
                break;
            }
            q[d].erase({cnt[v], v});
            CheckNbrs(v, k);

            /*forn(i, timer) {
                cout << cnt[i] << ' ';
            } cout << endl;
            for (int i = 0; i < 5; i++) {
                cout << "d: ";
                for (pi p : q[i])
                    cout << p.second << ' ';
                cout << endl;
            }*/

            ++ans;
        }
    }
    cout << ans;
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    int t = 1;
//    cin >> t;
    for (int i = 1; i <= t; ++i) {
        //        cout << "Case #" << i << ": ";
        Solve();
    }
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}