﻿#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <list>

using namespace std;

void deleteF(vector<set<int>>& ceils, int row, int col) {
    ceils[col].erase(row);
    ceils[col - 1].erase(row);
    ceils[col - 1].erase(row + 2);
    ceils[col - 2].erase(row);
    ceils[col - 2].erase(row + 1);
    ceils[col - 2].erase(row + 2);
    ceils[col - 2].erase(row + 3);
    ceils[col - 2].erase(row + 4);
}

void deleteQ(vector<set<int>>& ceils, int row, int col) {
    ceils[col].erase(row);
    ceils[col].erase(row + 1);
    ceils[col].erase(row + 2);
    ceils[col].erase(row + 3);
    ceils[col].erase(row + 4);
    ceils[col - 1].erase(row);
    ceils[col - 1].erase(row + 2);
    ceils[col - 2].erase(row);
    ceils[col - 2].erase(row + 1);
    ceils[col - 2].erase(row + 2);
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<set<int>> ceils(m);
    for (int r = 0; r < n; r++) {
        for (int c = 0; c < m; c++) {
            char ch;
            cin >> ch;
            if (ch == '#')
                ceils[c].insert(r);
        }
    }

    int quanQ = 0, quanF = 0;
    bool mark = 1;
    while (mark) {
        int rightRow, rightCol;
        mark = 0;
        for (int c = m - 1; c >= 0; c--) {
            if (ceils[c].empty())
                continue;
            mark = 1;
            rightRow = *ceils[c].begin();
            rightCol = c;
            break;
        }

        if (!mark)
            break;
        if (ceils[rightCol].find(rightRow + 1) != ceils[rightCol].end()) {
            quanQ++;
            deleteQ(ceils, rightRow, rightCol);
        }
        else {
            quanF++;
            deleteF(ceils, rightRow, rightCol);
        }
    }
    cout << quanQ << ' ' << quanF;
    return 0;
}