from collections import deque

n, m = map(int, input().split())

graph = {i: [] for i in range(n)}

for i in range(m):
    u, v, c = map(int, input().split())
    graph[u - 1].append((v - 1, c))
    graph[v - 1].append((u - 1, c))

visited = [0 for i in range(n)]

visited = []  # List to keep track of visited nodes.
queue = deque()  # Initialize a queue


def bfs(visited, graph, node):
    visited.append(node)
    queue.append((node, 0))
    while queue:
        s, l = queue.popleft()
        if s == n - 1:
            return l
        for neighbour, weight in graph[s]:
            if neighbour not in visited:
                visited.append(neighbour)
                queue.append((neighbour, l + 1))


# Driver Code
length = bfs(visited, graph, 0)

tr = 0
shrt = n
stck = []


def dfs(cur, r, mn, mx, visited, stack):
    if r > length:
        return
    # print("-" * r, cur)
    if cur == n - 1:
        global tr, shrt, stck
        if shrt > r or (shrt == r and mx - mn > tr):
            tr = mx - mn
            shrt = r
            stck = stack
    else:
        for i, j in graph[cur]:
            if i not in visited:
                dfs(i, r + 1, min(mn, j), max(mx, j), visited.union({i}), stack + [i + 1])


dfs(0, 0, 1e10, -1, set(), [1])
print(len(stck) - 1)
print(*stck)

"""
6 8
1 5 2
5 2 5 
3 5 4
1 3 10
3 4 6
4 5 7
4 6 8
2 6 1
"""
