#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

ll v[21][21];

string check() {
    int mxc = 0, mnc = 0, pc = 0;
    for (int it = -9; it <= 9; ++it) {
        for (int jt = -9; jt <= 9; ++jt) {
            int i = it + 10;
            int j = jt + 10;
            if (v[i][j] > v[i - 1][j] && v[i][j] > v[i + 1][j] && v[i][j] > v[i][j - 1] && v[i][j] > v[i][j + 1]) {
                ++mxc;
            }
            if (v[i][j] < v[i - 1][j] && v[i][j] < v[i + 1][j] && v[i][j] < v[i][j - 1] && v[i][j] < v[i][j + 1]) {
                ++mnc;
            }
            if (v[i][j] == v[i - 1][j] && v[i][j] == v[i + 1][j] && v[i][j] == v[i][j - 1] && v[i][j] == v[i][j + 1]) {
                ++pc;
            }
        }
    }
    for (int it = -9; it <= 9; ++it) {
        int i = it + 10;
        int j = 20;
        if (v[i][j] == v[i - 1][j] && v[i][j] == v[i + 1][j] && v[i][j] == v[i][j - 1]) {
            ++pc;
        }
        j = 0;
        if (v[i][j] == v[i - 1][j] && v[i][j] == v[i + 1][j] && v[i][j] == v[i][j + 1]) {
            ++pc;
        }
        j = it + 10;
        i = 20;
        if (v[i][j] == v[i][j - 1] && v[i][j] == v[i][j + 1] && v[i][j] == v[i - 1][j]) {
            ++pc;
        }
        i = 0;
        if (v[i][j] == v[i][j - 1] && v[i][j] == v[i][j + 1] && v[i][j] == v[i + 1][j]) {
            ++pc;
        }
    }
    if (v[20][20] == v[19][20] && v[20][20] == v[20][19]) {
        ++pc;
    }
    if (v[0][20] == v[1][20] && v[0][20] == v[0][19]) {
        ++pc;
    }
    if (v[20][0] == v[19][0] && v[20][0] == v[20][1]) {
        ++pc;
    }
    if (v[0][0] == v[1][0] && v[0][0] == v[0][1]) {
        ++pc;
    }
    string ans = "";
    if (mxc >= 2) {
        ans += "Yes; ";
    } else {
        ans += "No; ";
    }
    if (mnc >= 2) {
        ans += "Yes; ";
    } else {
        ans += "No; ";
    }
    if (pc >= 1) {
        ans += "Yes; ";
    } else {
        ans += "No; ";
    }
    return ans;
}

ll llpow(ll v, ll p) {
    ll ans = 1;
    for (int i = 0; i < p; ++i) {
        ans *= v;
    }
    return ans;
}

ll f(ll a, ll b, ll c, ll d, ll p, ll q, ll x, ll y) {
    return x * x - x;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    unordered_set<string> vs;
    unordered_map<string, vector<ll>> params;
    for (ll a = -9; a <= 9; ++a) {
        for (ll b = -9; b <= 9; ++b) {
            for (ll c = -9; c <= 9; ++c) {
                for (ll d = -9; d <= 9; ++d) {
                    for (ll p = -9; p <= -9; ++p) {
                        for (ll q = -9; q <= -9; ++q) {
                            for (ll x = -10; x <= 10; ++x) {
                                for (ll y = -10; y <= 10; ++y) {
                                    v[x + 10][y + 10] = f(a, b, c, d, p, q, x, y);
                                }
                            }
                            string ans = check();
                            if (vs.find(ans) == vs.end()) {
                                vs.insert(ans);
                                cout << ans << '\n' << a << ' ' << b << ' ' << c << ' ' << d << ' ' << p << ' ' << q << '\n';
                            }
                        }
                    }
                }
            }
        }
    }
}
