#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>
#include <unordered_map>

using namespace std;

typedef long long ll;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    vector<vector<pair<string, int>>> lines(t);
    int sl = 0;
    for (int i = 0; i < t; ++i) {
        int l;
        cin >> l;
        sl += l;
        lines[i].resize(l);
        for (int j = 0; j < l; ++j) {
            string s;
            cin >> s;
            auto ep = s.find('=');
            string var = s.substr(0, ep);
            int val = stoi(s.substr(ep + 1, s.size()));
            lines[i][j] = make_pair(var, val);
        }
    }
    unordered_map<string, int> vv;
    unordered_map<string, bool> vc;
    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        string var;
        int val;
        cin >> var;
        cin >> val;
        vv[var] = val;
        vc[var] = 0;
    }
    vector<int> cl(t);
    for (int i = 0; i < t; ++i) {
        cl[i] = int(lines[i].size()) - 1;
    }
    vector<int> ans(sl, -1);
    for (int i = 0; i < sl; ++i) {
        for (int j = 0; j < t; ++j) {
            if (cl[j] == -1) {
                continue;
            }
            string var = lines[j][cl[j]].first;
            int val = lines[j][cl[j]].second;
            if (vc[var] || vv[var] == val) {
                ans[i] = j;
                --cl[j];
                vc[var] = true;
                break;
            }
        }
        if (ans[i] == -1) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    reverse(ans.begin(), ans.end());
    for (auto &x: ans) {
        cout << x + 1 << ' ';
    }
}
