#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <iterator>
#include <fstream>
#include <math.h>

#include <vector>
#include <string>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <list>
#include <bitset>
#include <unordered_set>
#include <unordered_map>

#include <random>
#include <ctime>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;
typedef long double ld;

#define FOR(i, from, to) for (int i = from; i < to; i++)
#define ROF(i, from, to) for (int i = from; i > to; i--)

const double PI = 3.141592653589793238463;
const int INF = 0x3f3f3f3f;
const int INFS = 1000000001;
const ll LLINF = 9223372036854775807;
const ll M = 998244353;
const double EPS = 1e-8;

typedef long long int lli;

#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int> > > g(n);
    int t1, t2, w;
    FOR(i, 0, m) {
        cin >> t1 >> t2 >> w;
        --t1; --t2;
        g[t1].push_back({ t2, w });
        g[t2].push_back({ t1, w });
    }
    queue<int> q = {};
    vector<int> d0(n, -1);
    d0[0] = 0;
    vector<int> dmn(n, 10000000000), dmx(n, -1), d(n, -1);
    vector<int> p(n, -1);
    d[0] = -2;
    p[0] = 0;
    for (auto u : g[0]) {
        dmn[u.first] = u.second;
        dmx[u.first] = u.second;
        d[u.first] = 0;
        q.push(u.first);
        p[u.first] = 0;
        d0[u.first] = 1;
    }
    int v, tmp;
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (d0[u.first] == -1) {
                d0[u.first] = d0[v] + 1;
                q.push(u.first);
                if (u.second < dmn[v]) {
                    dmn[u.first] = u.second;
                } else {
                    dmn[u.first] = dmn[v];
                }
                if (u.second > dmx[v]) {
                    dmx[u.first] = u.second;
                } else {
                    dmx[u.first] = dmx[v];
                }
                if (u.second - dmn[v] > d[v]) {
                    d[u.first] = u.second - dmn[v];
                } else if (dmx[v] - u.second > d[v]) {
                    d[u.first] = dmx[v] - u.second;
                } else {
                    d[u.first] = d[v];
                }
                p[u.first] = v;
                continue;
            }
            if (d0[u.first] != d0[v] + 1)
                continue;
            tmp = min(dmn[v], dmn[u.first]);
            if (u.second < tmp) {
                dmn[u.first] = u.second;
            } else {
                dmn[u.first] = tmp;
            }
            tmp = max(dmx[v], dmx[u.first]);
            if (u.second > tmp) {
                dmx[u.first] = u.second;
            } else {
                dmx[u.first] = tmp;
            }
            tmp = max(d[v], d[u.first]);
            if (u.second - dmn[v] > tmp) {
                d[u.first] = u.second - dmn[v];
                p[u.first] = v;
            } else if (dmx[v] - u.second > tmp) {
                d[u.first] = dmx[v] - u.second;
                p[u.first] = v;
            } else if (d[v] > d[u.first]) {
                d[u.first] = d[v];
                p[u.first] = v;
            }
        }
    }
    cout << d0[n - 1] << "\n";
    vector<int> path = {};
    for (int i = n - 1; p[i] != i; i = p[i]) {
        path.push_back(i);
    }
    path.push_back(0);
    reverse(path.begin(), path.end());
    for (auto x : path) {
        cout << (x + 1) << ' ';
    }
    cout << "\n";

    return 0;
}
