#include <bits/stdc++.h>

using namespace std;

vector<vector<bool>> used, black;

int last_x = 0, last_y = 0;
int n, m;

pair<int, int> find_p() {
    while (true) {
        if (last_x == m) {
            last_x = 0;
            ++last_y;
        }
        if (last_y == n) {
            return {-1, -1};
        }

        bool is_black = black[last_y][last_x];
        if (!is_black) {
            ++last_x;
            continue;
        }

        bool is_used = used[last_y][last_x];
        if (is_used) {
            ++last_x;
            continue;
        }

        return {last_x++, last_y};
    }
}

vector<int> dxq = {0, 1, 2, 0, 2, 0, 1, 2, 2, 2};
vector<int> dyq = {0, 0, 0, 1, 1, 2, 2, 2, 3, 4};

vector<int> dxf = {0, 1, 2, 0, 0, 1, 0, 0};
vector<int> dyf = {0, 0, 0, 1, 2, 2, 3, 4};

bool is_letter(int x, int y, const vector<int> &dxs, const vector<int> &dys) {
    for (int i = 0; i < dxs.size(); ++i) {
        int dx = dxs[i];
        int dy = dys[i];

        if (x + dx >= m) return false;
        if (y + dy >= n) return false;

        if (!black[y + dy][x + dx] || used[y + dy][x + dx]) return false;
    }

    for (int i = 0; i < dxs.size(); ++i) {
        int dx = dxs[i];
        int dy = dys[i];
        used[y + dy][x + dx] = true;
    }

    return true;
}

bool is_q(int x, int y) {
    return is_letter(x, y, dxq, dyq);
}

bool is_f(int x, int y) {
    return is_letter(x, y, dxf, dyf);
}

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    used.resize(n, vector<bool>(m));
    black.resize(n, vector<bool>(m));
    char c;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> c;
            black[i][j] = c == '#';
        }
//        cin >> c;
    }


    int q_cnt = 0, f_cnt = 0;
    while (true) {
        auto [x, y] = find_p();
        if (x == -1) break;
        if (is_f(x, y)) {
            ++f_cnt;
        }
        else if (is_q(x, y)) {
            ++q_cnt;
        }
    }

    cout << q_cnt << " " << f_cnt;

    return 0;
}
