#include <bits/stdc++.h>

using namespace std;

struct wb {
    int w, b;
};

void solution() {
    int n;
    cin >> n;
    deque<int> leafs;
    stack<int> not_leafs_b, not_leafs_w;
    vector<wb> nodes;
    vector<pair<pair<int, int>, bool>> gr;

    int sum_n = 0;
    for (int i = 0; i < n; ++i) {
        int w, b;
        cin >> w >> b;
        nodes.push_back({w, b});
        sum_n += w;
        sum_n += b;
        if (w + b == 1) {
            leafs.push_back(i);
        }
        else {
            if (w != 0) {
                not_leafs_w.push(i);
            }
            if (b != 0) {
                not_leafs_b.push(i);
            }
        }
    }

    if (sum_n != (n - 1) * 2) {
        cout << "No\n";
        return;
    }

    while (!leafs.empty()) {
        auto leaf = leafs.front();
        leafs.pop_front();

        while (!not_leafs_w.empty()) {
            auto top = not_leafs_w.top();
            if (top == leaf || nodes[top].w == 0 || nodes[top].w + nodes[top].b == 1) {
                not_leafs_w.pop();
                continue;
            }
            break;
        }

        while (!not_leafs_b.empty()) {
            auto top = not_leafs_b.top();
            if (top == leaf || nodes[top].b == 0 || nodes[top].w + nodes[top].b == 1) {
                not_leafs_b.pop();
                continue;
            }
            break;
        }

        if (leafs.size() == 1 && not_leafs_w.empty() && not_leafs_b.empty()) {
            auto s = leafs.front();

            if (nodes[leaf].w != 0 && nodes[s].w != 0) {
                gr.push_back({{leaf, s}, true});
                nodes[leaf].w = 0;
                nodes[s].w = 0;
                break;
            }
            else if (nodes[leaf].b != 0 && nodes[s].b != 0) {
                gr.push_back({{leaf, s}, false});
                nodes[leaf].b = 0;
                nodes[s].b = 0;
                break;
            }
            else {
                cout << "No\n";
                return;
            }
        }

        auto [w, b] = nodes[leaf];
        assert(w + b == 1);
        nodes[leaf].w = 0;
        nodes[leaf].b = 0;

        int ind;
        if (w == 0) {
            if (not_leafs_b.empty()) {
                cout << "No\n";
                return;
            }
            ind = not_leafs_b.top();
            --nodes[ind].b;
            gr.push_back({{leaf, ind}, false});
        }
        else {
            if (not_leafs_w.empty()) {
                cout << "No\n";
                return;
            }
            ind = not_leafs_w.top();
            --nodes[ind].w;
            gr.push_back({{leaf, ind}, true});
        }

        if (nodes[ind].w + nodes[ind].b == 1) {
            leafs.push_back(ind);
        }
    }

    for (auto node : nodes) {
        if (node.b != 0 || node.w != 0) {
            cout << "No\n";
            return;
        }
    }

    cout << "Yes\n";
    for (auto [e, is_w] : gr) {
        cout << e.first + 1 << " " << e.second + 1<< " " << (is_w ? "W" : "B") << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;
    for (int tt = 0; tt < t; ++tt) {
       solution();
    }

    return 0;
}
