#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <complex>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <cstdio>

#define ll long long
#define ld long double
#define pll pair<ll,ll>
#define pii pair<ll,ll>
#define X first
#define Y second
#define int ll

using namespace std;

int gcd(int a, int b) {
    if (a < b)
        swap(a,b);
    while (b) {
        a %= b;
        swap(a,b);
    }
    return a;
}

int phi (int n, int fixed) {
    int result = fixed;
    for (int i = 2; i * i <= n; i++) {
        if (n % i == 0) {
            while (n % i == 0) {
                n /= i;
            }
            result -= result/i;
        }
    }
    if (n > 1) {
        result -= result/n;
    }
    return result;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        int l = 0;
        int startval = phi(n, n);
        int r = n;
        while (l + 1 < r) {
            int m = (l + r)/2;
            if (phi(n, m) < (startval)/2) {
                l = m;
            } else {
                r = m;
            }
        }
        cout << r << endl;
    }
}