#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <complex>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <cstdio>

#define ll long long
#define ld long double
#define pll pair<ll,ll>
#define pii pair<ll,ll>
#define X first
#define Y second
#define int ll

using namespace std;

vector<int> raz;

int gcd(int a, int b) {
    if (a < b)
        swap(a,b);
    while (b) {
        a %= b;
        swap(a,b);
    }
    return a;
}

int phi (int fixed) {
    int result = fixed;
    for (long long i : raz) {
        result -= result/i;
    }
    return result;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        raz.clear();
        int cn = n;
        for (int i = 2; i * i <= n; i++) {
            if (cn % i == 0) {
                raz.push_back(i);
                while (cn % i == 0) {
                    cn /= i;
                }
            }
        }
        if (cn != 1) {
            raz.push_back(cn);
        }
        int l = 0;
        int startval = phi(n);
        int r = n + 2;
        while (l + 1 < r) {
            int m = (l + r)/2;
            if (phi(m) < (startval + 1)/2) {
                l = m;
            } else {
                r = m;
            }
        }
        cout << r << endl;
    }
}