#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, m, v, u, c, INF = 2'000'000'000;
    cin >> n >> m;
    vector<pair<int, int>> edges[n];
    for (int i = 0; i < m; ++i) {
        cin >> v >> u >> c;
        edges[v - 1].push_back(make_pair(u - 1, c));
        edges[u - 1].push_back(make_pair(v - 1, c));
    }

    queue<pair<pair<int, pair<int, int>>, pair<int, int>>> que; // v, ind_par, length, c_min, c_max
    que.push(make_pair(make_pair(0, make_pair(-1, 0)), make_pair(INF, -1)));
    vector<pair<int, int>> ind_par; // now_par, ind_par_par
    int now_ind = 0;
    vector<bool> used(n, false);

    int max_c = -1, mcip = -1, max_length = INF;
    while (!que.empty()) {
        auto el = que.front();
        que.pop();
        v = el.first.first;
        used[v] = true;
        if (el.first.second.second > max_length) {
            break;
        }

        for (auto edge : edges[v]) {
            u = edge.first, c = edge.second;
            if (!used[u] && el.first.second.second < max_length) {
                que.push(make_pair(make_pair(u, make_pair(now_ind, el.first.second.second + 1)), make_pair(min(el.second.first, c), max(el.second.second, c))));
                ind_par.push_back(make_pair(v, el.first.second.first));
                now_ind += 1;
            }
        }

        if (v + 1 == n && el.second.second - el.second.first > max_c && el.first.second.second <= max_length) {
            max_length = el.first.second.second;
            max_c = el.second.second - el.second.first;
            mcip = el.first.second.first;
        }
    }

    vector<int> ans;
    ans.push_back(n - 1);
    while (mcip != -1) {
        ans.push_back(ind_par[mcip].first);
        mcip = ind_par[mcip].second;
    }
    reverse(ans.begin(), ans.end());

    cout << ans.size() - 1 << endl;
    for (int el : ans) {
        cout << el + 1 << ' ';
    }
    return 0;
}
