#include<iostream>
#include<vector>
#include <algorithm>

using namespace std;
//TODO K
struct Edge {
    int from;
    int to;
    int w;
};
vector<vector<Edge>> gr;
vector<vector<int>> d;
vector<vector<int>> mn;
vector<vector<int>> mx;
vector<vector<vector<int>>> parent;
void bfs(bool is_end) {
    vector<int> q;
    q.push_back(is_end ? gr.size()-1 : 0);
    int start = 0;
    d[is_end][q[0]] = 0;
    while (start < q.size()) {
        int v = q[start];
        start++;

        for (auto i: gr[v]) {
            if (d[is_end][i.to] > d[is_end][v] + 1) {
                q.push_back(i.to);
                d[is_end][i.to] = d[is_end][v] + 1;
                mn[is_end][i.to] = min(i.w, mn[is_end][v]);
                mx[is_end][i.to] = max(i.w, mx[is_end][v]);
                parent[is_end][0][i.to] = v;
                parent[is_end][1][i.to] = v;
            }
            if ((d[is_end][i.to] == d[is_end][v] + 1 and mx[is_end][i.to] < max(mx[is_end][v], i.w)) or
                (d[is_end][i.to] == d[is_end][v] + 1 and mn[is_end][i.to] > max(mn[is_end][v], i.w))) {
                int prevmin = mn[is_end][i.to];
                int prevmax = mx[is_end][i.to];
                mn[is_end][i.to] = min(i.w, min(mn[is_end][i.to], mn[is_end][v]));
                mx[is_end][i.to] = max(i.w, max(mx[is_end][i.to], mx[is_end][v]));
                if(prevmin != mn[is_end][i.to]) parent[is_end][0][i.to] = v;
                if(prevmax != mx[is_end][i.to])parent[is_end][1][i.to] = v;
            }
        }
    }
}



signed main() {
    int n, m;
    cin >> n>>m;
    gr.resize(n);
    d.resize(2, vector<int>(n, 1e9));
    mn.resize(2, vector<int>(n, 1e9));
    mx.resize(2, vector<int>(n, -1e9));
    parent.resize(2, vector<vector<int>>(2, vector<int>(n, -1)));
    for(int i = 0; i < m; i++){
        int fr, to, w;
        cin>>fr>>to>>w;
        gr[fr-1].push_back({fr-1, to-1, w});
        gr[to-1].push_back({to-1, fr-1, w});
    }
    bfs(true);
    bfs(false);
    if(d[0][n-1] == 1){
        cout<<1<<endl<<1<<" "<<n;
        return 0;
    }
    int myans = -1e9;
    int id = 0;
    bool govno = false;
    for(int i = 0; i < n; i++){
        //cout<<mx[0][i]<<" "<<mn[0][i]<<" "<<d[0][i]<<endl;
        if(d[0][i] + d[1][i] == d[0][n-1]){
            if(mx[0][i] - mn[1][i] > myans){
                myans = mx[0][i] - mn[1][i];
                id = i;
                govno = true;
            }
            if(mx[1][i] - mn[0][i] > myans){
                govno=false;
                id = i;
                myans = mx[1][i] - mn[0][i];
            }
        }
    }
    vector<int> ans;
    if(govno){
        int cur = id;
        while(cur != 0){
            ans.push_back(cur+1);
            cur = parent[0][1][cur];
        }
        ans.push_back(cur+1);
        reverse(ans.begin(), ans.end());
        cur = id;
        while(cur != n-1){
            cur = parent[1][0][cur];
            ans.push_back(cur+1);
        }
    }else{
        int cur = id;
        while(cur != 0){
            ans.push_back(cur+1);
            cur = parent[0][0][cur];
        }
        ans.push_back(cur+1);
        reverse(ans.begin(), ans.end());
        cur = id;
        while(cur != n-1){
            cur = parent[1][1][cur];
            ans.push_back(cur+1);

        }
    }
    cout<<ans.size()-1<<endl;
    for(auto i : ans){
        cout<<i<<" ";
    }

}