#include <bits/stdc++.h>

using namespace std;

#define int long long



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g (n);
    for (int i = 0; i < m; ++i) {
        int v, u, x;
        cin >> v >> u >> x;
        --v, --u;

        g[v].push_back({u, x});
        g[u].push_back({v, x});
    }

    vector<int> dist (n, -1);
    queue<int> q;
    q.push(0);
    dist[0] = 0;
    vector<int> order;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        order.push_back(v);

        for (auto [u, x]: g[v]) {
            if (dist[u] == -1) {
                q.push(u);
                dist[u] = dist[v] + 1;
            }
        }
    }

    vector<pair<pair<int, int>, pair<int, int>>> dp (n, {{INT_MAX, 0}, {INT_MAX, 0}});
    vector<pair<pair<int, int>, pair<int, int>>> p (n);
    for (auto v: order) {
        for (auto [u, x]: g[v]) {
            if (dist[u] == dist[v] - 1) {
                if (dp[v].first.first > min(dp[u].first.first, x)) {
                    dp[v].first.first = min(dp[u].first.first, x);
                    p[v].first.first = u;
                }
                if (dp[v].first.second < max(dp[u].first.second, x)) {
                    dp[v].first.second = max(dp[u].first.second, x);
                    p[v].first.second = u;
                }
            }
        }
    }

    reverse(order.begin(), order.end());
    for (auto v: order) {
        for (auto [u, x]: g[v]) {
            if (dist[u] == dist[v] + 1) {
                if (dp[v].second.first > min(dp[u].second.first, x)) {
                    dp[v].second.first = min(dp[u].second.first, x);
                    p[v].second.first = u;
                }
                if (dp[v].second.second < max(dp[u].second.second, x)) {
                    dp[v].second.second = max(dp[u].second.second, x);
                    p[v].second.second = u;
                }
            }
        }
    }

    int res = 0;
    int v = -1;
    for (int i = 0; i < n; ++i) {
        if (dist[i] > 0 && dist[i] < dist[n-1]) {
            if (res < max(dp[i].second.second - dp[i].first.first, dp[i].first.second - dp[i].second.first)) {
                res = max(dp[i].second.second - dp[i].first.first, dp[i].first.second - dp[i].second.first);
                v = i;
            }
        }
    }

    if (dist[n - 1] == 1) {
        cout << 1 << endl;
        cout << 1 << " " << n;
    } else {
        cout << dist[n-1] << endl;
        if (dp[v].second.second - dp[v].first.first > dp[v].first.second - dp[v].second.first) {
            stack<int> path;
            int u = v;
            while (u != 0) {
                path.push(u);
                u = p[u].first.first;
            }
            cout << 1 << " ";
            while (path.size() > 1) {
                cout << path.top() + 1 << " ";
                path.pop();
            }
            u = v;
            while (u != n-1) {
                cout << u + 1 << " ";
                u = p[u].second.second;
            }
            cout << n;
        } else {
            stack<int> path;
            int u = v;
            while (u != 0) {
                path.push(u);
                u = p[u].first.second;
            }
            cout << 1 << " ";
            while (path.size() > 1) {
                cout << path.top() + 1 << " ";
                path.pop();
            }
            u = v;
            while (u != n-1) {
                cout << u + 1 << " ";
                u = p[u].second.first;
            }
            cout << n;
        }
    }

    return 0;
}