#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <cfenv>
#include <queue>
#include <math.h>
#include <vector>
#include <string>
#include <random>
#include <numeric>
#include <iomanip>
#include <cassert>
#include <complex>
#include <iostream>
#include <iterator>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double db;
typedef complex <db> cmpl;
typedef pair <int, int> pii;

const ll MOD1 = 998244353;
const ll MOD2 = (int)1e9 + 7;
const db EPS = 1e-7;
const int INF = (int)1e9 + 7;

const int N = (int)51;

ll n, m, c;
ll r, M, C;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%lld%lld%lld", &n, &m, &c);
    r = n;
    for (ll M1 = 0; M1 <= (ll)2e6; ++M1) {
        if (m * M1 > n) {
            ll cur_r = m * M1 - n;
            if (cur_r < r) {
                r = cur_r;
                M = M1;
                C = 0;
            }
            break;
        }
        ll cur_r = n - M1 * m;
        ll C1 = cur_r / c;
        cur_r -= C1 * c;
        if (cur_r < c - cur_r) {
            if (cur_r < r) {
                r = cur_r;
                C = C1;
                M = M1;
            }
        } else {
            if (c - cur_r < r) {
                r = c - cur_r;
                C = C1;
                M = M1;
            }
        }
    }
    printf("%lld %lld", M, C);
    return 0;
}
