#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <cfenv>
#include <queue>
#include <math.h>
#include <vector>
#include <string>
#include <random>
#include <numeric>
#include <iomanip>
#include <cassert>
#include <complex>
#include <iostream>
#include <iterator>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double db;
typedef complex <db> cmpl;
typedef pair <int, int> pii;

const ll MOD1 = 998244353;
const ll MOD2 = (int)1e9 + 7;
const db EPS = 1e-7;
const int INF = (int)1e9 + 7;

const int N = (int)1e2;
const int K = (int)1e4;

int t, l, value, k, rest_comm_cnt;
vector <pair <ll, int>> a[N];
string s;
int final_value[K];
bool ignored[K];
vector <int> ans;
ll name;
vector <ll> names;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    iostream::sync_with_stdio(0);
    cin >> t;
    for (int i = 0; i < t; ++i) {
        cin >> l;
        rest_comm_cnt += l;
        a[i].resize(l);
        for (int j = 0; j < l; ++j) {
            cin >> s;
            name = 0;
            int it = 0;
            for (; s[it] != '='; ++it) {
                name *= 26;
                name += s[it] - 'a';
            }
            names.push_back(name);
            ++it;
            value = 0;
            for (; it < s.size(); ++it) {
                value *= 10;
                value += s[it] - '0';
            }
            a[i][j] = { name, value };
        }
    }
    sort(names.begin(), names.end());
    names.resize(unique(names.begin(), names.end()) - names.begin());
    for (int i = 0; i < t; ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            a[i][j].first = lower_bound(names.begin(), names.end(), a[i][j].first) - names.begin();
        }
    }
    scanf("%d", &k);
    for (int i = 0; i < k; ++i) {
        cin >> s >> value;
        name = 0;
        for (int it = 0; it < s.size(); ++it) {
            name *= 26;
            name += s[it] - 'a';
        }
        name = lower_bound(names.begin(), names.end(), name) - names.begin();
        final_value[name] = value;
    }
    while (rest_comm_cnt) {
        int delta = 0;
        for (int i = 0; i < t; ++i) {
            while (a[i].size()) {
                if (ignored[a[i].back().first]) {
                    ans.push_back(i + 1);
                    a[i].pop_back();
                    ++delta;
                } else if (final_value[a[i].back().first] != a[i].back().second) {
                    break;
                } else {
                    ans.push_back(i + 1);
                    ignored[a[i].back().first] = true;
                    a[i].pop_back();
                    ++delta;
                }
            }
        }
        if (!delta) {
            break;
        }
        rest_comm_cnt -= delta;
    }
    if (rest_comm_cnt) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    reverse(ans.begin(), ans.end());
    for (int val : ans) {
        cout << val << " ";
    }
    return 0;
}
