#include <bits/stdc++.h>
using namespace std;
int n, m;
 
vector<pair<int, int>> F = {{0, 0}, {-1, 0}, {-2, 0}, {-3, 0}, {-4, 0}, {-2, 1}, {-4, 1}, {-4, 2}};
vector<pair<int, int>> Q = {{0, 0}, {-1, 0}, {-2, 0}, {-3, 0}, {-4, 0}, {-4, -1}, {-4, -2}, {-3, -2}, {-2, -2}, {-2, -1}};
 
vector<vector<bool>> rest;
 
void restr(vector<pair<int, int>>& letter, int i, int j){
 
    for(auto at: letter){
        rest[i + at.first][j + at.second]  = true;
    }
}
 
bool comp(vector<pair<int, int>>& letter, int i, int j, vector<vector<char>>& field){
 
    for(auto at: letter){
        if((field[i + at.first][j + at.second] != '#') || rest[i + at.first][j + at.second]){
            // cerr << at.first << ' ' << at.second << endl;
            return false;
        }
    }
    return true;
}
 
void solve(){
 
    cin >> n >> m;
    vector<vector<char>> field(n, vector<char>(m));
    rest.resize(n, vector<bool>(m, false));
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> field[i][j];
        }
    }
 
    int q = 0;
    int f = 0;
 
    for(int i = n - 1; i >= 4; i--){
        for(int j = m - 1; j >= 0; j--){
 
            if(j <= m - 3 && comp(F, i, j, field)){
                // cerr << "F found " << i << ' ' << j << endl;
                if (field[i - 3][j + 1] == '.') {
                    f++;
                    restr(F, i, j);
                    continue;
                }
            }
 
            if(j >= 2 && comp(Q, i, j, field)){
                // cerr << "Q found " << i << ' ' << j << endl;
                q++;
                restr(Q, i, j);
            }
        }
    }
 
    cout << q << ' ' << f << endl;
 
}
 
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // #ifndef DLOCAL
    //  freopen("","r",stdin);
    //  freopen("","w",stdout);
    // #endif
    solve();
    return 0;
}