#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <tuple>
using namespace std;

typedef long long lint;
#define For(i, n) for (int i = 0; i < (n); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) (int)((v).size())

const int MAXN = 100500;
int ar[MAXN];
double psum1[MAXN];
double psum2[MAXN];

void solve()
{
    int n, L, V;
    cin >> n >> L >> V;
    For(i, n)
    {
        cin >> ar[i];
        psum1[i + 1] = psum1[i] + (double)L / ((double)ar[i] + V);
        psum2[i + 1] = psum2[i] + (double)ar[i] / ((double)ar[i] + V);
    }
    double psum3 = 0;
    double res = 1e18;
    for (int i = n; i >= 0; --i)
    {
        if (i < n)
            psum3 += (double)L / ar[i];
        double t = i == n ? 0 : (double)L / ar[i];
        double cur = (psum3 + t * i + (psum1[i] - psum2[i] * t) * 2.0) / n;
        res = min(res, cur);
    }
    cout << fixed << setprecision(12);
    cout << res << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
#ifdef LOCAL
    printf("\n\n%.3f s", (double)clock() / CLOCKS_PER_SEC);
#endif
    return 0;
}
