#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <tuple>
using namespace std;

typedef long long lint;
#define For(i, n) for (int i = 0; i < (n); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) (int)((v).size())

vector<pair<string, int>> ar[100];
map<string, int> br;

void solve()
{
    int n;
    cin >> n;
    For(i, n)
    {
        int m;
        cin >> m;
        ar[i].resize(m);
        For(j, m)
        {
            cin >> ar[i][j].first;
            int m = 1;
            while ('0' <= ar[i][j].first.back() && ar[i][j].first.back() <= '9')
            {
                ar[i][j].second += m * (ar[i][j].first.back() - '0');
                ar[i][j].first.pop_back();
                m *= 10;
            }
            ar[i][j].first.pop_back();
        }
    }
    int m;
    cin >> m;
    For(i, m)
    {
        string a;
        int b;
        cin >> a >> b;
        br[a] = b;
    }
    vector<int> ans;
    while (true)
    {
        bool succ = false;
        For(i, n) while (!ar[i].empty())
        {
#ifdef LOCAL
            if (succ)
                break;
#endif
            auto it = br.find(ar[i].back().first);
            if (it == br.end())
            {
                ans.push_back(i);
                ar[i].pop_back();
#ifdef LOCAL
                succ = true;
#endif
            }
            else if (it->second == ar[i].back().second)
            {
                ans.push_back(i);
                ar[i].pop_back();
                succ = true;
                br.erase(it);
            }
            else
                break;
        }
        if (succ)
            continue;
        For(i, n)
            if (!ar[i].empty())
                succ = true;
        if (!succ)
            break;
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    reverse(all(ans));
    For(i, sz(ans))
        cout << ans[i] + 1 << (i + 1 == sz(ans) ? '\n' : ' ');
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
#ifdef LOCAL
    printf("\n\n%.3f s", (double)clock() / CLOCKS_PER_SEC);
#endif
    return 0;
}
