#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <stack>
#include <map>
using namespace std;
using ll = long long;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    vector<stack<pair<string,string>>> v;
    v.resize(t);
    for(int i(0); i < t; i++)
    {
        ll n;
        cin >> n;
        for(int j(0); j < n; j++)
        {
            string s;
            cin >> s;

            string s1 = s.substr(0, find(s.begin(), s.end(), '=')- s.begin());
            string s2 = s.substr(s1.size()+1, s.size()-1);
            v[i].push({s1,s2});
        }
    }
    int num;
    cin >> num;
    map< string ,pair<string,int>> mp;
    for(int i(0); i < num; i++)
    {
        string s1,s2;
        cin >> s1 >> s2;
        mp[s1] = {s2,0};
    }
    vector<int> otv;
    int b = true;
    while(b)
    {
        b = !b;
        for(int i(0); i < t; i++)
        {
            while(v[i].size() != 0)
            {
                pair<string,int> &pr = mp[v[i].top().first];
                if(pr.second == 1 || pr.first == v[i].top().second)
                {
                    v[i].pop();
                    otv.push_back(i+1);
                    pr.second = 1;
                    b = true;
                }
                else
                {
                    break;
                }
            }
        }
    }
    if(otv.size() == 0)
    {
        cout << "No\n";
        return  0;
    }
    cout << "Yes\n";
    for(int i(otv.size()-1); i >= 0; i--)
    {
        cout << otv[i] << " ";
    }
    cout << "\n";
    return 0;
}

