#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

struct Distance {
    int distance;
    int m, c;
};

int main() {
    int n, m, c;
    cin >> n >> m >> c;

    vector<Distance> distance;
    int M_max = n / m + 1;
    for (int cur_m = 0; cur_m < M_max; cur_m++) {
        int cur_n = n - m * cur_m;
        int cur_c = cur_n / c;
        distance.push_back({ m * cur_m + c * cur_c, cur_m, cur_c });
        distance.push_back({ m * cur_m + c * (cur_c + 1), cur_m, cur_c + 1 });
    }

    for (auto& element : distance)
        element.distance = abs(n - element.distance);

    Distance result = distance[0];
    for (const auto& element : distance)
        if (element.distance < result.distance)
            result = element;

    cout << result.m << ' ' << result.c << std::endl;

    return 0;
}