#import sys
#sys.stdin = open('input.txt')

n, m = map(int, input().split())
pole = []
for i in range(n):
    pole.append(list(input()))
q, f = 0, 0


def print_pole():
    for i in pole:
        for j in i:
            print(j, end='')
        print()


def delete_letter(i, j):
    if i + 5 >= n and j + 3 >= n:
        print(q, f) # stop, this is not valid
        exit()
    for y in range(5):
        for x in range(3):
            pole[i + y][j + x] = 'Q'


def process_letter(i, j):
    global q, f
    if pole[i+1][j+1] == '#':
        delete_letter(i, j) # this should never be
    if pole[i + 1][j + 2] == '#':
        q += 1
        delete_letter(i, j)
    else:
        f += 1
        delete_letter(i, j)


def search():
    final = True
    for i in range(len(pole)):
        while '#' in pole[i]:
            j = pole[i].index('#')
            process_letter(i, j)
            final = False
    if final:
        print(q, f)
        exit()


while True:
    search()
