package com.company;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Scanner;

public class ProblemB {

    public static void main(String[] args) throws IOException {

        int m = 0, c = 0, n = 0;
        Scanner in = new Scanner(System.in);

        n = in.nextInt();
        if(n < 169){
            System.out.println("0 0");
            System.exit(0);
        }

        m = in.nextInt();
        c = in.nextInt();

        int minDelta = Integer.MAX_VALUE;
        int previousDelta = 0;
        int mCof = 0;
        int cCof = 0;
        int maxM = Math.round((float)n / m);
        int maxN = Math.round((float)n / c);


        for(int j = maxN; j >= 0; j--){
            for(int i = maxM; i >= 0 ; i--){
                int delta = Math.abs(i*m + j*c - n);
                // System.out.println(delta+ " " + j + " "+ i+ " "+minDelta);
                if(delta < minDelta){
                    minDelta = delta;
                    mCof = i;
                    cCof = j;
                }
                else if(delta >= minDelta){
                    break;
                }
            }

        }


        System.out.println(mCof+" "+cCof);


    }


}