#include <bits/stdc++.h>
using namespace std;
 
vector<vector<pair<int,int>>> g;
vector<int> lvl;
int ans = -1;
int n;
//vector<int> curr;
//vector<int> path;

struct segment {
	int min = 1e9+1;
	int max = -1;
	int p = -1;
};

struct info {
	segment opt;
	segment min;
	segment max;
};

vector<info> segments;
 
void bfs(int v) {
    queue<int> q;
    lvl[v] = 0;
    q.push(v);
 
    while(!q.empty()) {
        v = q.front();
        q.pop();
 
        for(auto [to, dis] : g[v]) {
            if(lvl[to] == -1) {
                lvl[to] = lvl[v]+1;
                q.push(to);
            }
        }
    }
}

void updateInfo(int ind, segment& seg) {
	if(segments[ind].opt.max - segments[ind].opt.min < seg.max-seg.min) {
		segments[ind].opt = seg;
	}
	if(segments[ind].min.min > seg.min) {
		segments[ind].min = seg;
	}
	if(segments[ind].max.max < seg.max) {
		segments[ind].max = seg;
	}
}
 
void bfs2(int v) {
	queue<int> q;
	q.push(v);
	segment newseg;

	while(!q.empty()) {
		v = q.front();
		q.pop();

		for(auto [to, dis] : g[v]) {
			if(lvl[to] == lvl[v]+1) {
				newseg = segments[v].opt;
				newseg.min = min(newseg.min, dis);
				newseg.max = max(newseg.max, dis);
				newseg.p = v;
				updateInfo(to, newseg);

				newseg = segments[v].min;
				newseg.min = min(newseg.min, dis);
				newseg.max = max(newseg.max, dis);
				newseg.p = v;
				updateInfo(to, newseg);

				newseg = segments[v].max;
				newseg.min = min(newseg.min, dis);
				newseg.max = max(newseg.max, dis);
				newseg.p = v;
				updateInfo(to, newseg);

				q.push(to);
			}
		}
	}
}

void PrintInfo(int v) {
	if(v == 0) {
		cout << v+1 << ' ';
		return;
	}

	if(segments[v].opt.min == segments[segments[v].min.p].min.min) {
		PrintInfo(segments[v].opt.p);
		cout << v+1 << ' ';
		return;
	}
	if(segments[v].opt.max == segments[segments[v].max.p].max.max) {
		PrintInfo(segments[v].opt.p);
		cout << v+1 << ' ';
		return;
	}
	PrintInfo(segments[v].opt.p);
	cout << v+1 << ' ';
}
 
int main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
 
    int m;
    int l, r, c;
    cin >> n >> m;
 
    g.resize(n);
    lvl.resize(n, -1);
    segments.resize(n);
 
    while(m--) {
        cin >> l >> r >> c;
        l--; r--;
        g[l].push_back({r,c});
        g[r].push_back({l,c});
    }
 
    bfs(0);
    //curr.resize(lvl[n-1]+1);
    //path.resize(lvl[n-1]+1);
    //curr[0] = 0;
    bfs2(0);
 
    cout << lvl[n-1] << '\n';
    PrintInfo(n-1);
    cout << '\n';
}
