package com.company;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) {

        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int [] ar = new int[n-1];

        for (int i = 1; i <= n-1; i++) {
            ar[i-1] = i;
        }
        

        int median = getMedian(ar,ar.length);

        int count = 0;

        for(int i = 1 ; i <= n-1 ; i++){

            if ( getGCD(i, median) == 1) {
                count++;
            }
        }
        System.out.println(count);
    }

    public static int getMedian(int[] a, int m)
    {

        if (m % 2 == 0) {
            return a[(m / 2)-1];
        }
        return a[((m+1)/2)-1];
    }

   public static int getGCD(int a, int b)
    {
        if (a == 0 || b == 0)
            return 0;

        if (a == b)
            return a;

        if (a > b)
            return getGCD(a-b, b);

        return getGCD(a, b-a);
    }
    
}