#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <complex>
#include <unordered_set>
#include <algorithm>
#include <cstring>
#include <bitset>
#include <math.h>
#include <ctime>
using namespace std;
#define ll long long
#define sint unsigned char
#define ull unsigned long long
#define pii pair<int, int>
#define uint unsigned int
typedef complex<double> base;

const double PI = acos(-1);

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O2")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

const int MAXN = 3e5 + 100;
const int LOGN = 18;
const int MOD = (int)1e9 + 7;
void clear()
{
}
void precalc() {
	
}
void gen_tests() {
}


struct SegmentTree {
	vector<pair<int, int>> max_values;
	vector<int> deltas_values;
	int sz;
	SegmentTree(int cnt_values)  {
		sz = cnt_values;
		max_values.resize(4 * sz);
		deltas_values.resize(4 * sz);
		Initialize(0, cnt_values - 1, 0);
	}

	void Add(int l, int r, int delta) {
		Add(0, sz - 1, l, r, delta, 0);
	}

	pair<int, int> GetMax() {
		return max_values[0];
	}

private:

	void Add(int l, int r, int l1, int r1, int delta, int i) {
		if (l == l1 && r == r1) {
			deltas_values[i] += delta;
			max_values[i].first += delta;
			return;
		}
		int med = (l + r) >> 1;
		if (l1 <= med) {
			Add(l, med, l1, min(r1, med), delta, i * 2 + 1);
		}
		if (r1 > med) {
			Add(med + 1, r, max(l1, med + 1), r1, delta, i * 2 + 2);
		}
		max_values[i] = max(max_values[i * 2 + 1], max_values[i * 2 + 2]);
		max_values[i].first += deltas_values[i];
	}
	void Initialize(int l, int r, int i) {
		if (l == r) {
			max_values[i] = { 0, l };
			return;
		}
		int mid = (l + r) >> 1;
		Initialize(l, mid, i * 2 + 1);
		Initialize(mid + 1, r, i * 2 + 2);
		max_values[i] = max(max_values[i * 2 + 1], max_values[i * 2 + 2]);
	}
};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> times;
	set<int> values1;
	unordered_map<int, int> left_values, right_values;

	for (int i = 0; i < n; ++i) {
		int value;
		cin >> value;
		int day1 = value / m;
		int start = value % m;
		values1.insert(day1);
		if (left_values.count(day1) == 0) {
			left_values[day1] = start;
		}
		else {
			left_values[day1] = min(left_values[day1], start);
		}
		if (start == 0)
			continue;
		int day2 = day1 + 1;
		values1.insert(day2);
		if (right_values.count(day2) == 0) {
			right_values[day2] = start - 1;
		}
		else {
			right_values[day2] = max(right_values[day2], start - 1);
		}
	}
	int prev_value = -1;

	vector < pair<int, vector<pii>>> keks;
	set<int> pos_values;
	pos_values.insert(0);
	pos_values.insert(m - 1);
	for (auto day : values1) {
		
		vector<pii> values;
		if (right_values.count(day) == 0) {
			values.push_back({ 0, m - 1 - left_values[day] });
		}
		else if (left_values.count(day) == 0) {
			values.push_back({ m - 1 - right_values[day], m - 1 });
		}
		else {

			if (left_values[day] > right_values[day] + 1) {
				values.push_back({ m - 1 - right_values[day], m - 1 });
				values.push_back({ 0, m - 1 - left_values[day] });
			}
			else {
				values.push_back({ 0, m - 1 });
			}
		}
		for (auto u : values) {
			if (u.first != 0) {
				pos_values.insert(u.first);
			}
			if (u.second != m - 1) {
				pos_values.insert(u.second);
			}
		}
		keks.push_back({ day, values });
	}
	unordered_map<int, int> d, back_values;

	for (auto v : pos_values) {
		d[v] = d.size();
		back_values[d[v]] = v;
	}
	SegmentTree tree(pos_values.size());
	queue<vector<pii>> stack_values;
	int prev_day = -1000;
	pair<int, int> res = { -1,-1 };
	for (auto value : keks) {
		if (value.first != prev_day + 1) {
			while (stack_values.size()) {
				for (auto u : stack_values.front()) {
					tree.Add(d[u.first], d[u.second], -1);
				}
				stack_values.pop();
			}
			
		}
		prev_day = value.first;
		for (auto u : value.second) {
			tree.Add(d[u.first], d[u.second], 1);
		}
		stack_values.push(value.second);
		while (stack_values.size() > tree.GetMax().first) {
			for (auto u : stack_values.front()) {
				tree.Add(d[u.first], d[u.second], -1);
			}
			stack_values.pop();
			
		}
		res = max(pii{ stack_values.size(), tree.GetMax().second }, res);
	}
	cout << res.first << ' ' << back_values[res.second] << '\n';
}

void multisolve()
{
	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	//freopen("output.out", "w", stdout);
	precalc();
	multisolve();

	return 0;
}