#include <iostream>
#include <string>
#include <regex>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

unordered_map<string, int> mp;
vector<int>ad;
vector<int>bc;

void input(string s) {
    int res;
    stringstream ss(s);
    if(s[0] == 'A'){
        string tmp;
        ss >> tmp;
        ss >> res;
        mp["AD"]++;
        ad.push_back(res);
    }
    else {
        ss >> res;
        mp["BC"]++;
        bc.push_back(res);
    }
}


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef _DEBUG
    freopen("in.txt","r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    string s1, s2;
    getline(cin, s1);
    getline(cin, s2);
    input(s1);
    input(s2);

    sort(ad.begin(), ad.end());
    sort(bc.begin(), bc.end());

    if(mp["AD"] == 2) {
        cout << abs(ad[1] - ad[0]);
    }
    else if(mp["BC"] == 2){
        cout << abs(bc[1] - bc[0]);
    }
    else{
        cout << abs(bc[0] + ad[0]) - 1;
    }



    return 0;
}