﻿

#define _CRT_SECURE_NO_WARNINGS
#include <complex>
#include <numeric>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <regex>
#include <vector>
#include <bitset>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <set>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <string>
#include <sstream> 
#include <stack>

//#pragma comment(linker, "/STACK:256000000")                 
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;

#define debug(x)                          \
    {                                     \
        cout << #x << " = " << x << endl; \
    }
#define mod 1000000007
#define mod1 998244353
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define mp make_pair        
#define pb push_back
#define ve vector
#define PI acos(-1)
#define fastio ios_base::sync_with_stdio(false);cin.tie(NULL)
ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

ll powmod(ll a, ll x, ll p)
{
    if (x == 0) return 1;
    unsigned long res = powmod(a, x >> 1, p);
    res *= res;
    res %= p;
    return (x & 1) ? (a * res) % p : res;
}

template <typename Function>
string regex_replace(const string& s, const regex& re, Function f)
{
    string r;
    sregex_iterator t(s.begin(), s.end(), re), end;
    int last = 0;
    for (; t != end; ++t) {
        r += t->prefix().str() + f(*t);
        last = t->position() + t->length();
    }
    return r += s.substr(last);
}
template <class T>
T pollard_bent(T n, unsigned iterations_count = 19)
{
    T
        b0 = rand() % n,
        b1 = (b0 * b0 + 2) % n,
        a = b1;
    for (unsigned iteration = 0, series_len = 1; iteration < iterations_count; iteration++, series_len *= 2)
    {
        T g = gcd(b1 - b0, n);
        for (unsigned len = 0; len < series_len && (g == 1 && g == n); len++)
        {
            b1 = (b1 * b1 + 2) % n;
            g = gcd(abs(b1 - b0), n);
        }
        b0 = a;
        a = b1;
        if (g != 1 && g != n)
            return g;
    }
    return 1;
}

template <class T>
T pollard_monte_carlo(T n, unsigned m = 100)
{
    T b = rand() % (m - 2) + 2;

    static std::vector<T> primes;
    static T m_max;
    if (primes.empty())
        primes.push_back(3);
    if (m_max < m)
    {
        m_max = m;
        for (T prime = 5; prime <= m; ++++prime)
        {
            bool is_prime = true;
            for (auto iter = primes.begin(), end = primes.end();
                iter != end; ++iter)
            {
                T div = *iter;
                if (div * div > prime)
                    break;
                if (prime % div == 0)
                {
                    is_prime = false;
                    break;
                }
            }
            if (is_prime)
                primes.push_back(prime);
        }
    }

    T g = 1;
    for (size_t i = 0; i < primes.size() && g == 1; i++)
    {
        T cur = primes[i];
        while (cur <= n)
            cur *= primes[i];
        cur /= primes[i];
        b = powmod(b, cur, n);
        g = gcd(abs(b - 1), n);
        if (g == n)
            g = 1;
    }

    return g;
}
int main()
{
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    fastio;
    string s1, s2, s3;
    getline(cin, s1);
    getline(cin, s2);
    getline(cin, s3);
    //cout << s1 << endl << s2 << endl << s3 << endl;
    if (s1 == "Multiple local maxima: No" &&
        s2 == "Multiple local minima: No" &&
        s3.substr(0,s3.size()-1) == "Plateaus: No")
    {
        cout << "x 3 - 4 ^ y -5 + 2 ^ +";
    }
    else if (s1 == "Multiple local maxima: No" &&
        s2 == "Multiple local minima: No" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: Yes")
    {
        cout << "1";
    }
    else if (s1 == "Multiple local maxima: No" &&
        s2 == "Multiple local minima: Yes" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: No")
    {
        cout << "x 1 - 2 ^ x 1 + 2 ^ * - y 1 - 2 ^ y 1 + 2 ^ * -";
    }
    else if (s1 == "Multiple local maxima: No" &&
        s2 == "Multiple local minima: Yes" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: Yes")
    {
        cout << "x 1 - 2 ^ x 1 + 2 ^ * y 1 - 2 ^ y 1 + 2 ^ * +";
    }
    else if (s1 == "Multiple local maxima: Yes" &&
        s2 == "Multiple local minima: No" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: No")
    {
        cout << "x 1 - 2 ^ x 2 ^ * x 1 + 2 ^ * x 2 + 2 ^ * - y 1 - 2 ^ y 2 ^ * y 1 + 2 ^ * y 2 + 2 ^ * -";
    }
    else if (s1 == "Multiple local maxima: Yes" &&
        s2 == "Multiple local minima: No" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: Yes")
    {
        cout << "x 1 - 2 ^ x 2 ^ * x 1 + 2 ^ * x 2 + 2 ^ * y 1 - 2 ^ y 2 ^ * y 1 + 2 ^ * y 2 + 2 ^ * +";
    }
    else if (s1 == "Multiple local maxima: Yes" &&
        s2 == "Multiple local minima: Yes" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: No")
    {
        cout << "No solution";
    }
    else if (s1 == "Multiple local maxima: Yes" &&
        s2 == "Multiple local minima: Yes" &&
        s3.substr(0, s3.size() - 1) == "Plateaus: Yes")
    {
        cout << "No solution";
    }
#ifdef _DEBUG
    printf("\n\n%lf\n", clock() * 1e-3);
#endif
    return 0;
}