﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;
using System.Xml.Xsl;

namespace ACM
{
    class Program
    {
        static void Main(string[] args)
        {
            var n = int.Parse(Console.ReadLine());
            var m = int.Parse(Console.ReadLine());
            var c = int.Parse(Console.ReadLine());
            (int mCount, int cCount)[] arr = Enumerable.Repeat((-1, -1), n + 1 + c).ToArray();
            var resultPosition = 0;
            arr[resultPosition] = (0, 0);
            for (int i = 0; i < arr.Length; i++)
            {
                if (arr[i].mCount >= 0)
                {
                    var mMove = i + m;
                    if (mMove < arr.Length)
                    {
                        arr[mMove] = (mCount: arr[i].mCount + 1, cCount: arr[i].cCount);
                        if (Math.Abs(mMove - n) < Math.Abs(resultPosition - n))
                            resultPosition = mMove;
                    }
        
                    var cMove = i + c;
                    if (cMove < arr.Length)
                    {
                        arr[cMove] = (mCount: arr[i].mCount, cCount: arr[i].cCount + 1);
                        if (Math.Abs(cMove - n) < Math.Abs(resultPosition - n))
                            resultPosition = cMove;
                    }
                }
            }

            var result = arr[resultPosition];//arr.Last(x => x.mCount >= 0);
            Console.WriteLine($"{result.mCount} {result.cCount}");
        }
    }
}