#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <fstream>
#include <stdio.h>
#include <numeric>

#define all(a) (a).begin(), (a).end()
#define from(i, n) for (long long i=0; i<n;i++)

using namespace std;

typedef long long ll;
typedef long double ld;

ll Gcd(ll a, ll b) {
    if (abs(a-b)==1)
        return 1;
    if (b == 0)
        return a;
    return Gcd(b, a % b);
}
bool isPrime(ll x) {
    if (x<2)
        return false;
    for (ll i=2;i*i<=x;i++)
        if (x%i==0)
            return false;
    return true;
}
void Solve() {
    ll test;
    cin >> test;
    while (test--) {
        vector <ll> v{1};
        ll n;
        cin >> n;
        if (n==2) {
            cout << 1 << endl;
            continue;
        }
        if (isPrime(n)) {
            cout << (n-1)/2 << endl;
            continue;
        }
        if (n%2==0) {
            for (ll i=3;i<n;i+=2) {
                if (Gcd(i,n)==1)
                    v.push_back(i);
            }
        }
        else {
            for (ll i=2;i<n;i++) {
                if (Gcd(i,n)==1)
                    v.push_back(i);
            }
        }
        ll len = v.size();
        if (len%2==0)
            cout << v[(len/2)-1] << endl;
        else
            cout <<  v[((len+1)/2)-1]<< endl;
    }
}

void s1() {
    ll l, m, c;
    cin >> l >> m >> c;
    if (l%m==0) {
        cout << l/m << " " << 0 << endl;
        return;
    }
    if (l%c==0) {
        cout << 0 << " " << l/c << endl;
        return;
    }
    ll k1=0,k2=0, sum1=0, sum2=0;
    while (sum1<=l) {
        sum1+=m;
        k1++;
    }
    while (sum2<=l) {
        sum2+=c;
        k2++;
    }
    ll min=LLONG_MAX;
    ll ans1, ans2;
    for (ll i=0;i<=k1;i++) {
        for (ll j=0;j<=k2;j++) {
            ll tmp = abs(i*m+j*c-l);
            if (tmp==0) {
                cout << i << " " << j;
                return;
            }
            if (tmp<min) {
                min = tmp;
                ans1 = i;
                ans2 = j;
            }
        }
    }
    cout << ans1 << " " << ans2;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    s1();
    return 0;
}