﻿using System;
using System.Linq;

namespace Contest
{
    class Contest
    {
        private static void Main()
        {
            var n = long.Parse(Console.ReadLine());
            var m = long.Parse(Console.ReadLine());
            var c = long.Parse(Console.ReadLine());
            var bestDistance = long.MaxValue;
            var result =  new long[2];

            for (long mCap = 0; mCap < m + n / m; mCap++)
            {
                var cCap = (n - mCap * m) / (double)c;

                var floorCCap = (long)decimal.Floor((decimal)cCap);
                var ceilCCap = (long)decimal.Ceiling((decimal)cCap);
                var floorCalc = long.MaxValue;
                var ceilCalc = long.MaxValue;
                
                if (floorCCap >= 0)
                    floorCalc = Math.Abs(mCap * m + floorCCap * c - n);
                if (ceilCCap >= 0)
                    ceilCalc = Math.Abs(mCap * m + ceilCCap * c - n);
                if(floorCalc < 0 && ceilCalc < 0)
                    continue;

                var minDistance = Math.Min(floorCalc, ceilCalc);

                if (minDistance >= bestDistance) continue;
                
                bestDistance = minDistance;
                result[0] = mCap;
                result[1] = floorCalc == minDistance ? floorCCap : ceilCCap;
            }
            Console.WriteLine(string.Join(" ", result));
        }
    }
}
