n, max_rm = map(int, input().split(' '))
prefixes_to_count = {}

for _ in range(n):
    f_name = input()

    for i in range(-1, len(f_name)):
        prefix = f_name[0:i + 1]
        if prefix in prefixes_to_count:
            prefixes_to_count[prefix] += 1
        else:
            prefixes_to_count[prefix] = 1

remove_prefixes = []
remove_count = 0
remove_commands = 0
for prefix, count in sorted(prefixes_to_count.items(), key=lambda d: d[1], reverse=True):
    skip = False
    for rp in remove_prefixes:
        if rp in prefix:
            skip = True
    if skip:
        continue

    if 1 < count <= max_rm:
        remove_prefixes.append(prefix)
        remove_count += count
        remove_commands += 1

print(remove_commands + (n - remove_count) // max_rm + (n - remove_count) % max_rm)
