#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
string s[303];
int n, m, f, q;

bool is_f (int i, int j)
{
  if (i + 4 < n && s[i][j - 1] == '#' && s[i][j - 2] == '#' && s[i + 1][j - 2] == '#' &&
    s[i + 2][j - 1] == '#' && s[i + 2][j - 2] == '#' && s[i + 3][j - 2] == '#' && s[i + 4][j - 2] == '#')
      return true;
  return false;
}

bool is_q (int i, int j)
{
  if (i - 4 >= 0 && s[i - 1][j] == '#' && 
    s[i - 2][j] == '#' && s[i - 2][j - 1] == '#' && s[i - 2][j - 2] == '#' &&
    s[i - 3][j] == '#' && s[i - 3][j - 1] == '.' && s[i - 3][j - 2] == '#' &&
    s[i - 4][j] == '#' && s[i - 4][j - 1] == '#' && s[i - 4][j - 2] == '#')
      return true;
  return false;
}

void del_f (int i, int j)
{
  s[i][j] = s[i][j - 1] = s[i][j - 2] = s[i + 1][j - 2] = s[i + 2][j - 1] = s[i + 2][j - 2] = s[i + 3][j - 2] = s[i + 4][j - 2] = '.';
}

void del_q (int i, int j)
{
  s[i][j] = s[i - 1][j] = s[i - 2][j] = s[i - 2][j - 1] = s[i - 2][j - 2] = s[i - 3][j] = 
    s[i - 3][j - 2] = s[i - 4][j] = s[i - 4][j - 1] = s[i - 4][j - 2] = '.';
}

int main()
{
  ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
  cin >> n >> m;
  for (int i = 0; i < n; i++)
    cin >> s[i];

  for (int j = m - 1; j >= 0; j--)
    for (int i = n - 1; i >= 0; i--)
    {
      if (s[i][j] == '.') continue;
      if (is_f(i, j))
        del_f(i, j), f++;
      else if (is_q(i, j))
        del_q(i, j), q++;
    }

  cout << q << " " << f << endl;
}

/*
5 3
###
#.#
###
..#
..#

5 3
###
#..
##.
#..
#..

5 8
###..###
#.#..#..
###..##.
..#..#..
..#..#..

8 8
.....###
###..#.#
#.######
###.####
#.###.##
#.#.###.
..#...#.
......#.

11 7
.######
.#.##..
.#####.
#####..
#.###..
###....
..####.
..##...
...##..
...#...
...#...


.###...
.#.#...
.###...
####...
#.##...
###....
..#....
..#....
.......
.......
.......
*/