package com.company;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

public class Main {

    public static void main(String[] args) {
        solveB();
    }

//    solveC(){
//
//    }

    public static void solveB() {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int k = sc.nextInt();
        sc.nextLine();
        List<String> list = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            list.add(sc.nextLine());
        }
        list.sort(new MyStringComparator());
        boolean wildcardUsed = false;
        int i = 0;
        List<Integer> groups = new ArrayList<>();
        while (list.size() > 0) {
            String prefix = "";
            if (list.size() <= k) {
                prefix = String.valueOf(list.get(0).charAt(0));
                int end = list.size() - 1;
                while (!list.get(end).startsWith(prefix)) {
                    end--;
                }
                prefix = getSubstring(list.get(0), list.get(end));
            } else {
                while (list.size() > k && list.get(k).startsWith(prefix)) {
                    prefix += String.valueOf(list.get(0).charAt(prefix.length()));
                }
            }
            String finalPrefix = prefix;
            int j = (int) list.stream().filter(x -> x.startsWith(finalPrefix)).count();

            list.removeAll(
                    list.stream().filter(x -> x.startsWith(finalPrefix)).collect(Collectors.toList())
            );
            groups.add(j);
        }
        groups.sort(Integer::compareTo);
        while (groups.stream().reduce(0, Integer::sum) > k) {
            int cur = groups.remove(groups.size() - 1);
            n -= cur;
            i++;
        }
        if (groups.size() > 0) {
            i++;
        }
        System.out.println(i);
    }

    private static String getSubstring(String s, String s1) {
        int i = 0;
        while(i < s1.length() && s.charAt(i) == s1.charAt(i))
            i++;
        return s.substring(0, i);
    }

    private static void printList(List<String> list) {
        for (String str : list) {
            System.out.println(str);
        }
        System.out.println("END");
    }

    private static class MyStringComparator
            implements Comparator<String> {
        public int compare(String s1, String s2) {
            char[] firstChars = s1.toCharArray();
            char[] secondChars = s2.toCharArray();
            int i = 0;
            while (i < firstChars.length && i < secondChars.length) {
                if (firstChars[i] < secondChars[i]) {
                    return -1;
                }
                if (secondChars[i] < firstChars[i]) {
                    return 1;
                }
                i++;
            }
            return secondChars.length - firstChars.length;
        }

    }

}