#include <bits/stdc++.h>

#define ll long long

using namespace std;

struct cell
{
    int x, y;
};

bool operator<(cell c1, cell c2)
{
    return min(c1.x, c1.y) < min(c2.x, c2.y);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector <string> field(n);
    vector <vector <int> > used(n, vector <int> (m));

    for (int i = 0; i < n; i++)
        cin >> field[i];

    int cnt[2] = {};

    vector <cell> cells;

    for (int i = 0; i + 4 < n; i++)
        for (int j = 0; j + 2 < m; j++)
            cells.push_back({i, j});

    sort(cells.begin(), cells.end());

    for (int i = 0; i + 5 < n; i++)
        for (int j = 0; j + 4 < m; j++)
        {
            if (!used[i][j] && !used[i][j + 1] && !used[i][j + 2] && field[i][j] == '#' && field[i][j + 1] == '#' && field[i][j + 2] == '#')
            if (!used[i + 1][j] && !used[i + 1][j + 1] && !used[i + 1][j + 2] && !used[i + 1][j + 3] && !used[i + 1][j + 4] && field[i + 1][j] == '#' && field[i + 1][j + 1] == '.' && field[i + 1][j + 2] == '#' && field[i + 1][j + 3] == '#' && field[i + 1][j + 4] == '#')
            if (!used[i + 2][j] && !used[i + 2][j + 1] && !used[i + 2][j + 2] && !used[i + 2][j + 3] && field[i + 2][j] == '#' && field[i + 2][j + 1] == '#' && field[i + 2][j + 2] == '#' && field[i + 2][j + 3] == '.')
            if (!used[i + 3][j] && !used[i + 3][j + 1] && !used[i + 3][j + 2] && !used[i + 3][j + 3] && field[i + 3][j] == '#' && field[i + 3][j + 1] == '.' && field[i + 3][j + 2] == '#' && field[i + 3][j + 3] == '#')
            if (!used[i + 4][j] && !used[i + 4][j + 1] && !used[i + 4][j + 2] && field[i + 4][j] == '#' && field[i + 4][j + 1] == '.' && field[i + 4][j + 2] == '#')
            if (!used[i + 5][j + 2] && field[i + 5][j + 2] == '#')
            {
                cnt[1] += 2;
                used[i][j] = used[i][j + 1] = used[i][j + 2] = 1;
                used[i + 1][j] = used[i + 1][j + 1] = used[i + 1][j + 2] = used[i + 1][j + 3] = used[i + 1][j + 4] = 1;
                used[i + 2][j] = used[i + 2][j + 1] = used[i + 2][j + 2] = used[i + 2][j + 3] = 1;
                used[i + 3][j] = used[i + 3][j + 1] = used[i + 3][j + 2] = used[i + 3][j + 3] = 1;
                used[i + 4][j] = used[i + 4][j + 1] = used[i + 4][j + 2] = 1;
                used[i + 5][j + 2] = 1;
            }
        }

for (auto cell : cells)
{
int i = cell.x;
int j = cell.y;
            if (field[i][j] == '#' && field[i][j + 1] == '#' && field[i][j + 2] == '#')
                if (field[i + 1][j] == '#')
                    if (field[i + 2][j] == '#' && field[i + 2][j + 1] == '#')
                        if (field[i + 3][j] == '#')
                            if (field[i + 4][j] == '#')
                               if (!used[i][j] && !used[i][j + 1] && !used[i][j + 2])
                                if (!used[i + 1][j])
                                if (!used[i + 2][j] && !used[i + 2][j + 1])
                                if (!used[i + 3][j] && !used[i + 4][j])
                            {

                                cnt[1]++;
                                used[i][j] = used[i][j + 1] = used[i][j + 2] = 1;
                                    used[i + 1][j] = 1;
                                    used[i + 2][j] = used[i + 2][j + 1] = 1;
                                    used[i + 3][j] = used[i + 4][j] = 1;
                            }
            if (field[i][j] == '#' && field[i][j + 1] == '#' && field[i][j + 2] == '#')
                if (field[i + 1][j] == '#' && field[i + 1][j + 1] == '.' && field[i + 1][j + 2] == '#')
                    if (field[i + 2][j] == '#' && field[i + 2][j + 1] == '#' && field[i + 2][j + 2] == '#')
                        if (field[i + 3][j + 2] == '#')
                            if (field[i + 4][j + 2] == '#')
                                if (!used[i][j] && !used[i][j + 1] && !used[i][j + 2])
                                if (!used[i + 1][j] && !used[i + 1][j + 1] && !used[i + 1][j + 2])
                                if (!used[i + 2][j] && !used[i + 2][j + 1] && !used[i + 2][j + 2])
                                if (!used[i + 3][j + 2] && !used[i + 4][j + 2])
                                {

                                    cnt[0]++;
                                    used[i][j] = used[i][j + 1] = used[i][j + 2] = 1;
                                    used[i + 1][j] = used[i + 1][j + 1] = used[i + 1][j + 2] = 1;
                                    used[i + 2][j] = used[i + 2][j + 1] = used[i + 2][j + 2] = 1;
                                    used[i + 3][j + 2] = used[i + 4][j + 2] = 1;
                                }

        }


    cout << cnt[0] << " " << cnt[1];
}
