﻿#include <iostream>
#include <vector>

using namespace std;

vector <vector<int>> map;

bool check(int i,int j, int k) {
    return (map[i + 1][j] > k && map[i + 1][j + 1] > k && map[i][j + 1] > k && map[i - 1][j + 1] > k
        && map[i - 1][j] > k && map[i - 1][j - 1] > k && map[i][j - 1] > k && map[i + 1][j - 1] > k);
}

bool checkf(int i, int j, int k) {
    return (map[i + 1][j] > k && map[i - 1][j + 1] > k
        && map[i - 1][j] > k && map[i - 1][j - 1] > k && map[i][j - 1] > k && map[i + 1][j - 1] > k);
}

bool checkk(int i, int j, int k) {
    return(map[i + 1][j] > k || map[i + 1][j + 1] > k || map[i][j + 1] > k || map[i - 1][j + 1] > k
        || map[i - 1][j] > k || map[i - 1][j - 1] > k || map[i][j - 1] > k || map[i + 1][j - 1] > k);
}

void ff(int i, int j) { 
    map[i + 1][j - 1] = 2;
    map[i + 1][j] = 2;
    map[i + 1][j + 1] = 2;
    map[i - 1][j] = 2;
    map[i - 1][j - 1] = 2;
    map[i][j - 1] = 2;
    map[i + 1][j - 1] = 2;
    map[i + 1][j - 1] = 2;
}

void qq(int i, int j) {
    map[i + 1][j] = 2;
    map[i + 1][j + 1] = 2;
    map[i + 1][j - 1] = 2;
    map[i][j + 1] = 2;
    map[i - 1][j + 1] = 2;
    map[i - 1][j] = 2;
    map[i - 1][j - 1] = 2;
    map[i][j - 1] = 2;
    map[i + 2][j + 1] = 2;
    map[i + 3][j + 1] = 2;
}

int main()
{
    int n, m;

    cin >> n >> m;

    map.resize(n, vector <int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c == '#') {
                map[i][j] = 1;
            }
            else {
                map[i][j] = 0;
            }
        }
    }

    int f = 0;
    int q = 0;
    for (int j = m - 2; j >= 1; j--) {
        for (int i = 1; i < n - 1; i++) {        
            if (map[i][j] == 0 && check(i, j, 0)) {
                if (!checkk(i, j, 1)) {
                    q++;
                    qq(i, j);
                }
                else {
                    f++;
                    ff(i, j);
                }
            }
            else if (map[i][j] == 0 && checkf(i, j, 0)) {
                f++;
                ff(i, j);
            }
        }
    }

    cout << q << " " << f;
}
