#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize(/*"Ofast",*/"O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2",/*"sse3","ssse3","sse4","popcnt"*/,"abm",/*"mmx","avx",*/"tune=native","arch=native"")

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <functional>

using namespace std;

#define sqr(x) ((x)*(x))

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.);

int n, k;
map <char, int> g[300005];
int N = 1;
int term[300005];
pair <int, int> dp[300005];


void dfs(int v, int p = -1) {
	for (auto& to : g[v]) {
		if (to.second != p) {
			dfs(to.second, v);
		}
	}
	vector <pair <int, int>> cur;
	for (auto& to : g[v]) {
		if (to.second != p) {
			cur.push_back({ dp[to.second].second, dp[to.second].first });
		}
	}
	sort(cur.begin(), cur.end());
	int sum = term[v];
	int ans = 0;
	for (auto& i : cur) {
		if (sum + i.first <= k) {
			sum += i.first;
			ans += i.second - 1;
		}
		else {
			ans += i.second;
		}
	}
	ans++;
	dp[v] = { ans, sum };
}

void solve() {
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		int pos = 0;
		for (auto& j : s) {
			if (!g[pos].count(j)) {
				g[pos][j] = N++;
			}
			pos = g[pos][j];
		}
		term[pos] = 1;
	}
	dfs(0);
	
	cout << dp[0].first << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	srand(time(0));
	cout.precision(10);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}