#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize(/*"Ofast",*/"O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2",/*"sse3","ssse3","sse4","popcnt"*/,"abm",/*"mmx","avx",*/"tune=native","arch=native"")

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <functional>

using namespace std;

#define sqr(x) ((x)*(x))

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.);

int n;
vector <pair <string, int>> arr[128];
int pos[128];

void solve() {
	cin >> n;
	int sum = 0;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		sum += k;
		for (int j = 0; j < k; j++) {
			string s;
			cin >> s;
			string a, b;
			bool f = 0;
			for (auto& c : s) {
				if (c == '=') {
					f = 1;
				}
				else if (!f) {
					a += c;
				}
				else {
					b += c;
				}
			}
			arr[i].push_back({ a, stoi(b) });
		}
	}
	
	int k;
	cin >> k;
	map <string, int> need;
	for (int j = 0; j < k; j++) {
		string s;
		int x;
		cin >> s >> x;
		need[s] = x;
	}
	set <string> found;
	for (int i = 0; i < n; i++) {
		pos[i] = arr[i].size() - 1;
	}
	vector <int> ans;
	for (int i = 0; i < sum; i++) {
		bool f = 0;
		for (int j = 0; j < n; j++) {
			if (pos[j] == -1) {
				continue;
			}
			if (found.count(arr[j][pos[j]].first) || arr[j][pos[j]].second == need[arr[j][pos[j]].first]) {
				f = 1;
				found.insert(arr[j][pos[j]].first);
				ans.push_back(j);
				pos[j]--;
				break;
			}
		}
		if (!f) {
			cout << "No\n";
			return;
		}
	}
	reverse(ans.begin(), ans.end());
	cout << "Yes\n";
	for (auto& i : ans) {
		cout << i + 1 << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	srand(time(0));
	cout.precision(10);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}