#define F first
#define S second

#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;

using namespace std;


mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto starttime = chrono::steady_clock::now();
#else
    //     freopen("input.in", "r", stdin);
//     freopen("output.out", "w", stdout);
#endif
    int a = 8;
    int b = 10;
    int N = 0;
    int sm = 0;
    int n, m;
    cin >> n >> m;
    char f[n][m];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> f[i][j];
            if (f[i][j] == '#') {
                ++N;
            }
        }
    }

    for (int i = 0; i + 4 < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool ok = 1;
            for (int t = 0; t < 5; ++t) {
                if (f[i + t][j] != '#') {
                    ok = 0;
                    break;
                }
            }
            if (ok) {
                ++sm;
                for (int t = 0; t < 5; ++t) {
                    f[i + t][j] = '.';
                }
            }
        }
    }

    int bx = 0;
    int by = 0;
    for (int x = 0; x <= sm; ++x) {
        if (a * x + b * (sm - x) == N) {
            bx = x;
            by = (sm - x);
        }
    }

    cout << by << ' ' << bx << '\n';

#ifdef LOCAL
    auto endtime = chrono::steady_clock::now();
    printf("\n[Finished in %.3lfs]\n", 1e-6*(ll)chrono::duration_cast
            <chrono::microseconds>(endtime-starttime).count());
#endif
    return 0;
}
