#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

void B() {
    long long n;
    int m, c;
    cin >> n >> m >> c;
    long long m_upper_bound = n / m + m;
    long long current_closest_approx = n;
    long long curM, curC = 0;
    long long cur_result = 0;
    double x = 0;
    long long C = 0;
    long long C1 = 0;
    long long res1 = 0;
    long long C2 = 0;
    long long res2 = 0;
    for (long long M = 0; M <= m_upper_bound; M++) {
        x = (n - M * m) / (c * 1.0);
        C1 = floor(x);
        res1 = abs(M * m - n + C1 * c);
        C2 = ceil(x);
        res2 = abs(M * m - n + C2 * c);
        if (res1 < res2 && C1 >= 0) {
            C = C1;
            cur_result = res1;
        } else if (C2 >= 0) {
            C = C2;
            cur_result = res2;
        }
        if (cur_result < current_closest_approx) {
            current_closest_approx = cur_result;
            curM = M;
            curC = C;
        }
    }
    cout << curM << " " << curC;
}

ostream &operator<<(ostream &os, vector<vector<int>> const &v) {
    for (auto const &line: v) {
        for (auto const &elem: line) {
            cout << elem << " ";
        }
        cout << endl;
    }
}

void l() {
    auto BLACK = '#';
    auto WHITE = '.';
    int height, width;
    int f_count = 0, q_count = 0;
    cin >> height >> width;
    vector<vector<int>> field(height);
    for (auto &line: field) {
        string input;
        cin >> input;
        for (auto const &s: input) {
            if (s == '#') line.push_back(1);
            else line.push_back(0);
        }
    }
    for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
            if (field[i][j]) {
                if (field[i + 1][j] and field[i + 2][j] and field[i + 3][j] and field[i + 4][j] and field[i][j + 1] and
                    field[i][j + 2] and field[i + 2][j + 1]) {
                    f_count++;
                    field[i][j] = field[i + 1][j] = field[i + 2][j] = field[i + 3][j] = field[i + 4][j] = field[i][j +
                                                                                                                   1] = field[i][
                            j + 2] = field[i + 2][j + 1] = 0;
                } else {
                    q_count++;
                    field[i][j] = field[i + 1][j] = field[i + 2][j] = field[i][j + 1] = field[i][j + 2] = field[i + 1][
                            j + 2] = field[i + 2][j + 2] = field[i + 3][j + 2] = field[i + 4][j + 2] = field[i +
                                                                                                             2][j +
                                                                                                                1] = 0;
                }
            }
        }
    }
    cout << q_count << " " << f_count << endl;
}


int main() {
    l();
    return 0;
}
