import java.util.Scanner;

public class B {
    public static Scanner sc = new Scanner(System.in);

    public static void main(String[] args) {
        int n = sc.nextInt();
        int m = sc.nextInt();
        int c = sc.nextInt();

        int k = n / m + 1;
        int l = n / c + 1;

        int res = Integer.MAX_VALUE;
        int M = 0;
        int C = 0;

        // diagonal 1
        for(int i = k; i >= Math.max(k - l, 0); i--){
            int j = k - i;

            if(check(i, j, k, l)){
                int r = Math.abs(i*m + j*c - n);
                if(r < res){
                    res = r;
                    M = i;
                    C = j;
                }
            }

            if(check(i-1, j, k, l)){
                int r = Math.abs((i-1)*m + j*c - n);
                if(r < res){
                    res = r;
                    M = i-1;
                    C = j;
                }
            }

            if(check(i+1, j, k, l)){
                int r = Math.abs((i+1)*m + j*c - n);
                if(r < res){
                    res = r;
                    M = i+1;
                    C = j;
                }
            }

        }

        // diagonal 2
        for(int j = l; j >= Math.max(l - k, 0); j--){
            int i = l - j;

            if(check(i, j, k, l)){
                int r = Math.abs(i*m + j*c - n);
                if(r < res){
                    res = r;
                    M = i;
                    C = j;
                }
            }

            if(check(i-1, j, k, l)){
                int r = Math.abs((i-1)*m + j*c - n);
                if(r < res){
                    res = r;
                    M = i-1;
                    C = j;
                }
            }

            if(check(i+1, j, k, l)){
                int r = Math.abs((i+1)*m + j*c - n);
                if(r < res){
                    res = r;
                    M = i+1;
                    C = j;
                }
            }

        }


        System.out.println(M + " " + C);
    }

    public static boolean check(int i, int j, int k, int l){
        return i >= 0 && i <= k && j >= 0 && j <= l;
    }
}
