#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<algorithm>
#include<map>
#include<vector>
#include<set>
#include<stack>
#include<queue>
#include<iostream>
#include<stdio.h>
#include<math.h>
#include<string>
#include<iomanip>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<time.h> 
#include<climits>
#include<bitset>
#pragma comment(linker, "/STACK:602777215")

using namespace std;

typedef long long ll;
typedef long double ld;
const long double eps = 1e-6;
const long double pi = 3.1415926535897932384626433;
const int inf = 1e9;
const ll INF = 1e18;
const ll mod = inf + 7;
const int maxn = 32002;
#define max_n 10000000
#define nl '\n'
#define cint(n) int n; cin >> n
#define cill(n) ll n; cin >> n
#define dbg(x) cout << (#x) << ": " << x << nl
#define elif else if

inline void io() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifndef ONLINE_JUDGE
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
}

int n, k;

struct trie {
    int su;
    trie* next[26];
    int clear;
    
    trie() {
        su = 0;
        clear = inf;
        for (int i = 0; i < 26; i++)
            next[i] = nullptr;
    }
} *root = new trie();

trie* add_str(string& s) {
    trie* cur = root;
    cur->su++;
    for (int i = 0; i < s.size(); ++i) {
        if (cur->next[s[i] - 'a'] == nullptr)
            cur->next[s[i] - 'a'] = new trie();
        cur = cur->next[s[i] - 'a'];
        cur->su++;
    }
    return cur;
}

void dp(trie* cur, int i, int z, int su) {
    if (i == 0 && z == 0 && su == 0 && cur-> clear < inf) {
        return;
    }
    if (cur->su == 0) {
        cur->clear = 0;
        return;
    }
    if (cur->su <= k) {
        cur->clear = 1;
        return;
    }
    for (i; i < 26; i++) {
        if (cur->next[i] == nullptr)
            continue;
        if (cur->next[i]->su + z <= k) {
            dp(cur, i + 1, cur->next[i]->su + z, su);
        }
        dp(cur->next[i], 0, 0, 0);
        su += cur->next[i]->clear;
    }
    if (z > 0)
        cur->clear = min(cur->clear, su + 1);
    else
        cur->clear = min(cur->clear, su);
}

int main() {
    io();
    cin >> n >> k;
    string tmp;
    for (int i = 0; i < n; i++) {
        cin >> tmp;
        add_str(tmp);
    }
    dp(root, 0, 0, 0);
    cout << root->clear;
}