#include <bits/stdc++.h>
using namespace std;

void flipq(vector<string>& s, int i, int j) {
    s[i][j] = s[i-1][j] = s[i-2][j] = '.';
    s[i][j+1] = s[i][j+2] = '.';
    s[i-2][j+1] = s[i-2][j+2] = '.';
    s[i-1][j+2] = s[i+1][j+2] = s[i+2][j+2] = '.';
}

void flipf(vector<string>& s, int i, int j) {
    s[i][j] = s[i-1][j] = s[i-2][j] = s[i-3][j] = s[i-4][j] = '.';
    s[i-2][j+1] = '.';
    s[i-4][j+1] = s[i-4][j+2] = '.';
}

void solve() {
    int n, m; cin >> n >> m;
    vector<string> s(n);
    for(int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    int q = 0, f = 0;
    for(int l = 0; l < m; ++l) {
        int cnt = 0, k;
        for (int i = 0; i < n; ++i) {
            if (s[i][l] == '#') {
                cnt++;
            } else {
                if (cnt > 0) {
                    k = i - 1;
                    if (cnt % 5 == 3) {
                        flipq(s, k, l);
                        cnt -= 3;
                        k -= 3;
                        q++;
                    }
                    while (cnt > 0) {
                        flipf(s, k, l);
                        k -= 5;
                        cnt -= 5;
                        f++;
                    }
                }
                cnt = 0;
            }
        }
        k = n - 1;
        while (cnt > 0) {
            flipf(s, k, l);
            k -= 5;
            cnt -= 5;
            f++;
        }
    }
    cout << q << " " << f << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1; //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
