#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define eb emplace_back
#define pb push_back
#define pf push_front
#define pp pop_back
#define all(v) v.begin(), v.end()
#define file "point3"
#define rep(i, n) for (int i = 0; i < n; i++)

/*
 * think and coding
 */
bool prime(ll n) {
    for (ll i = 2; i <= sqrt(n); i++) { if (n % i == 0) return false; }
    return true;
}

ll gcd(ll a, ll b) { return b ? gcd(b, a % b) : a; }

ll lcm(ll a, ll b) { return abs(a * b) / gcd(a, b); }

const int mod2 = 1e9 + 7;

ll mul(ll a, ll b) { return (ll) a * b % mod2; }

ll qpow(ll x, ll n) {
    ll r = 1;
    for (; n; n /= 2, x = mul(x, x)) if (n & 1) r = mul(r, x);
    return r;
}

bool isPower2(ll n) {
    if (n == 2)return true;
    if (n > 1) { return (double) ((ll) log2(n)) == log2(n); } else { return false; }
}

char arr[301][301];

bool checkF(int i, int j) {
    if (arr[i][j + 1] == '#' && arr[i][j + 2] == '#' && arr[i + 1][j] == '#' && arr[i + 2][j] == '#' &&
        arr[i + 2][j + 1] == '#'
        && arr[i + 3][j] == '#' && arr[i + 4][j] == '#') {
        arr[i][j + 1] = arr[i][j + 2] = arr[i + 1][j] = arr[i + 2][j] = arr[i + 2][j + 1] = arr[i + 3][j] = arr[i +
                                                                                                                4][j] = '*';
        return true;
    }
    return false;
}

void fill_q(int i, int j) {
    arr[i][j] = arr[i][j + 1] = arr[i][j + 2] = '*';
    arr[i + 1][j] = arr[i + 2][j] = arr[i + 2][j + 1] = '*';
    arr[i][j + 2] = arr[i + 1][j + 2] = arr[i + 2][j + 2] = '*';
    arr[i+3][j+2] = arr[i+4][j+2] = '*';
}

void sol() {
    int a, b;
    cin >> a >> b;
    int cnt = 0;
    for (int i = 0; i < a; ++i) {
        for (int j = 0; j < b; ++j) {
            cin >> arr[i][j];
        }
    }
    int cnt_f = 0;
    int cnt_q = 0;
    for (int i = 0; i < b; ++i) {
        int c = 0;
        for (int j = 0; j < a; ++j) {
            if (arr[i][j] == '#') {
                if (checkF(i, j)) {
                    cnt_f++;
                } else {
                    cnt_q++;
                    fill_q(i,j);
                }
            }
        }
    }
    cout << cnt_q << " " << cnt_f;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    freopen(file".in", "r", stdin);
//    freopen(file".out", "w", stdout);
    int t = 1;
    // cin >> t;
    while (t--) {
        sol();
//        cout << "\n";
    }
    return 0;
}