#include <bits/stdc++.h>

using namespace std;

string a[305];
bool was[305][305];
int n, m;

bool check(int i, int j) {
    return a[i][j] == '#' && !was[i][j];
}

bool isF(int i, int j) {
    if (i + 4 < n && j + 2 < m) {
        pair<int, int> indices[] = {{i, j}, {i, j + 1}, {i, j + 2}, {i + 1, j}, {i + 2, j}, {i + 3, j}, {i + 4, j}, {i + 2, j + 1}};
        for (int k = 0; k < 8; k++) {
            if (!check(indices[k].first, indices[k].second)) {
                return false;
            }
        }
        for (int k = 0; k < 8; k++) {
            was[indices[k].first][indices[k].second] = true;
        }
        return true;
    }
    return false;
}

bool isQ(int i, int j) {
    if (i + 4 < n && j + 2 < m) {
        pair<int, int> indices[] = {{i, j}, {i, j + 1}, {i, j + 2}, {i + 1, j}, {i + 2, j}, {i + 2, j + 1}, {i + 2, j + 2}, {i + 1, j + 2}, {i + 3, j + 2}, {i + 4, j + 2}};
        for (int k = 0; k < 10; k++) {
            if (!check(indices[k].first, indices[k].second)) {
                return false;
            }
        }
        for (int k = 0; k < 10; k++) {
            was[indices[k].first][indices[k].second] = true;
        }
        return true;
    }
    return false;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int f = 0, q = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (!was[i][j] && isF(i, j)) {
                f++;
            }
            if (!was[i][j] && isQ(i, j)) {
                q++;
            }
        }
    }
    cout << q << ' ' << f;
}

int main() {
    int T = 1;
//    cin >> T;
    while (T--)
        solve();

    return 0;
}
