﻿#include <algorithm>
#include<iostream>
#include<cmath>
#include<vector>
#include <map>
#include <string>
#include <set>
#include <sstream>

using namespace std;

int main() {
    int t; cin >> t;
	stringstream ss;

	map<string, int> name_counter;
	map<int, vector<pair<string, int>>> mv;
	for (size_t i = 1; i <= t; i++) {
		int n; cin >> n;
		for (size_t j = 0; j < n; j++) {
			string name; char c; int value;
			cin >> name;
			value = stoi(name.substr(name.find('=') + 1));
			name = name.substr(0, name.find('='));
			name_counter[name]++;
			mv[i].push_back({ name, value });
		}
	}
	
	int n; cin >> n;
	vector<pair<string, int>> v(n);
	map<string, int> mm;
	for (size_t i = 0; i < n; i++) {
		string name; int value;
		cin >> name >> value;
		v[i] = { name, value };
		mm[name] = value;
	}

	map<string, vector<pair<int, int>>> answer;
	for (size_t i = 0; i < v.size(); i++) {
		for (auto it = begin(mv); it != end(mv); it++) {
			for (size_t j = 0; j < it->second.size(); j++) {
				if (it->second[j].first == v[i].first && it->second[j].second == v[i].second) {
					answer[v[i].first].push_back({ it->first, j + 1 });
					break;
				}
			}
		}
	}

	while (!mv.empty()) {
		auto mv_copy = mv;
		vector<string> tmp_v;
		for (auto it = begin(mv); it != end(mv); it++) {
			tmp_v.push_back(it->second[0].first);
			if (name_counter.find(it->second[0].first) != end(name_counter)) {
				if (it->second[0].second != mm[it->second[0].first]) {
					ss << it->first << ' ';
					name_counter[it->second[0].first]--;
					it->second.erase(begin(it->second));
				}
				else if (name_counter[it->second[0].first] == 1) {
					ss << it->first << ' ';
					name_counter.erase(it->second[0].first);
					it->second.erase(begin(it->second));
				}
			}
		}
		
		if (mv_copy == mv) {
			auto it = begin(mv);
			auto mx = it;
			while (it != end(mv)) {
				if (mx->second.size() < it->second.size() && count(begin(tmp_v), end(tmp_v), mx->second[0].first) != 1) {
					mx = it;
				}
				it = next(it);
			}
			ss << mx->first << ' ';
			name_counter[mx->second[0].first]--;
			if (name_counter[mx->second[0].first] == 0) {
				name_counter.erase(it->second[0].first);
			}
			mx->second.erase(begin(mx->second));
		}
		auto it = begin(mv);
		while (it != end(mv)) {
			auto next_it = next(it);
			if (it->second.empty()) {
				mv.erase(it);
			}
			it = next_it;
		}
		if (mv.empty()) {
			break;
		}
	}
	
	bool is_ok = true;
	for (auto& i: name_counter) {
		if (i.second > 0) is_ok = false;
	}

	if (is_ok) {
		cout << "Yes" << endl << ss.str();
	}
	else {
		cout << "No";
	}

	return 0;
}