#include <iostream>
#include <cmath>
#include <set>

using namespace std;


int main()
{
    int n, m;
    cin >> n >> m;
    char arr[n + 4][m + 4];

    for (int i = 0; i < n + 4; ++i) {
        for (int j = 0; j < m + 4; ++j) {
            arr[i][j] = '.';
        }
    }

    for (int i = 2; i < n + 2; ++i) {
        for (int j = 2; j < m + 2; ++j) {
            cin >> arr[i][j];
        }
    }

    set<pair<int, int>> used;
    int c1 = 0, c2 = 0;
    for (int i = 1; i < n + 1; ++i) {
        for (int j = 1; j < m + 1; ++j) {
            if (
                    arr[i][j] == '#' and used.find(make_pair(i, j)) == used.end() and
                    arr[i][j + 1] == '#' and used.find(make_pair(i, j + 1)) == used.end() and
                    arr[i][j + 2] == '#' and used.find(make_pair(i, j + 2)) == used.end() and
                    arr[i + 2][j] == '#' and used.find(make_pair(i + 2, j)) == used.end() and
                    arr[i + 2][j + 1] == '#' and used.find(make_pair(i + 2, j + 1)) == used.end()
                    ) {
                if (
                        arr[i + 1][j] == '#' and used.find(make_pair(i + 1, j)) == used.end() and
                        arr[i + 3][j] == '#' and used.find(make_pair(i + 3, j)) == used.end() and
                        arr[i + 4][j] == '#' and used.find(make_pair(i + 4, j)) == used.end()) {
                    c2++;

                    used.insert(make_pair(i, j));
                    used.insert(make_pair(i, j + 1));
                    used.insert(make_pair(i, j + 2));
                    used.insert(make_pair(i + 2, j));
                    used.insert(make_pair(i + 2, j + 1));
                    used.insert(make_pair(i + 1, j));
                    used.insert(make_pair(i + 3, j));
                    used.insert(make_pair(i + 4, j));
                }
            }

            if (
                    arr[i][j] == '#' and used.find(make_pair(i, j)) == used.end() and
                    arr[i][j + 1] == '#' and used.find(make_pair(i + 1, j + 1)) == used.end() and
                    arr[i][j + 2] == '#' and used.find(make_pair(i + 2, j + 2)) == used.end() and
                    arr[i + 2][j] == '#' and used.find(make_pair(i + 2, j)) == used.end() and
                    arr[i + 2][j + 1] == '#' and used.find(make_pair(i + 2, j + 1)) == used.end() and
                    arr[i + 2][j + 2] == '#' and used.find(make_pair(i + 2, j + 2)) == used.end() and
                    arr[i + 1][j] == '#' and used.find(make_pair(i + 1, j)) == used.end() and
                    arr[i + 1][j + 2] == '#' and used.find(make_pair(i + 1, j + 2)) == used.end()) {
                if (
                        arr[i + 3][j + 2] == '#' and used.find(make_pair(i + 3, j + 2)) == used.end() and
                        arr[i + 4][j + 2] == '#' and used.find(make_pair(i + 4, j + 2)) == used.end()) {
                    c1++;
                    used.insert(make_pair(i, j));
                    used.insert(make_pair(i, j + 1));
                    used.insert(make_pair(i, j + 2));
                    used.insert(make_pair(i + 2, j));
                    used.insert(make_pair(i + 2, j + 1));
                    used.insert(make_pair(i + 2, j + 2));
                    used.insert(make_pair(i + 1, j));
                    used.insert(make_pair(i + 1, j + 2));
                }
            }
        }
    }

    cout << c1 << " " << c2 << endl;


    return 0;
}

