def GetQ(i,j):
    if  lst[i-1][j] == '#' and \
        lst[i-2][j] == '#'and \
        lst[i-3][j] == '#'and \
        lst[i-4][j] == '#'and \
        lst[i-4][j-1] == '#'and \
        lst[i-4][j-2] == '#'and \
        lst[i-3][j-2] == '#'and \
        lst[i-2][j-2] == '#'and \
        lst[i-2][j-1] == '#':
        return True
    return False

def DrawQ(i,j):
    lst[i][j] = '.'
    lst[i-1][j] = '.'
    lst[i-2][j] = '.'
    lst[i-3][j] = '.'
    lst[i-4][j] = '.'
    lst[i-4][j-1] = '.'
    lst[i-4][j-2] = '.'
    lst[i-3][j-2] = '.'
    lst[i-2][j-2] = '.'
    lst[i-2][j-1] = '.'

def DrawF(i,j):
    lst[i][j] = '.'
    lst[i-1][j] = '.'
    lst[i-2][j] = '.'
    lst[i-3][j] = '.'
    lst[i-4][j] = '.'
    lst[i-4][j+1] = '.'
    lst[i-4][j+2] = '.'
    lst[i-2][j+1] = '.'

n,m = map(int,input().split())

lst = [[] for i in range(n)]
for i in range(n):
    a = input()
    lst[i] = [a[j] for j in range(m)]

# for i in range(n):
#     print(lst[i])
countQ = countF = 0
for row in range(n-1, -1, -1):
    for col in range(m-1, -1, -1):
        if lst[row][col] == '#':
            if col >= 2 and GetQ(row,col):
                countQ += 1
                DrawQ(row,col)
            else:
                countF += 1
                DrawF(row,col)

print(countQ, countF)

'''
5 3
###
#.#
###
..#
..#

5 3
###
#..
##.
#..
#..

5 8
###..###
#.#..#..
###..##.
..#..#..
..#..#..

8 8
.....###
###..#.#
#.######
###.####
#.###.##
#.#.###.
..#...#.
......#.

'''