#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<set>
#include<stack>
#include<deque>
#include<queue>
#include<iomanip>

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(v) v.size()
#define up_b upper_bound
#define low_b lower_bound
#define all(v) v.begin(),v.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N=3e5+11;
const ll mod=1e9+7;
const int inf=2e9;
const ll INF=1e18;
const int dx[4]={0,0,1,-1};
const int dy[4]={1,-1,0,0};

struct node{
	int val;
	int nxt[26];
}t[N];

void init(int v){
	t[v].val=0;
	for(int i=0;i<26;i++)t[v].nxt[i]=-1;
}

int n,k;

int cur=0;

void add(string s){
	int v=0;
	for(int i=0;i<sz(s);i++){
		int c=s[i]-'a';
		if(t[v].nxt[c]==-1){
			cur++;
			t[v].nxt[c]=cur;
			init(cur);
		}
		v=t[v].nxt[c];
	}
	t[v].val++;
}

int ans=0;

int dfs(int v){
	int sum=t[v].val;
	vector<int>a;
	for(int i=0;i<26;i++){
		if(t[v].nxt[i]==-1)continue;
		int x=dfs(t[v].nxt[i]);
		a.pb(x);
		sum+=x;
	}
	if(sum<=k){
		return sum;
	}
	sort(all(a));
	reverse(all(a));
	for(int i=0;i<sz(a);i++){
		if(sum<=k)break;
		sum-=a[i];
		ans++;
	}
	return sum;
}

void solve(){
	cin>>n>>k;
	init(0);
	for(int i=1;i<=n;i++){
		string s;
		cin>>s;
		add(s);
	}
	int x=dfs(0);
	if(x>0)ans++;
	cout<<ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0),cout.tie(0);
	int T=1;
//	cin>>T;
	while(T--){
		solve();
		cout<<endl;
	}
}

