#include <bits/stdc++.h>

using namespace std;

void dfs(int v, vector<int> cur_path, int mn, int mx, int& dif, vector<int>& path, vector<int>& dp, vector<vector<pair<int, int>>>& g) {
    cur_path.push_back(v);

    if (v == g.size() - 1 && dif < mx - mn) {
        dif = mx - mn;
        path = cur_path;
    }

    for (auto to: g[v]) {
        if (dp[to.first] == dp[v] + 1) {
            dfs(to.first, cur_path, min(mn, to.second), max(mx, to.second), dif, path, dp, g);
        }
    }
}

inline void solve(){
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n + 1);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    queue<int> q;
    vector<int> dp(n + 1, INT_MAX);
    q.push(1);
    dp[1] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto to: g[v]) {
            if (dp[to.first] > dp[v] + 1) {
                dp[to.first] = dp[v] + 1;
                q.push(to.first);
            }
        }
    }

    vector<int> path, temp;
    int dif = -1;
    dfs(1, temp, INT_MAX, 0, dif, path, dp, g);
    cout << path.size() - 1 << "\n";
    for (int node: path) {
        cout << node << " ";
    }
}

int main(){
    #ifdef nurik
    freopen("in", "r", stdin);
    #endif

    ios_base::sync_with_stdio(0);

    solve();

    return 0;
}
