#include <bits/stdc++.h>

using namespace std;

inline void solve(){
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n + 1);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    queue<pair<int, pair<int, int>>> q;
    vector<int> dp(n + 1, INT_MAX), res;
    vector<vector<pair<pair<int, int>, pair<int, int>>>> paths(n + 1);
    int dif = -1, MX, MN;
    q.push({1, {INT_MAX, 0}});
    dp[1] = 0;
    while (!q.empty()) {
        int v = q.front().first, mn = q.front().second.first, mx = q.front().second.second;
        q.pop();

        if (dif < mx - mn) {
            dif = mx - mn;
            MX = mx;
            MN = mn;
        }

        for (auto to: g[v]) {
            if (dp[to.first] > dp[v] + 1) {
                dp[to.first] = dp[v] + 1;
                paths[to.first].clear();
                paths[to.first].push_back({{v, to.second}, {min(mn, to.second), max(mx, to.second)}});
                q.push({to.first, {min(mn, to.second), max(mx, to.second)}});
            } else if (dp[to.first] == dp[v] + 1) {
                paths[to.first].push_back({{v, to.second}, {min(mn, to.second), max(mx, to.second)}});
                q.push({to.first, {min(mn, to.second), max(mx, to.second)}});
            }
        }
    }

    int node = n;
    while (node != 1) {
        res.push_back(node);
        for (auto path: paths[node]) {
            if ((path.second.first == MN || MN == -1) && (path.second.second == MX || MX == -1)) {
                node = path.first.first;
                if (path.first.second == MN) 
                    MN = -1;
                if (path.first.second == MX) 
                    MX = -1;
            }
        }
    }
    res.push_back(1);
    reverse(res.begin(), res.end());

    cout << res.size() - 1 << "\n";
    for (int node: res) {
        cout << node << " ";
    }
}

int main(){
    #ifdef nurik
    freopen("in", "r", stdin);
    #endif

    ios_base::sync_with_stdio(0);

    solve();

    return 0;
}
