#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

struct node {
    int to[26];
    int cnt;
    bool isEnd;
    node() {
        memset(to, 0, sizeof(to));
        cnt = 0;
        isEnd = false;
    }
};

int n, k;
int ans;
vector<int> dp;
vector<node> trie;
vector<int> vec;

void add(string s) {
    if (trie.size() == 0)
        trie.push_back(node());
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        int ch = s[i] - 'a';
        if (trie[cur].to[ch] == 0) {
            trie[cur].to[ch] = trie.size();
            trie.push_back(node());
        }
        trie[cur].cnt++;
        cur = trie[cur].to[ch];
    }
    trie[cur].cnt++;
    trie[cur].isEnd = true;
}

void dfs(int v) {	
	dp[v] = trie[v].isEnd;
    for (int i = 0; i < 26; i++) {
        if (trie[v].to[i]) {
            dfs(trie[v].to[i]);
            dp[v] += dp[trie[v].to[i]];
        }
    }
    vec.clear();
    for (int i = 0; i < 26; i++) {
        if (trie[v].to[i]) {
            vec.push_back(dp[trie[v].to[i]]);
        }
    }

    sort(vec.begin(), vec.end());

    int pt = vec.size() - 1;
    while (dp[v] > k) {
//    	cout << v << ' ' << dp[v] << ' ' << vec[pt] << "\n";
    	++ans;
    	dp[v] -= vec[pt];
    	--pt;
    }
}

int main() {
	#ifdef Madi
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
	#endif

	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		string s;
		cin >> s;

		add(s);
	}
	
	dp.resize(trie.size(), 0);
	dfs(0);
	cout << ans + (dp[0] != 0);
	return 0;
}