#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int n, m;
vector<pair<int, int>> g[100005];
int pr[100005], ds[100005], mn[100005], mx[100005], df[100005];

int dif(pair<int, int> x) {
	return x.second - x.first;
}

void bfs() {
	ds[1] = 0;
	df[1] = 0;

	queue<int> q;
	q.push(1);
	while (!q.empty()) {
		int cur = q.front();
		q.pop();

		for (auto it : g[cur]) {
			int to = it.first;
			int val = it.second;
			if (ds[to] == -1) {
				ds[to] = ds[cur] + 1;
				mn[to] = min(mn[cur], val);
				mx[to] = max(mx[cur], val);
				df[to] = df[cur];
				pr[to] = cur;
				q.push(to);
			}
			if (ds[to] == ds[cur] + 1) {																
				if (val - mn[cur] > df[to]) {
					df[to] = val - mn[cur];
					pr[to] = cur;
				}
				if (mx[cur] - val > df[to]) {
					df[to] = mx[cur] - val;
					pr[to] = cur;
				}
				mn[to] = min(mn[cur], mn[to]);
				mx[to] = max(mx[cur], mx[to]);
			}
		}
	}
}

int main() {
	#ifdef Madi
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
	#endif

	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		mn[i] = INF;
		mx[i] = 0;
		df[i] = -1;
		ds[i] = -1;
	}

	for (int i = 1; i <= m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;

		g[a].push_back(make_pair(b, c));
		g[b].push_back(make_pair(a, c));
	}

	bfs();	

	vector<int> res;
	while (n != 1) {
		res.push_back(n);
		n = pr[n];
	}
	res.push_back(1);
	reverse(res.begin(), res.end());
	
	cout << res.size() - 1 << "\n";
	for (auto it : res)
		cout << it << ' ';
	return 0;
}