#include <bits/stdc++.h>
 
#define pb push_back
#define sz(x) (int)x.size()
#define whole(x) x.begin(), x.end()
#define rwhole(x) x.rbegin(), x.rend()
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const int N = (int)3e5 + 2;
const int INF = (int)1e9 + 7;
const ll linf = (ll)1e14;

int used2[105];
map<pair<string, int>, bool> m;
map<string, int> used;
stack<pair<string, int>> st[105];

pair<string, int> process(string s) {
    string ss;
    int i;
    for (i = 0; i < sz(s); ++i) {
        if (s[i] == '=') break;
        ss += s[i];
    }
    int x = 0;
    for (int j = i + 1; j < sz(s); ++j) {
        x = (x * 10 + ((int)(s[j] - '0')));
    }
    return {ss, x};
}

void solve() {
    int T; cin >> T;

    int sum = 0;
    for (int i = 1; i <= T; ++i) {
        int k; cin >> k;
        for (int j = 1; j <= k; ++j) {
            string s; cin >> s;
            pair<string, int> cur = process(s);
            st[i].push(cur);
        }
        sum += k;
    }

    int n; cin >> n;

    for (int i = 1; i <= n; ++i) {
        pair<string, int> p;
        cin >> p.first >> p.second;
        m[p] = true;
        used[p.first] = false;
    }

    vector<int> ans;
    while (sz(ans) < sum) {
        bool f = 0;
        for (int i = 1; i <= T; ++i) {
            if (st[i].empty()) continue;
            if (m[st[i].top()] == true) {
                f = 1;
                used[st[i].top().first] = true;
                ans.pb(i);
                st[i].pop();
            }
        }
        if (!f) {
            cout << "No\n";
            return;
        }
        for (int i = 1; i <= T; ++i) {
            if (!st[i].empty() && used[st[i].top().first]) ans.pb(i), st[i].pop();        
        }
        for (int i = 1; i <= T; ++i) used2[i] = 0;
    }

    reverse(whole(ans));

    cout << "Yes\n";
    for (int x : ans) cout << x << " ";
}
 
int main() {
    int tt = 1;
    while (tt--) solve();
    return 0;
}