#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1000000007;

void solve() {

  int n, m, c;
  cin >> n >> m >> c;
  int mx = m * c / __gcd(m, c);
  int ans = n;
  pii ansp = make_pair(0, 0);
  for (int i = 0; i <= mx; ++i) {
    int F = (n - i * c) / m;
    for (int j = max(0, F - 2); j <= max(0, F + 2); ++j) {
      if (abs(j * m + c * i - n) < ans) {
        ans = abs(j * m + c * i - n);
        ansp = make_pair(j, i);
      }
    }
  }
  cout << ansp.first << " " << ansp.second << "\n";
}

int main() {
  #ifndef LOCAL58
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
