#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define F first
#define S second
#define pii pair <int , int>
#define pll pair <ll ,ll >
#define all(x) x.begin(),x.end()
#define sz(x) (int)(x.size())

using namespace std;

const int maxn = (int)2e5 + 7;
const ll linf = (ll)1e18 + 7;
const int INF = (int)1e9 + 7;
const double pi = 3.14159265359;
const double eps = 1e-6;
const int base = 1000 * 1000 * 1000;
const ll P = 37;
const int block = 100;

void boost(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
}

ll n;

char ch[400][400];

bool canf(int i, int j){
    if(ch[i][j] == '#' && ch[i + 1][j] == '#' && ch[i + 2][j] == '#' && ch[i + 3][j] == '#' &&
            ch[i + 4][j] == '#' && ch[i][j + 1] == '#' && ch[i][j + 2] == '#' && ch[i + 2][j + 1] == '#'){
        return true;
    }
    return false;
}


bool canq(int i, int j){
    if(ch[i][j] == '#' && ch[i + 1][j] == '#' && ch[i + 2][j] == '#' && ch[i][j + 1] == '#' &&
            ch[i + 2][j + 1] == '#' && ch[i][j + 2] == '#' && ch[i + 1][j + 2] == '#' && ch[i + 2][j + 2] == '#'
            && ch[i + 3][j + 2] == '#' && ch[i + 4][j + 2] == '#'){
        return true;
    }
    return false;
}

void fitf(int i, int j) {
    ch[i][j] = '.';
    ch[i + 1][j] = '.';
    ch[i + 2][j] = '.';
    ch[i + 3][j] = '.';
    ch[i + 4][j] = '.';
    ch[i][j + 1] = '.';
    ch[i][j + 2] = '.';
    ch[i + 2][j + 1] = '.';
}


void fitq(int i, int j) {
    ch[i][j] = '.';
    ch[i + 1][j] = '.';
    ch[i + 2][j] = '.';
    ch[i][j + 1] = '.';
    ch[i][j + 2] = '.';
    ch[i + 2][j + 1] = '.';
    ch[i + 1][j + 2] = '.';
    ch[i + 2][j + 2] = '.';
    ch[i + 3][j + 2] = '.';
    ch[i + 4][j + 2] = '.';
}

void solve(){
    int m;
    cin >> n >> m;
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= m; ++j){
            cin >> ch[i][j];
        }
    }
    int ans1 = 0, ans2 = 0;
    for(int j = 1; j <= m; ++j){
        for(int i = 1; i <= n; ++i){
            if(canf(i, j)){
                ans1++;
                fitf(i, j);
            }
            else if(canq(i, j)){
                ans2++;
                fitq(i, j);
            }
        }
    }
    cout << ans2 << " " << ans1;
}

signed main() {
    boost();
    int t = 1;
    //cin >> t;
    for(int i = 1; i <= t; ++i){
        solve();
    }
}
