# include <iostream>
# include <vector>
# define sz(x) (int)((x).size())

# define all(x) x.begin(), x.end()
 
using namespace std; 
using ll = long long;

int a[305][305];
int n, m;

int findQs() {
  int x = 3, y = 5;
  vector<int> dx = {0, 1, 2, 0, 2, 0, 1, 2, 3, 4};
  vector<int> dy = {0, 0, 0, 1, 1, 2, 2, 2, 2, 2};

  int res = 0;

  for (int i = 1; i <= n - y + 1; i++) {
    for (int j = 1; j <= m - x + 1; j++) {
      int sum = 0;
      for (int d = 0; d < dx.size(); d++) {
        //cout << i + dx[d] << ' ' << j + dy[d] << " == " << a[i + dx[d]][j + dy[d]] << endl;
        sum += a[i + dx[d]][j + dy[d]];
      }

      if (sum == dx.size()) {
        for (int d = 0; d < dx.size(); d++) {
          a[i + dx[d]][j + dy[d]] = -1;
        }
        res++;
      }
    }
  }

  return res;
}

int findFs() {
  int x = 3, y = 5;
  vector<int> dx = {0, 1, 2, 3, 4, 0, 2, 0};
  vector<int> dy = {0, 0, 0, 0, 0, 1, 1, 2};

  int res = 0;

  for (int i = 1; i <= n - y + 1; i++) {
    for (int j = 1; j <= m - x + 1; j++) {
      int sum = 0;
      for (int d = 0; d < dx.size(); d++) {
        //cout << i + dx[d] << ' ' << j + dy[d] << " == " << a[i + dx[d]][j + dy[d]] << endl;
        sum += a[i + dx[d]][j + dy[d]];
      }

      if (sum == dx.size()) {
        for (int d = 0; d < dx.size(); d++) {
          a[i + dx[d]][j + dy[d]] = -1;
        }
        res++;
      }
    }
  }

  return res;
}

void solve() {
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      char x;
      cin >> x;
      a[i][j] = (x == '#');
    }
  }

  // for (int i = 1; i <= n; i++) {
  //   for (int j = 1; j <= m; j++) {
  //     cout << a[i][j] << ' ';
  //   }
  //   cout << endl;
  // }

  int f = findFs();
  int s = findQs();

  cout << s << ' ' << f << endl;
}
 
int main(){
  //freopen("input.in", "r", stdin);
  //freopen("output.out", "w", stdout);
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  //int t = 1; cin >> t; while (t--)
  solve();
  return 0;
}
