# include <bits/stdc++.h>
 
using namespace std; 
using ll = long long;

int t, k;
int variables[10100];
stack<pair<int, int>> threads[101];

int tasksCnt = 0;

void input() {
  map<string, int> vars;
  cin >> t;
  int varIdx = 0;

  for (int i = 1; i <= t; i++) {
    int l;
    cin >> l;
    tasksCnt += l;
    for (int j = 0; j < l; j++) {
      string s;
      cin >> s;
      string varName = "";
      
      int val = 0;
      bool ok = false;
      for (int k = 0; k < s.size(); k++) {
        if (s[k] == '=') {
          ok = true;
        } else if (ok) {
          val = val * 10 + (s[k] - '0');
        } else {
          varName += s[k];
        }
      }

      if (vars[varName] == 0) {
        vars[varName] = ++varIdx;
      }

      int idx = vars[varName];
      threads[i].push({idx, val});
    }
  }

  cin >> k;
  for (int i = 0; i < k; i++) {
    string varName;
    int val;
    cin >> varName >> val;
    //cout << varName << ' ' << vars[varName] << endl;
    variables[vars[varName]] = val;
  }
}

 
void solve() {
  input();

  bool ok = true;
  vector<int> res;

  int cnt = 0;
  while (cnt < tasksCnt) {

    bool atLeastOneUpdate = false;

    for (int tIdx = 1; tIdx <= t; tIdx++) {
      if (threads[tIdx].empty()) {
        continue;
      }

      int topIdx = threads[tIdx].top().first;
      int topVal = threads[tIdx].top().second;

      if (variables[topIdx] == topVal || variables[topIdx] == -1) {
        //cout << tIdx << ": " << "topIdx=" << topIdx << " topVal=" << topVal << endl;
        res.push_back(tIdx);
        variables[topIdx] = -1;
        threads[tIdx].pop();
        atLeastOneUpdate = true;
        cnt++;
      }
    }

    if (!atLeastOneUpdate) {
      ok = false;
      break;
    }
  }

  if (!ok) {
    cout << "No";
    return;
  }
  cout << "Yes\n";
  reverse(res.begin(), res.end());
  for (int th : res) {
    cout << th << ' ';
  }
  cout << endl;
}
 
int main(){
  //freopen("input.in", "r", stdin);
  //freopen("output.out", "w", stdout);
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  //int t = 1; cin >> t; while (t--)
  solve();
  return 0;
}