#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <random>
#include <stack>
#include <climits>
#include <chrono>
#include <fstream>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

#define _ << " " <<
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define ff first
#define ss second
#define pb push_back
#define debug(x) cout << (#x) << " is " << (x) << endl

using namespace std;
//using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const double eps = 1e-8;
const ll INF = 2e9;

#define int ll

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int stupid(int i) {
    vector<int> p;
    for (int j = 1; j < i; j++) {
        if (gcd(i, j) == 1) p.pb(j);
    }
    return p[p.size() / 2 - (p.size() % 2 == 0)];
}

int smart(int n) {
    if (n == 2) return 1;
    if (n % 2 == 1) {
        return (n - 1) / 2;
    }
    if (n % 4 == 0) {
        return n / 2 - 1;
    }
    return n / 2 - 2;
}


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output_false.txt", "w", stdout); //outs
#endif
//    for (int i = 2; i <= 10000; i++) {
//        int ans1 = stupid(i), ans2 = smart(i);
//        if (ans1 != ans2) cout << i _ ans1 _ ans2 << endl;
//    }
    int tt;
    cin >> tt;
    while (tt--) {
        int x; cin >> x;
        cout << smart(x) << "\n";
    }
    return 0;
}