﻿#include <iostream>

int main()
{
    long long int n, m, c;
    std::cin >> n >> m >> c;

    if (m && (n % m) == 0) {
        std::cout << n / m << " " << 0 << std::endl;
        return 0;
    }

    if (c && (n % c) == 0) {
        std::cout << 0 << " " << n / c << std::endl;
        return 0;
    }

    long long int maybeM = 0;
    long long int maybeC = std::ceil(n / (double)(c || 1));
    long long int bestM = maybeM;
    long long int bestC = maybeC;
    long long int MtoC = std::ceil(m / (double)(c || 1));
    long long int error = abs(n - c * maybeC);
    long long int bestError = error;

    do {
        if (error == 0) {
            std::cout << maybeM << " " << maybeC << std::endl;
            return 0;
        }

        for (size_t i = 0; i < MtoC && maybeC-- > 0; i++)
        {
            error = abs(n - c * maybeC - m * maybeM);

            if (bestError > error) {
                bestError = error;
                bestM = maybeM;
                bestC = maybeC;
            }
        }

        maybeM++;
        maybeC += MtoC;

        for (size_t i = 0; i < MtoC && maybeC-- > 0; i++)
        {
            error = abs(n - c * maybeC - m * maybeM);

            if (bestError > error)
            {
                bestError = error; 
                bestM = maybeM;
                bestC = maybeC;
            }
        }

    } while (maybeC >= 0);

    maybeM = std::ceil(n / (double)(c || 1));
    maybeC = 0;

    while (maybeM)
    {
        if (error == 0) {
            std::cout << maybeM << " " << maybeC << std::endl;
            return 0;
        }

        error = abs(n - m * maybeM);

        if (bestError > error) {
            bestError = error;
            bestM = maybeM;
            bestC = maybeC;
        }

        maybeM--;
    }

    std::cout << bestM << " " << bestC << std::endl;
}