#!/usr/bin/env python3

n, m = [int(x) for x in input().split(' ')]
field = []
for _ in range(n):
    field.append([x for x in input()])

offF = [
    (0, 0), (0, 1), (0, 2),
    (1, 0),
    (2, 0), (2, 1),
    (3, 0),
    (4, 0),
]
def isF(row, col):
    for dy, dx in offF:
        if field[row + dy][col + dx] != '#':
            return False
    for dy, dx in offF:
        field[row + dy][col + dx] = '.'
    return True

offQ = [
    (0, 0), (0, 1), (0, 2),
    (1, 0),         (1, 2),
    (2, 0), (2, 1), (2, 2),
                    (3, 2),
                    (4, 2),
]
def isQ(row, col):
    for dy, dx in offQ:
        if field[row + dy][col + dx] != '#':
            return False
    for dy, dx in offQ:
        field[row + dy][col + dx] = '.'
    return True

q = 0
f = 0

for j in range(m - 2):
    for i in reversed(range(n - 4)):
        if isF(i, j):
            f += 1
    for i in reversed(range(n - 4)):
        if isQ(i, m - 3 - j):
            q += 1

print(f'{q} {f}')