#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <cstring>
#include <iomanip>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    long long n, m, c;
    cin >> n >> m >> c;

    long long minDiff = n, bestMCount, bestCCount;
    for (long long mCount = 0; mCount * m <= n; mCount++) {
        long long cCount = abs(n - mCount * m) / c;
        long long currentDiff = abs(n - mCount * m - c * cCount);

        if (currentDiff < minDiff) {
            minDiff = currentDiff;
            bestMCount = mCount;
            bestCCount = cCount;
        }
    }

    for (long long cCount = 0; cCount * m <= n; cCount++) {
        long long mCount = abs(n - cCount * c) / m;
        long long currentDiff = abs(n - mCount * m - c * cCount);

        if (currentDiff < minDiff) {
            minDiff = currentDiff;
            bestMCount = mCount;
            bestCCount = cCount;
        }
    }

    cout << bestMCount << " " << bestCCount << endl;
}
