///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>
 
using namespace std;
 
const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

int T;
int n, m;
int a[N];

vector <int> g[N];
int val[N];

int son1[N * 60], son2[N * 60];
int pref[N * 60], suf[N * 60];
int answ[N * 60], t[N * 60];
int timer = 1;

void update(int v, int s, int e, int pos, int delta) {
  if (s == e) {
    t[v] += delta;
    if (t[v] > 0) {
      answ[v] = 1;
      pref[v] = suf[v] = 1;
    } else {
      answ[v] = 0;
      pref[v] = suf[v] = 0;
    }
    return ;
  }
  int m = (s + e) / 2;
  if (son1[v] == 0) {
    son1[v] = ++timer;
    son2[v] = ++timer;
  }
  if (pos <= m) {
    update(son1[v], s, m, pos, delta);
  } else {
    update(son2[v], m + 1, e, pos, delta);
  }
  ///
  answ[v] = max(answ[son1[v]], answ[son2[v]]);
  answ[v] = max(answ[v], suf[son1[v]] + pref[son2[v]]);
  ///
  if (pref[son1[v]] == m - s + 1) {
    pref[v] = pref[son1[v]] + pref[son2[v]];
  } else {
    pref[v] = pref[son1[v]];
  }
  if (suf[son2[v]] == e - m) {
    suf[v] = suf[son2[v]] + suf[son1[v]];
  } else {
    suf[v] = suf[son2[v]];
  }
}

void clean() {
  for (int i = 1; i <= timer; i++) {
    son1[i] = son2[i] = 0;
    t[i] = answ[i] = pref[i] = suf[i] = 0;
  }
  timer = 1;
}

int main() {
  cin >> T;

  while (T--) {
    scanf("%d%d", &n, &m);

    vector <int> x;
    x.push_back(0);

    for (int i = 1; i <= n; i++) {
      scanf("%d", &a[i]);
      x.push_back((m - a[i] % m) % m);
      val[i] = a[i] / m;
      update(1, 0, inf + 2, val[i], 1);
    }

    sort(x.begin(), x.end());
    x.resize( unique(x.begin(), x.end()) - x.begin() );

    for (int i = 1; i <= n; i++) {
      int val = (m - a[i] % m) % m;
      if (val == 0) continue;
      int id = lower_bound(x.begin(), x.end(), val) - x.begin();
      g[id].push_back(i);
    }

    int pat = answ[1], tzone = 0;
    for (int i = 1; i < (int)x.size(); i++) {
      for (int j = 0; j < (int)g[i].size(); j++) {
        int id = g[i][j];
        update(1, 0, inf + 2, val[id], -1);
        update(1, 0, inf + 2, val[id] + 1, 1);
      }
      if (answ[1] > pat) {
        pat = answ[1];
        tzone = x[i];
      }
    }

    printf("%d %d\n", pat, tzone);

    for (int i = 0; i < (int)x.size(); i++) {
      g[i].clear();
    }
    clean();
  }
  return 0;
}
