///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>
 
using namespace std;
 
const int N = 300005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

struct node {
  int a, b;
  char c;
};

int t;
int n;

int a[N], b[N];

set < pair<int, int> > Q;
set < pair< pair<int, int>, int> > B, W;

void clean() {
  while (!Q.empty()) {
    Q.erase(Q.begin());
  }
  while (!W.empty()) {
    W.erase(W.begin());
  }
  while (!B.empty()) {
    B.erase(B.begin());
  }
}

int main() {
  cin >> t;

  while (t--) {
    scanf("%d", &n);

    int ww = 0, bb = 0;
    int all = 0;
    for (int i = 1; i <= n; i++) {
      scanf("%d%d", &a[i], &b[i]);
      ///
      if (a[i] + b[i] > 0) {
        Q.insert(make_pair(a[i] + b[i], i));
      }
      if (b[i] > 0) {
        B.insert(make_pair(make_pair(b[i], a[i] + b[i]), i));
      }
      if (a[i] > 0) {
        W.insert(make_pair(make_pair(a[i], a[i] + b[i]), i));
      }
      ///
      ww ^= a[i] % 2;
      bb ^= b[i] % 2;
      all += a[i] + b[i];
    }

    if (ww || bb || all != 2 * (n - 1)) {
      printf("No\n");
      clean();
      continue;
    }

    vector < node > answ;
    while (!Q.empty()) {
      int v = Q.begin() -> second;
      Q.erase(Q.begin());

      if (a[v] + b[v] != 1) {
        break;
      }

      if (a[v] == 1) {
        W.erase(make_pair(make_pair(1, 1), v));
        auto it = W.end();
        --it;
        int u = it -> second;

        answ.push_back({v, u, 'W'});

        if (a[u] + b[u] == 1) break;

        ///
        W.erase(make_pair(make_pair(a[u], a[u] + b[u]), u));
        B.erase(make_pair(make_pair(b[u], a[u] + b[u]), u));
        Q.erase(make_pair(a[u] + b[u], u));
        a[u]--;
        if (a[u] > 0) {
          W.insert(make_pair(make_pair(a[u], a[u] + b[u]), u));
        }
        if (b[u] > 0) {
          B.insert(make_pair(make_pair(b[u], a[u] + b[u]), u));
        }
        if (a[u] + b[u] > 0) {
          Q.insert(make_pair(a[u] + b[u], u));
        }
      } else {
        B.erase(make_pair(make_pair(1, 1), v));
        auto it = B.end();
        --it;
        int u = it -> second;

        answ.push_back({v, u, 'B'});

        if (a[u] + b[u] == 1) break;

        ///
        W.erase(make_pair(make_pair(a[u], a[u] + b[u]), u));
        B.erase(make_pair(make_pair(b[u], a[u] + b[u]), u));
        Q.erase(make_pair(a[u] + b[u], u));
        b[u]--;
        if (a[u] > 0) {
          W.insert(make_pair(make_pair(a[u], a[u] + b[u]), u));
        }
        if (b[u] > 0) {
          B.insert(make_pair(make_pair(b[u], a[u] + b[u]), u));
        }
        if (a[u] + b[u] > 0) {
          Q.insert(make_pair(a[u] + b[u], u));
        }
      }
    }

    if ((int)answ.size() == n - 1) {
      printf("Yes\n");
      for (int i = 0; i < (int)answ.size(); i++) {
        printf("%d %d %c\n", answ[i].a, answ[i].b, answ[i].c);
      }
    } else {
      printf("No\n");
    }

    clean();
  }
  return 0;
}
