#include <bits/stdc++.h>
using namespace std;
#define m_p make_pair
#define all(x) (x).begin(),(x).end()
#define sz(x) ((int)(x).size())
#define fi first
#define se second
typedef long long ll;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnf(2106);
const int N = 200005;

int n, m;
int a[N];

vector<pair<int, int> > v;

struct ban
{
    int l, r;
    int ans;
    bool z;
    ban()
    {
        l = r = ans = 0;
        z = false;
    }
    ban(int x)
    {
        if (x == 0)
        {
            l = r = ans = 0;
            z = false;
        }
        else if (x == 1)
        {
            l = r = ans = 1;
            z = true;
        }
        else if (x == 2)
        {
            l = r = ans = 0;
            z = true;
        }
        else
            assert(false);
    }
};

ban mer(const ban& l, const ban& r)
{
    ban res;
    res.z = (l.z && r.z);

    res.l = l.l;
    if (l.z)
        res.l = l.l + r.l;

    res.r = r.r;
    if (r.z)
        res.r = r.r + l.r;

    res.ans = max(l.ans, r.ans);
    res.ans = max(res.ans, l.r + r.l);
    return res;
}

ban t[N * 4];

void bil(int tl, int tr, int pos)
{
    t[pos] = ban();
    if (tl == tr)
        return;
    int m = (tl + tr) / 2;
    bil(tl, m, pos * 2);
    bil(m + 1, tr, pos * 2 + 1);
}

void ubd(int tl, int tr, int x, int y, int pos)
{
    if (tl == tr)
    {
        t[pos] = ban(y);
        return;
    }
    int m = (tl + tr) / 2;
    if (x <= m)
        ubd(tl, m, x, y, pos * 2);
    else
        ubd(m + 1, tr, x, y, pos * 2 + 1);
    t[pos] = mer(t[pos * 2], t[pos * 2 + 1]);
}

void solv()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];

    if (n == 1)
    {
        cout << "1 0\n";
        return;
    }

    v.clear();
    for (int i = 1; i < n; ++i)
    {
        v.push_back(m_p(0, i));

        int j = 0;
        while (1)
        {
            int l = j + 1, r = m - 1;
            int u = m;
            while (l <= r)
            {
                int t = (l + r) / 2;
                if ((a[i] + j) / m != (a[i] + t) / m)
                {
                    u = t;
                    r = t - 1;
                }
                else
                    l = t + 1;
            }

            if (u == m)
                break;
            v.push_back(m_p(u, i));
            j = u;
        }

        j = 0;
        while (1)
        {
            int l = j + 1, r = m - 1;
            int u = m;
            while (l <= r)
            {
                int t = (l + r) / 2;
                if ((a[i + 1] + j) / m != (a[i + 1] + t) / m)
                {
                    u = t;
                    r = t - 1;
                }
                else
                    l = t + 1;
            }

            if (u == m)
                break;
            v.push_back(m_p(u, i));
            j = u;
        }
    }

    bil(1, n, 1);
    sort(all(v));
    int ans = 0, anst = 0;
    for (int j = 0; j < sz(v); ++j)
    {
        int t = v[j].fi;
        int i = v[j].se;

        if ((a[i] + t) / m + 1 == (a[i + 1] + t) / m)
            ubd(1, n, i, 1, 1);
        else if ((a[i] + t) / m == (a[i + 1] + t) / m)
            ubd(1, n, i, 2, 1);
        else
            ubd(1, n, i, 0, 1);

        if (j == sz(v) - 1 || t != v[j + 1].fi)
        {
            if (::t[1].ans + 1 > ans)
            {
                ans = ::t[1].ans + 1;
                anst = t;
            }
        }
    }

    cout << ans << ' ' << anst << "\n";
}

int main()
{
    #ifdef SOMETHING
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // SOMETHING
    ios_base::sync_with_stdio(false), cin.tie(0);

    int tt = 1;
    cin >> tt;
    while (tt--)
    {
        solv();
    }
    return 0;
}
