#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>


int n, m, c;
struct min_t {
	int m, c;
};

bool operator<(const min_t& m1, const min_t& m2) {
	return abs(n - m1.m * m - m1.c * c) < abs(n - m2.m * m - m2.c * c);
}

bool operator>(const min_t& m1, const min_t& m2) {
	return m2 < m1;
}
int main(){
	std::cin >> n >> m >> c;
	int a = n / m;
	int b = n / c;
	if (a==0 || n % a > a / 2) a++;
	if (b==0 || n % b > b / 2) b++;
	std::vector<min_t> mins(a*m + b*c, { 0, 0 });
	min_t m1{ a, 0 };
	min_t m2{ 0, b };
	min_t ans = m1 > m2 ? m2 : m1;
	for(int i = 1;i * m < mins.size();++i){
		mins[i * m].m += mins[(i - 1)*m].m + 1;
		for (int j = 1; (i - 1) * m + j * c < mins.size(); ++j) {
			mins[(i - 1) * m + j * c].m = mins[(i - 1) * m + (j - 1) * c].m;
			mins[(i - 1)* m + j * c].c += mins[(i - 1) * m + (j - 1) * c].c + 1;
			if (mins[(i - 1) * m + (j -1) * c] < ans) {
				ans = mins[(i - 1) * m + (j - 1)* c];
			}
		}
	}
	if (ans.m == 0 && ans.c == 0) {
		if (m > c)
			std::cout << 1 << ' ' << 0;
		else
			std::cout << 0 << ' ' << 1;
		return;
	}
	std::cout << ans.m << ' ' << ans.c;
}