#include<iostream>
#include<vector>
#include<queue>
#include<deque>
using namespace std;

deque<int> l;
queue<int> q;
vector<pair<int, int>> g[100001];
int main()
{
    int n, m;
    cin>>n>>m;
    for(int i=0;i<m;i++){
        int v, u, c;
        cin>>v>>u>>c;
        g[v].push_back({u, c});
        g[u].push_back({v, c});
    }
    q.push(1);
    vector<bool> used (n+1);
    vector<int> left_min (n+1, -1);
    vector<int> left_max (n+1, -1);
    vector<int> left_d (n+1), left_p_min(n+1), left_p_max(n+1);
    left_p_min[n] = -1;
    left_p_max[n] = -1;
    used[1] = true;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (size_t i=0; i<g[v].size(); ++i) {
            int to = g[v][i].first;
            int c = g[v][i].second;
            if (!used[to] || left_d[to] == left_d[v] + 1) {
                if(used[to] == false)
                    q.push(to);
                used[to] = true;
                left_d[to] = left_d[v] + 1;
                if(left_min[to] == -1 || left_min[to] > c)
                {
                    left_min[to] = c;
                    left_p_min[to] = v;
                }
                if(v!=1 && v!=n && left_min[to] > left_min[v])
                {
                    left_min[to] = left_min[v];
                    left_p_min[to] = v;
                }
                if(left_max[to] == -1 || left_max[to] < c)
                {
                    left_max[to] = c;
                    left_p_max[to] = v;
                }
                if(v!=1 && v!=n && left_max[to] < left_max[v])
                {
                    left_max[to] = left_max[v];
                    left_p_max[to] = v;
                }
            }
        }
    }
    if(left_d[n] == 1){
        cout<<1<<endl;
        cout<<1<<" "<<n<<endl;
        return 0;
    }
    q.push(n);
    for(int i=0;i<=n;i++)
        used[i] = false;
    vector<int> right_min (n+1, -1);
    vector<int> right_max (n+1, -1);
    vector<int> right_d (n+1), right_p_min(n+1), right_p_max(n+1);
    used[n] = true;
    right_p_min[n] = -1;
    right_p_max[n] = -1;
    int ans = 0;
    int e = -1, y = -1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (size_t i=0; i<g[v].size(); ++i) {
            int to = g[v][i].first;
            int c = g[v][i].second;
            if (!used[to] || right_d[to] == right_d[v] + 1) {
                if(used[to] == false)
                    q.push(to);
                used[to] = true;
                right_d[to] = right_d[v] + 1;
                if(right_min[to] == -1 || right_min[to] > c)
                {
                    right_min[to] = c;
                    right_p_min[to] = v;
                }
                if(v!=1 && v!=n && right_min[to] > right_min[v])
                {
                    right_min[to] = right_min[v];
                    right_p_min[to] = v;
                }
                if(right_max[to] == -1 || right_max[to] < c)
                {
                    right_max[to] = c;
                    right_p_max[to] = v;
                }
                if(v!=1 && v!=n && right_max[to] < right_max[v])
                {
                    right_max[to] = right_max[v];
                    right_p_max[to] = v;
                }
                if(left_d[to] + right_d[to] == left_d[n] && to!=n && to!=1)
                {
                    //cout<<to<<" "<<left_max[to]<<" "<<left_min[to]<<" "<<right_min[to]<<" "<<right_max[to]<<endl;
                    if(ans < abs(left_max[to] - right_min[to])){
                        ans = max(ans, abs(left_max[to] - right_min[to]));
                        e = to;
                        y = 1;
                    }
                    if(ans < abs(left_min[to] - right_max[to])){
                        ans = max(ans, abs(left_min[to] - right_max[to]));
                        e = to;
                        y = 2;
                    }
                }
            }
        }
    }

    if(y == 1){
        int u = e;
        while(u != 1){
            l.push_front(left_p_max[u]);
            u = left_p_max[u];
        }
        l.push_back(e);
        u = e;
        while(u != n){
            l.push_back(right_p_min[u]);
            u = right_p_min[u];
        }
    }

    if(y == 2){
        int u = e;
        while(u != 1){
            l.push_front(left_p_min[u]);
            u = left_p_min[u];
        }
        l.push_back(e);
        u = e;
        while(u != n){
            l.push_back(right_p_max[u]);
            u = right_p_max[u];
        }
    }
    cout<<left_d[n]<<endl;
    while(!l.empty()){
        int v = l.front();
        l.pop_front();
        cout<<v<<" ";
    }
    return 0;
}