#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

void do_swap(int i, int j) {
    cout << "S " << i + 1 << ' ' << j + 1 << endl;
    int x;
    cin >> x;
    if (x == 1) {
        exit(0);
    }
}

int comp(int i, int j) {
    cout << "C " << i + 1 << ' ' << j + 1 << endl;
    int x;
    cin >> x;
    return x;
}

int solve() {
    int n;
    cin >> n;
    if (n == 1) {
        do_swap(0, 0);
    }
    vector<int> a(n);
    iota(a.begin(), a.end(), 0);
    shuffle(a.begin(), a.end(), rnd);
    for (int i = 0; i < n; i++) {
        if (a[i] != i) {
            do_swap(i, a[i]);
            swap(a[i], a[a[i]]);
        }
    }
    vector<int> inds;
    inds.push_back(0);
    for (int i = 1; i < n; i++) {
        int l = 0, r = i;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (comp(inds[mid], i) == -1) {
                l = mid;
            } else {
                r = mid;
            }
        }
        inds.push_back(0);
        for (int i = sz(inds) - 1; i > l; i--) {
            inds[i] = inds[i - 1];
        }
        inds[l] = i;
    }
    vector<int> revs(n);
    for (int i = 0; i < n; i++) {
        revs[inds[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        if (revs[i] != i) {
            do_swap(i, revs[i]);
            swap(revs[i], revs[revs[i]]);
        }
    }
    for (int i = 0; i < 1000; i++) {
        int x = rnd() % (n - 1);
        do_swap(x, x + 1);
    }
    return 1;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
