#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

vector<pair<int, int>> q = {
    {0, 0},
    {0, 1},
    {0, 2},
    {1, 0},
    {1, 2},
    {2, 0},
    {2, 1},
    {2, 2},
    {3, 2},
    {4, 2},
};

vector<pair<int, int>> f = {
    {0, 0},
    {0, 1},
    {0, 2},
    {1, 0},
    {2, 0},
    {2, 1},
    {3, 0},
    {4, 0},
};


int solve() {
    int n, m;
    if (!(cin >> n >> m)) {
        return 1;
    }
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    int ff = 0, qq = 0;
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (s[i][j] == '#') {
                bool isf = true;
                for (auto [x, y] : f) {
                    if (s[i + x][j + y] == '.') {
                        isf = false;
                        break;
                    }
                }
                if (isf) {
                    ff++;
                    for (auto [x, y] : f) {
                        s[i + x][j + y] = '.';
                    }
                } else {
                    bool isq = true;
                    for (auto [x, y] : q) {
                        if (s[i + x][j + y] == '.') {
                            isq = false;
                            break;
                        }
                    }
                    if (isq) {
                        qq++;
                        for (auto [x, y] : q) {
                            s[i + x][j + y] = '.';
                        }
                    } else {
                        assert(0);
                    }
                }
            }
        }
    }
    cout << qq << ' ' << ff << '\n';
    return 0;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
