#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    // Code here:

    int t;
    cin >> t;
    vector<vector<pair<string, string>>> ops(t);
    int m = 0;
    for (int i = 0; i < t; i++) {
        int l;
        cin >> l;
        m += l;
        for (int j = 0; j < l; j++) {
            string w;
            cin >> w;
            auto it = find(all(w), '=');
            int k = it - w.begin();
            ops[i].emplace_back(w.substr(0, k),
                                w.substr(k + 1, w.size() - k - 1));
        }
    }

    map<string, string> vals;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;
        vals[a] = b;
    }

    vector<int> ptr(t);
    for (int i = 0; i < t; i++) {
        ptr[i] = ops[i].size() - 1;
    }
    set<string> assigned;
    vector<int> ans(m);
    for (int i = m - 1; i >= 0; i--) {
        int aj = -1;
        for (int j = 0; j < t; j++) {
            if (ptr[j] == -1) {
                continue;
            }
            if (assigned.count(ops[j][ptr[j]].first)) {
                aj = j;
                break;
            }
            if (ops[j][ptr[j]].second == vals[ops[j][ptr[j]].first]) {
                aj = j;
                break;
            }
        }
        if (aj == -1) {
            cout << "No" << endl;
            return 0;
        }
        ans[i] = aj;
        assigned.insert(ops[aj][ptr[aj]].first);
        ptr[aj]--;
    }

    cout << "Yes" << endl;
    forn(i, m) { cout << ans[i] + 1 << " "; }
    cout << endl;

    return 0;
}
