#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#ifndef MY
    #define endl '\n'
#endif
#define int long long
#define sz(x) (int)x.size()

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;



const int inf = 1e9 + 7;
const int N = 2e4 + 5;
vector < int > gr[N];
string name[N];
map < string, vector < int >> pos;
int val[N];
bool used[N];
int plc[N];
int clr[N];
vector < int > euler;
int ext[N];

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << clr[a] << "( " << a << " )"<< ' ';
    out << endl;
    return out;
}

void dfs(int v) {
    used[v] = 1;
    for (auto u : gr[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    plc[v] = sz(euler);
    euler.pb(v);
}

void parse(int v) {
    string s;
    cin >> s;
    bool dig = 0;
    for (int i = 0; i < sz(s); i++) {
        if (s[i] == '=') {
            dig = 1;
            continue;
        }
        if (dig) {
            val[v] = val[v] * 10 + (s[i] - '0');
        } else {
            name[v].pb(s[i]);
        }
    }
    pos[name[v]].pb(v);
}

void stop() {
    cout << "No";
    exit(0);
}

void build(string s, int x, int w) {
    vector < int > lst = pos[s];
    for (int i = 0; i < sz(lst) - 1; i++) {
        if (clr[lst[i]] == clr[lst[i + 1]]) {
            ext[lst[i]] = 1;
        }
    }
    for (auto v : lst) {
        if (val[v] == x && !ext[v]) {
            gr[w].pb(v);
        } else {
            gr[v].pb(w);
        }
    }
    if (sz(gr[w]) == 0) {
        stop();
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
    //freopen("f.out", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int sum = 0;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        for (int j = 0; j < m; j++) {
            clr[sum + j] = i + 1;
            if (j) {
                int v = sum + j - 1, u = sum + j;
                gr[v].pb(u);
            }
            parse(sum + j);
        }
        sum += m;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        string s;
        int x;
        cin >> s >> x;
        build(s, x, sum + i);
    }
    sum += q;
    for (int i = 0; i < sum; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }

    for (int v = 0; v < sum; v++) {
        for (auto u : gr[v]) {
            if (plc[v] < plc[u]) {
                stop();
            }
        }
    }
    reverse(all(euler));
    cout << "Yes" << endl;
    for (auto v : euler) {
        if (clr[v]) {
            cout << clr[v] << ' ';
        }
    }
    return 0;
}
