#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <numeric>
#include <functional>
#include <limits>
#include <ctime>
#include <random>
#include <bitset>
#include <numeric>
#include <complex>
#include <stdlib.h>
#include <cassert>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()
#define F first
#define S second
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
//#define int ll

#ifndef _getchar_nolock
#define _getchar_nolock getchar_unlocked
#define _putchar_nolock putchar_unlocked
#endif

#pragma warning(disable : 4996)
//#pragma comment(linker, "/STACK:16777216")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld PI = 3.141592653589793;
const ld EPS = 1e-9;
const int N = (int)2e5 + 10;
const int INF = (int)1e9;
const int MOD = 998244353;

void solve() {
    
    int n;
    cin >> n;
    if (n == 1) {
        cin >> n >> n;
        cout << "Yes\n";
        return;
    }
    vi w(n), b(n);
    set<int> leaf;
    set<int> w0, b0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i] >> b[i];
        if (!w[i] && !b[i]) {
            cout << "No\n";
            return;
        }
        if (w[i] + b[i] == 1) {
            leaf.insert(i);
        }
        else {
            if (w[i])
                w0.insert(i);
            if (b[i])
                b0.insert(i);
        }
    }
    vector<pair<pii, char>> ans;
    for (int i = 0; i < n - 2; ++i) {
        if (leaf.empty()) {
            cout << "No\n";
            return;
        }
        int v = *leaf.begin();
        leaf.erase(leaf.begin());
        if (w[v]) {
            if (w0.empty()) {
                cout << "No\n";
                return;
            }
            int u = *w0.begin();
            ans.push_back({ { u, v }, 'W' });
            w[u]--;
            w[v]--;
            if (w[u] == 0 || w[u] + b[u] == 1)
                w0.erase(u);
            if (w[u] + b[u] == 1) {
                b0.erase(u);
                leaf.insert(u);
            }
        }
        else {
            if (b0.empty()) {
                cout << "No\n";
                return;
            }
            int u = *b0.begin();
            ans.push_back({ { u, v }, 'B' });
            b[u]--;
            b[v]--;
            if (b[u] == 0 || w[u] + b[u] == 1)
                b0.erase(u);
            if (w[u] + b[u] == 1) {
                w0.erase(u);
                leaf.insert(u);
            }
        }
    }
    if (leaf.size() != 2) {
        cout << "No\n";
        return;
    }
    int u = *leaf.begin();
    leaf.erase(leaf.begin());
    int v = *leaf.begin();
    if (w[u] != w[v]) {
        cout << "No\n";
        return;
    }
    if (w[u])
        ans.push_back({ {u, v}, 'W' });
    else
        ans.push_back({ {u, v}, 'B' });

    cout << "Yes\n";
    for (int i = 0; i < n - 1; ++i)
        cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' ' << ans[i].second << endl;

    return;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();

    return 0;
}