//#pragma GCC optimize("O3")
////    #pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back
#define pii pair <int, int>
#define ll long long
#define F first
#define S second
#define ld long double
#define int ll
#define sqr(x) (x)*(x)
#define all(x) (x).begin(),(x).end()

using namespace std;
using namespace __gnu_pbds;


template <typename T>
using ordered_set = tree<T, null_type, greater<T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937_64 gen(chrono::high_resolution_clock().now().time_since_epoch().count());


const int MOD = 1e9 + 7;
const int N = 1e6 + 10;
int MX = 0.98 * CLOCKS_PER_SEC;
#ifdef LOCAL
    const int inf = 1e9 + 7;
    const int M = (1 << 20);
#else
    #define cerr if(0) cerr
    const int inf = 1e9 + 7;
    const int M = (1 << 20);
#endif // LOCAL
int pattern_Fy[8] = {0, 0, 0, 0, 0, 1, 2, 1};
int pattern_Fx[8] = {0, -1, -2, -3, -4, -4, -4, -2};

int pattern_Qy[10] = {0, 0, 0, 0, 0, -1, -2, -1, -2, -2};
int pattern_Qx[10] = {0, -1, -2, -3, -4,  -4,  -4,  -2,  -2,  -3};
int n, m;
vector < string > a(500);
bool check_F (int x, int y) {
    for(int i = 0; i < 8; i++) {
        int x1 = x + pattern_Fx[i];
        int y1 = y + pattern_Fy[i];
        if(x1 < 0 || x1 >= n)
            return 0;
        if(y1 < 0 || y1 >= m)
            return 0;
        if(a[x1][y1] == '.') return 0;
    }
    return 1;
}
bool check_Q (int x, int y) {
    for(int i = 0; i < 10; i++) {
        int x1 = x + pattern_Qx[i];
        int y1 = y + pattern_Qy[i];
//        cerr << x1 << " " << y1 <<"\n";
        if(x1 < 0 || x1 >= n)
            return 0;
        if(y1 < 0 || y1 >= m)
            return 0;
        if(a[x1][y1] == '.') return 0;
    }
    return 1;
}
bool clear_Q (int x, int y) {
    for(int i = 0; i < 10; i++) {
        int x1 = x + pattern_Qx[i];
        int y1 = y + pattern_Qy[i];
        a[x1][y1] = '.';
    }
    return 1;
}
bool clear_F (int x, int y) {
    for(int i = 0; i < 8; i++) {
        int x1 = x + pattern_Fx[i];
        int y1 = y + pattern_Fy[i];
        a[x1][y1] = '.';
    }
    return 1;
}
main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#else
//    freopen("input.txt","r",stdin);
//    freopen("output.txt","w",stdout);
#endif LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 0; i < n; i++)
        cin >> a[i];
        int k1 = 0;
        int k2 = 0;
    for(int i = n - 1; i >= 0; i--) {
        for(int j =  m - 1; j >= 0; j--) {
            if(a[i][j] != '.') {
                if(check_F(i, j) && !check_Q(i, j)){
                    k1++;
                    clear_F(i, j);
                }
                if(!check_F(i, j) && check_Q(i, j)) {
                    k2++;
                    clear_Q(i, j);
                }
            }
        }
    }
    cout << k2 << " " << k1 <<"\n";
    return 0;
}
