#pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <map>
#include <vector>
#include <deque>
#include <algorithm>
#include <bitset>
#include <cstring>
#include <math.h>
#include <string>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <complex>
#include <random>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;
#define pb push_back
#define ll long long
#define mp make_pair
#define snd second
#define ins insert
//#define ld long double
#define mt make_tuple
#define fst first
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
const double PI = acos(-1);
// = 5e5 + 17;
const int MOD1 = 998244353;
const int MOD = 1'000'000'007;
const int INF = 1e9;
const int MaXN = 150;
const int N = 1e8 + 1000;
const int LOG = 25;
const int FACT = 120;

mt19937 rng(239);

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

pair<ll, ll> gcd_eu(ll a, ll b) {
	if (b == 0) return mp(1, 0);
	auto res = gcd_eu(b, a % b);
	swap(res.first, res.second);
	res.second -= (a / b) * res.first;
	return res;
}

pair<ll, ll> long_ans(ll n, ll a, ll b) {
	auto res = gcd_eu(a, b);
	ll g = gcd(a, b);
	res.first *= n / g;
	res.second *= n / g;

	if (res.first < 0) {
		ll times = (-res.first-1) / b + 1;
		res.first += times * b;
		res.second -= times * a;
	}
	if (res.second < 0) {
		ll times = (-res.second-1) / a + 1;
		res.first -= times * b;
		res.second += times * a;
	}

	return res;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, c;
	cin >> n >> m >> c;

	vector<bool> bp(m * c);
	bp[0] = true;
	vector<int> miles(m * c);
	vector<int> cables(m * c);

	for (int i = 0; i < m * c; i++) {
		if (i - m >= 0 && bp[i - m]) {
			bp[i] = true;
			miles[i] = miles[i - m] + 1;
			cables[i] = cables[i - m];
		}
		if (i - c >= 0 && bp[i - c]) {
			bp[i] = true;
			miles[i] = miles[i - c];
			cables[i] = cables[i - c] + 1;
		}
	}

	for (int i = 0;; i++) {
		int diff = i / 2;
		if (i % 2 == 0) diff *= -1;
		ll pt = n + diff;
		if (pt < 0) continue;
		if (pt >= m * c) {
			if (pt % gcd(m, c) == 0) {
				auto res = long_ans(pt, m, c);
				cout << res.first << ' ' << res.second << endl;
				break;
			}
			continue;
		}
		if (bp[pt]) {
			cout << miles[pt] << ' ' << cables[pt] << endl;
			break;
		}
	}

	return 0;
}