#pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <map>
#include <vector>
#include <deque>
#include <algorithm>
#include <bitset>
#include <cstring>
#include <math.h>
#include <string>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <complex>
#include <random>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;
#define pb push_back
#define ll long long
#define mp make_pair
#define snd second
#define ins insert
//#define ld long double
#define mt make_tuple
#define fst first
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
const double PI = acos(-1);
// = 5e5 + 17;
const int MOD1 = 998244353;
const int MOD = 1'000'000'007;
const int INF = 1e9;
const int MaXN = 150;
const int N = 1e8 + 1000;
const int LOG = 25;
const int FACT = 120;

mt19937 rng(239);

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

pair<ll, ll> gcd_eu(ll a, ll b) {
	if (b == 0) return mp(1, 0);
	auto res = gcd_eu(b, a % b);
	swap(res.first, res.second);
	res.second -= (a / b) * res.first;
	return res;
}

pair<ll, ll> long_ans(ll n, ll a, ll b) {
	auto res = gcd_eu(a, b);
	ll g = gcd(a, b);
	res.first *= n / g;
	res.second *= n / g;

	if (res.first < 0) {
		ll times = (-res.first-1) / b + 1;
		res.first += times * b;
		res.second -= times * a;
	}
	if (res.second < 0) {
		ll times = (-res.second-1) / a + 1;
		res.first -= times * b;
		res.second += times * a;
	}

	return res;
}

template<class T>
T up(T n)
{
	T r = 1;

	while (r < n)
		r *= 2;

	return r;
}


template<class T>
class segtree
{
	vector<pair<T, int>> arr;
	vector<bool> laz;
	vector<T> add;


	void push(int v)
	{
		if (laz[v])
		{
			laz[v] = false;
			arr[v].first = 0;

			if (v < arr.size() / 2)
			{
				add[2 * v] = 0;
				laz[2 * v] = true;
				add[2 * v + 1] = 0;
				laz[2 * v + 1] = true;
			}
		}
		if (add[v] != 0)
		{
			arr[v].first += add[v];

			if (v < arr.size() / 2)
			{
				add[2 * v] += add[v];
				add[2 * v + 1] += add[v];
			}

			add[v] = 0;
		}
	}


	void upd(int v)
	{
		push(v);

		if (v < arr.size() / 2)
		{
			push(2 * v);
			push(2 * v + 1);

			arr[v] = max(arr[2 * v], arr[2 * v + 1]);
		}
	}


	pair<T, int> segmax(int l, int r, int cl, int cr, int v)
	{
		if (r <= cl || cr <= l)
			return { numeric_limits<T>::lowest(), -1 };
		push(v);
		if (l <= cl && cr <= r)
			return arr[v];

		auto ct = (cl + cr) / 2;

		auto ans = max(segmax(l, r, cl, ct, 2 * v), segmax(l, r, ct, cr, 2 * v + 1));

		upd(v);

		return ans;
	}


	void segnull(int l, int r, int cl, int cr, int v)
	{
		if (r <= cl || cr <= l)
			return;
		push(v);
		if (l <= cl && cr <= r)
		{
			laz[v] = true;

			return;
		}

		auto ct = (cl + cr) / 2;

		segnull(l, r, cl, ct, 2 * v);
		segnull(l, r, ct, cr, 2 * v + 1);

		upd(v);
	}


	void segadd(int l, int r, int cl, int cr, int v, const T &x)
	{
		if (r <= cl || cr <= l)
			return;
		push(v);
		if (l <= cl && cr <= r)
		{
			add[v] += x;

			return;
		}

		auto ct = (cl + cr) / 2;

		segadd(l, r, cl, ct, 2 * v, x);
		segadd(l, r, ct, cr, 2 * v + 1, x);

		upd(v);
	}


public:
	explicit segtree(size_t n = 0) : arr(2 * up(n)), laz(2 * up(n)), add(2 * up(n))
	{
		for (int j = 0; j < n; j++)
			arr[j + arr.size() / 2].second = j;
		for (int j = (int)arr.size() / 2 - 1; j > 0; j--)
			arr[j] = max(arr[2 * j], arr[2 * j + 1]);
	}


	auto segmax(int l, int r)
	{
		return segmax(l, r, 0, arr.size() / 2, 1);
	}


	auto segnull(int l, int r)
	{
		return segnull(l, r, 0, arr.size() / 2, 1);
	}


	auto segadd(int l, int r, const T &x = 1)
	{
		return segadd(l, r, 0, arr.size() / 2, 1, x);
	}
};

ll sqr(ll a) {
	return a * a;
}

ll pow(ll a, ll n, ll mod) {
	if (n == 0) return 1;
	if (n % 2 == 0) return sqr(pow(a, n / 2, mod)) % mod;
	return (a * pow(a, n - 1, mod)) % mod;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> bochka(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> bochka[i][j];
		}
	}

	ll rev_m = pow(m, MOD1 - 2, MOD1);

	vector<ll> fact(1000), ofact(1000);
	fact[0] = 1;
	for (int i = 1; i < 1000; i++) fact[i] = (fact[i - 1] * i) % MOD1;
	ofact.back() = pow(fact.back(), MOD1 - 2, MOD1);
	for (int i = 999; i >= 1; i--) ofact[i - 1] = (ofact[i] * i) % MOD1;

	vector<ll> ans(n);

	for (int t = 0; t < m; t++) {
		vector<vector<ll>> time_prob(n, vector<ll>(k + 1));
		for (int i = 0; i < n; i++) {
			if (bochka[i][t] == 0) continue;
			vector<vector<ll>> set_amt(m, vector<ll>(k + 1));
			set_amt[0][0] = 1;
			for (int j = 0; j < m; j++) {
				if (j == t) continue;
				for (int pos = k - bochka[i][j]; pos >= 0; pos--) {
					for (int solved = min(j, m - 2); solved >= 0; solved--) {
						set_amt[solved + 1][pos + bochka[i][j]] += set_amt[solved][pos];
						if (set_amt[solved + 1][pos + bochka[i][j]] >= MOD1) set_amt[solved + 1][pos + bochka[i][j]] -= MOD1;
					}
				}
			}
			for (int j = bochka[i][t]; j <= k; j++) {
				for (int solved = 0; solved < m; solved++) {
					time_prob[i][j] += ((((((((set_amt[solved][j - bochka[i][t]] * fact[solved]) % MOD1) * fact[m - 1 - solved]) % MOD1) * ofact[m - 1]) % MOD1) * rev_m) % MOD1);
				}
				time_prob[i][j] %= MOD1;
			}
		}
		vector<ll> already_solved(n);
		for (int pos = 0; pos < k; pos++) {
			int zero_amt = 0;
			ll prod = 1;
			for (int i = 0; i < n; i++) {
				already_solved[i] += time_prob[i][pos];
				if (already_solved[i] >= MOD1) already_solved[i] -= MOD1;
				if (already_solved[i] == 1) zero_amt++;
				else prod = (prod * (MOD1 + 1 - already_solved[i])) % MOD1;
			}

			for (int i = 0; i < n; i++) {
				if (zero_amt - (already_solved[i] == 1 ? 1 : 0) > 0) continue;
				else {
					ans[i] += ((prod * (already_solved[i] == 1 ? 1 : pow(MOD1 + 1 - already_solved[i], MOD1 - 2, MOD1))) % MOD1) * time_prob[i][pos + 1];
					ans[i] %= MOD1;
				}
			}
		}
	}

	for (int i = 0; i < n; i++) cout << ans[i] << endl;

	return 0;
}