#include <bits/stdc++.h>
using namespace std;

// #define constexpr(...) (__VA_ARGS__)  
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
// for matching the kactl notes
#define sz(x) ((int)x.size())
#define rep(i,a,b) for (int i = (int)(a); i < (int)(b); ++i) 
#define all(a) (a).begin(), (a).end()
#define print_op(...) ostream& operator<<(ostream& out, const __VA_ARGS__& u)
// DEBUGING TEMPLETE ////////////////////////////////////////////////////////////////////////{{{
// What? You wanted to see how this template works?  Check this out:
// https://quangloc99.github.io/2021/07/30/my-CP-debugging-template.html
#define db(val) "["#val" = "<<(val)<<"] "
#define CONCAT_(x, y) x##y
#define CONCAT(x, y) CONCAT_(x, y)
#ifdef LOCAL_DEBUG   
#   define clog cerr << setw(__db_level * 2) << setfill(' ') << "" << setw(0)
#   define DB() debug_block CONCAT(dbbl, __LINE__)
    int __db_level = 0;
    struct debug_block {
        debug_block() { clog << "{" << endl; ++__db_level; }
        ~debug_block() { --__db_level; clog << "}" << endl; }
    };
#else
#   define clog if (0) cerr
#   define DB(...)
#endif

template<class U, class V> print_op(pair<U, V>) {
    return out << "(" << u.first << ", " << u.second << ")";
}
template<class Con, class = decltype(begin(declval<Con>()))>
typename enable_if<!is_same<Con, string>::value, ostream&>::type
operator<<(ostream& out, const Con& con) { 
    out << "{";
    for (auto beg = con.begin(), it = beg; it != con.end(); ++it)
        out << (it == beg ? "" : ", ") << *it;
    return out << "}";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")"; 
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup); 
}
template<class ...U> print_op(tuple<U...>) {
    return print_tuple_utils<0, tuple<U...>>(out, u);
}
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////}}}

struct Op {
    string var;
    ll val;
};
const int maxn = 1010;
int t;
vector<Op> threads[maxn];
map<string, ll> lst_state;

int main() {
#ifdef LOCAL
    freopen("main.inp", "r", stdin); 
    freopen("main.out", "w", stdout);  
    freopen(".log", "w", stderr);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    cin >> t;
    rep(i, 0, t) {
        int l;
        cin >> l;
        while (l--) {
            string line;
            cin >> line;
            for (auto& ch: line) {
                if (ch == '=') ch = ' ';
            }
            stringstream ss;
            ss << line;
            auto& [var_name, val] = threads[i].emplace_back();
            ss >> var_name >> val;
        }
    }
    
    int k;
    cin >> k;
    while (k--) {
        string var_name;
        ll val;
        cin >> var_name >> val;
        lst_state[var_name] = val;
    }
    
    vector<int> res;
    while (true) {
        bool ok = false;
        bool all_done = true;
        rep(i, 0, t) {
            while (sz(threads[i])) {
                auto& [name, val] = threads[i].back();
                auto it = lst_state.find(name);
                if (it == lst_state.end() or it->second == val) {
                    ok = true;
                    res.push_back(i);
                    if (it != lst_state.end()) lst_state.erase(it);
                    threads[i].pop_back();
                } else {
                    break;
                }
            }
            if (sz(threads[i])) all_done = false;
        }
        if (all_done) break;
        if (!ok) {
            cout << "No\n";
            return 0;
        }
    }
    cout << "Yes\n";
    reverse(all(res));
    for (auto i: res) cout << i + 1 << ' ';
    
    return 0;
}

// vim: foldmethod=marker

