﻿#include <math.h>
#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <complex>
#include <ctime>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

//#define int long long

#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

mt19937 mrand(random_device{}());

const double pi = acos((double) -1);
const ld eps = 1e-8;
const int inf0 = 1023 * 1024 * 1024;
const ll inf = 4e18;
const ll mod = 1e9 + 7;
//const ll mod = 998244353;

void solve();

signed main() {
#ifdef DEBUG
  freopen("test.in", "r", stdin);
  freopen("test.out", "w", stdout);
#endif
  cin.tie(nullptr);
  cout.tie(nullptr);
  ios_base::sync_with_stdio(false);
  cout << fixed;
  cout.precision(15);
  solve();
  return 0;
}

pair<string, ll> parse(string s) {
  string f1 = "";
  ll f2 = 0;
  bool fl = false;
  for(char c : s) {
    if(c == '=') {
      fl = true;
      continue;
    }
    if(!fl)
      f1 += c;
    else {
      f2 *= 10;
      f2 += (c - '0');
    }
  }
  return {f1, f2};
}

void solve() {
  int n; cin >> n;
  vector<vector<pair<string, ll>>> a(n);
  int m = 0;
  for(int i = 0; i < n; i++) {
    int l; cin >> l;
    m += l;
    a[i].resize(l);
    for(int j = 0; j < l; j++) {
      string s; cin >> s;
      a[i][j] = parse(s);
    }
  }
  map<string, int> right;
  int k; cin >> k;
  while(k--) {
    string s; cin >> s;
    int x; cin >> x;
    right[s] = x;
  }
  set<string> used;
  vector<int> ans;
  while(m--) {
    bool fl = false;
    for(int i = 0; i < n; i++) {
      if(a[i].empty()) continue;
      auto v = a[i].back();
      if(used.find(v.first) != used.end()) {
        a[i].pop_back();
        ans.push_back(i);
        fl = true;
        break;
      }
      if(v.second == right[v.first]) {
        a[i].pop_back();
        used.insert(v.first);
        ans.push_back(i);
        fl = true;
        break;
      }
    }
    if(!fl) {
      cout << "No" << endl;
      return;
    }
  }
  cout << "Yes" << endl;
  reverse(all(ans));
  for(int i : ans)
    cout << i + 1 << " ";
}