#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &i : x) cin >> i; }
#define out(x); { for (auto &i : x) cout << i << ' '; cout << endl; }

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e9;
const long long INFll = 1e18;
const long long mod = 1000000007;
const int base1 = 239;
const int base2 = 653;
const long double eps = 1e-4;
const long double pi = acos(-1);
const int N = 4e5 + 10;

vector <int> g[N], w[N];
int d[N], dn[N];
int mnf[N], mxf[N], mnt[N], mxt[N];
int mnfp[N], mxfp[N], mntp[N], mxtp[N];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x, y, c; cin >> x >> y >> c;
        g[x].pb(y); w[x].pb(c);
        g[y].pb(x); w[y].pb(c);
    }

    fill(d, d + N, INF);
    d[1] = 0;
    queue <int> q;
    q.push(1);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (d[i] == INF) {
                d[i] = d[v] + 1;
                q.push(i);
            }
        }
    }

    fill(dn, dn + N, INF);
    dn[n] = 0;
    q.push(n);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (dn[i] == INF) {
                dn[i] = dn[v] + 1;
                q.push(i);
            }
        }
    }

    vector <int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = i + 1;

    sort(all(a), [](int i, int j) { return (d[i] < d[j]); });
    fill(mnf, mnf + N, INF);
    fill(mxf, mxf + N, -INF);
    for (int i = 1; i < n; i++) {
        int v = a[i];

        for (int j = 0; j < g[v].size(); j++) {
            int u = g[v][j], c = w[v][j];
            if (d[u] == d[v] - 1) {
                if (min(c, mnf[u]) < mnf[v]) {
                    mnf[v] = min(c, mnf[u]);
                    mnfp[v] = u;
                }
                if (max(c, mxf[u]) > mxf[v]) {
                    mxf[v] = max(c, mxf[u]);
                    mxfp[v] = u;
                }
            }
        }
    }

    sort(all(a), [](int i, int j) { return (dn[i] < dn[j]); });
    fill(mnt, mnt + N, INF);
    fill(mxt, mxt + N, -INF);
    for (int i = 1; i < n; i++) {
        int v = a[i];

        for (int j = 0; j < g[v].size(); j++) {
            int u = g[v][j], c = w[v][j];
            if (dn[u] == dn[v] - 1) {
                if (min(c, mnt[u]) < mnt[v]) {
                    mnt[v] = min(c, mnt[u]);
                    mntp[v] = u;
                }
                if (max(c, mxt[u]) > mxt[v]) {
                    mxt[v] = max(c, mxt[u]);
                    mxtp[v] = u;
                }
            }
        }
    }

    int ans = 0, ansv = 0;
    for (int i = 1; i <= n; i++) {
        //cout << mnfp[i] << ' ' << mxfp[i] << ' ' << mntp[i] << ' ' << mxtp[i] << endl;
        if (mxf[i] - mnt[i] > ans) {
            ans = mxf[i] - mnt[i];
            ansv = i;
        }
        if (mxt[i] - mnf[i] > ans) {
            ans = mxt[i] - mnf[i];
            ansv = -i;
        }
    }

    cout << d[n] << "\n";

    if (ansv > 0) {
        vector <int> from;
        for (int v = mxfp[ansv]; v != 1; v = mxfp[v]) {
            from.pb(v);
        }
        vector <int> to;
        for (int v = mntp[ansv]; v != n; v = mntp[v])
            to.pb(v);
        reverse(all(from));
        cout << "1 ";
        for (int i : from)
            cout << i << " ";
        cout << ansv << " ";
        for (int i : to)
            cout << i << " ";
        cout << n;
    } else {
        ansv *= -1;
        vector <int> from;
        for (int v = mnfp[ansv]; v != 1; v = mnfp[v])
            from.pb(v);
        vector <int> to;
        for (int v = mxtp[ansv]; v != n; v = mxtp[v]) {
            to.pb(v);
        }
        reverse(all(from));
        cout << "1 ";
        for (int i : from)
            cout << i << " ";
        cout << ansv << " ";
        for (int i : to)
            cout << i << " ";
        cout << n;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
