#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <iomanip>
#include <map>
#include <complex>
#include <queue>
#include <cassert>
#include <chrono>
#include <random>
#include <climits>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define debug(x) cout << #x << " = " << x << endl
#define all(a) begin(a), end(a)
#define sqr(x) ((x) * (x))
//#define int long long

using namespace std;

template<class Iter> 
void print(Iter l, Iter r) {
    cout << "[";
    for (auto it = l; it != r; ++it) {
        if (it != l) {
            cout << ", ";   
        }
        cout << *it;
    }
    cout << "]" << endl;
}

template<class C, class F> 
ostream& operator<<(ostream &out, pair<C, F> p) {
    return out << "(" << p.first << ", " << p.second << ")";
}

using ll = long long;

mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); 

    string a1, a2, b1, b2, c1, c2;
    cin >> a1 >> a1 >> a1 >> a2;
    cin >> b1 >> b1 >> b1 >> b2;
    cin >> c1 >> c2;

    bool min = (b2 == "Yes");
    bool max = (a2 == "Yes");
    bool plat = (c2 == "Yes");

    if (min && !max && !plat) {
        cout << "x y + 1 + 2 ^";
    } 

    if (!min && !max && !plat) {
        cout << "x y +";
    }

    if (plat && !max && !min) {
        cout << "1 ";
    } 



    if (plat && min && !max) {
        cout << "y x 2 ^ - 2 ^ x 1 - 2 ^ +";
    }




    if (min && max && plat) {
        cout << "y 6 + y 5 + * y 4 + * y 3 + * y 2 + * y 1 + * y * y 1 - * y 2 - * y 3 - * y 4 - * y 5 - * y 6 - * x 5 ^ + 3 x 4 ^ * - 3 x 3 ^ * - 10 x 2 ^ * + 1 -";
    }



    if (max && plat && !min) {
        cout << "y 6 + y 5 + * y 4 + * y 3 - * y 4 - * y 5 - * y 6 - * x 5 ^ + 3 x 4 ^ * - 3 x 3 ^ * - 10 x 2 ^ * + 1 -";
    }



    if (max && min && !plat) {
        cout << "y 3 + y 1 + * y 2 - * y 5 - * x 5 ^ + 3 x 4 ^ * - 3 x 3 ^ * - 10 x 2 ^ * + 1 -";
    }


    if (max && !min && !plat) {
        cout << "y y 2 + * y 2 - * y 4 - * y 6 - * 2 x 2 ^ * - 8 x * + 1 +";
    }

    return 0;
}