﻿#include <iostream>
#include <fstream>
#include <cstdio>

#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <stack>

#include <functional>
#include <utility>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <iomanip>
#include <numeric>

#include <cassert>
#include <random>
#include <chrono>

#include <complex>
#include <climits>

using namespace std;

#define ll long long
#define prll pair<ll,ll>
#define prii pair<int,int>
#define m_p make_pair
#define INF (ll)LLONG_MAX

namespace __time {
	clock_t t;
	double get_time() {
		return (double)(clock() - t) / CLOCKS_PER_SEC;
	}
}
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const int H = 300 + 5;
char mt[H][H];

void uncolor_f(int a, int b) {
	for (int i = a; i < a + 5; ++i) {
		mt[i][b] = '.';
	}
	mt[a][b + 1] = mt[a][b + 2] = '.';
	mt[a + 2][b + 1] = '.';
}

void uncolor_q(int a, int b) {
	for (int i = a; i < a + 5; ++i)
		mt[i][b + 2] = '.';
	mt[a][b] = mt[a][b + 1] = '.';
	mt[a + 1][b] = '.';
	mt[a + 2][b] = mt[a + 2][b + 1] = '.';
}

int n, m;
void print() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << mt[i][j];
		}
		cout << '\n';
	}
}

void $main() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		string s; cin >> s;
		for (int j = 0; j < m; ++j)
			mt[i][j] = s[j];
	}

	int Q = 0, F = 0;
	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; ++i) {
			if (mt[i][j] == '.') continue;

			int ct = 0;
			for (int k = 0; k < 5; ++k)
				ct += (mt[i + k][j] == '#');
			while (ct != 3 && ct != 5) {};

			if (ct == 3) {
				++Q;
				uncolor_q(i, j);
			}
			else {
				++F;
				uncolor_f(i, j);
			}
			//print();
		}
	}
	cout << Q << " " << F;
}

int main()
{
	setlocale(LC_ALL, "Russian");

#ifndef ONLINE_JUDGE
	//freopen("input.txt", "r", stdin);
#else
	//freopen("kbest.in", "r", stdin);
	//freopen("kbest.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	//__time::t = clock();
	//ll t; cin >> t;
	//while (t--)
	$main();

	return 0;
}