/*
❤️❤️❤️I_love_QMsh❤️❤️❤️
*/
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds; // gp_hash_table<int, int> table;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set; // <int> .find_by_order(int) .order_of_key(int)

template<typename T> bool smin(T &a, const T &b) { bool ret = b < a; return a = (ret ? b : a), ret; }
template<typename T> bool smax(T &a, const T &b) { bool ret = a < b; return a = (ret ? b : a), ret; }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

mt19937 rnd;


const int L = 0;
const int R = 1 << 30;

struct V {
  int ans = 0;
  int l = 0;
  int r = 0;
  int sz = 1;
  V(bool ok = 0) {
    if (ok) {
      ans = 1;
      l = 1;
      r = 1;
    }
  }
};

V merge(const V &a, const V &b) {
  V res;
  res.sz = a.sz + b.sz;

  if (a.ans == a.sz) {
    res.l = a.sz + b.l;
  } else {
    res.l = a.l;
  }

  if (b.ans == b.sz) {
    res.r = b.sz + a.r;
  } else {
    res.r = b.r;
  }

  res.ans = max({a.ans, b.ans, a.r + b.l});
  return res;
}

struct T {
  T *l = 0;
  T *r = 0;

  V val{};
  int cnt = 0;

  void create() {
    if (!l) {
      l = new T();
    }
    if (!r) {
      r = new T();
    }
  }
};

void upd(T *t, int p, int x, int l = L, int r = R) {
  if (p < l || r <= p) {
    return;
  }

  if (l + 1 == r) {
    t->cnt += x;
    t->val = V(t->cnt > 0);
    return;
  }
  t->create();

  int m = (l + r) / 2;
  upd(t->l, p, x, l, m);
  upd(t->r, p, x, m, r);
  t->val = merge(t->l->val, t->r->val);
}

int get(T *t) {
  return t->val.ans;
}

void solve() {
  int n, m;
  cin >> n >> m;

  T *t = new T();

  map<int, vector<int>> events;

  for (int i = 0; i < n; i++) {
    int x;
    cin >> x;
    upd(t, x / m, 1);
    events[m - x % m].push_back(x / m);
  }

  pair<int, int> ans = {0, 0};

  smax(ans, {get(t), 0});

  for (auto &[tm, evs] : events) {
    for (auto &i : evs) {
      upd(t, i, -1);
      upd(t, i + 1, 1);
    }
    if (tm < m) {
      smax(ans, {get(t), tm});
    }
  }

  cout << ans.x << " " << ans.y << "\n";
}

signed main() {
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }


  return 0;
}

// check multiset.erase(multiset.find());
// check long long and overflows;
