#include <bits/stdc++.h>

using namespace std;

#define len(x) (int)(x).size()
#define all(x) x.begin(), x.end()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    cout.setf(ios::fixed), cout.precision(20);
}

constexpr int mod = 1000000007;

void explore(const function<long long(long long, long long)> &f) {
    long long spec = -22222222222222L;
    map<long long, map<long long, long long>> keks;
    for (long long x = -10; x <= 10; x++) {
        for (long long y = -10; y <= 10; y++) {
            assert(f(x, y) <= INT_MAX);
            keks[x][y] = f(x, y);
        }
    }
    bool hasMin = false;
    bool hasMax = false;
    bool hasStale = false;
    for (long long x = -9; x <= 9; x++) {
        for (long long y = -9; y <= 9; y++) {
            if (keks[x][y] < min({keks[x + 1][y], keks[x][y + 1], keks[x - 1][y], keks[x][y - 1]})) {
                hasMin = true;
            }
            if (keks[x][y] > max({keks[x + 1][y], keks[x][y + 1], keks[x - 1][y], keks[x][y - 1]})) {
                hasMax = true;
            }
            if (max({keks[x + 1][y], keks[x][y + 1], keks[x - 1][y], keks[x][y - 1], keks[x][y]}) ==
                min({keks[x + 1][y], keks[x][y + 1], keks[x - 1][y], keks[x][y - 1], keks[x][y]})) {
                hasStale = true;
            }
        }
    }

    for (long long x = -10; x <= 10; x += 20) {
        for (long long y = -10; y <= 10; y += 20) {
            if ((keks[x][y] == keks[x + 1][y] || keks[x + 1][y] == spec) &&
                (keks[x][y] == keks[x - 1][y] || keks[x - 1][y] == spec) &&
                (keks[x][y] == keks[x][y + 1] || keks[x][y + 1] == spec) &&
                (keks[x][y] == keks[x][y - 1] || keks[x][y - 1] == spec)) {
                hasStale = true;
            }
        }
    }

    cout << "hasMax: " << hasMax << "\n";
    cout << "hasMin: " << hasMin << "\n";
    cout << "hasStale: " << hasStale << "\n";


}

/*
 *
 *
 * min stale  x*x + y*y
 * max stale (x + y - 20) * (x + y - 19) * (x + y - 19) * (x * x + y * y)
 * min max (x+y+2)*(x+y)*(x+y)*(x+y-2)
 */

void solve() {
    string str;
    getline(cin, str);
    bool a = str.back() != 'o';
    getline(cin, str);
    bool b = str.back() != 'o';
    getline(cin, str);
    bool c = str.back() != 'o';
//    if (c) throw(1);
    map<bool, map<bool, map<bool, string>>> ans;
    ans[0][0][0] = "x 3 - 4 ^ y -5 + 2 ^ +";
    ans[0][0][1] = "1";
    ans[0][1][0] = "x y + 2 + x y + * x y + * x y + -2 + * x 4 ^ +";
    ans[0][1][1] = "y -6 + y -3 + * y 3 + * y 6 + * x -2 + * x 2 + * -1 *";
    ans[1][0][0] = "x y + 2 + x y + * x y + * x y + -2 + * x 4 ^ + -1 *";
    ans[1][0][1] = "y -6 + y -3 + * y 3 + * y 6 + * x -2 + * x 2 + *";
    ans[1][1][0] = "x y + 2 + x y + * x y + * x y + -2 + *";
    ans[1][1][1] = "y -6 + y -3 + * y 3 + * y 6 + * x -2 + * x 2 + * x *";
    cout << ans[a][b][c];
}

int main() {
#ifdef SIGUSR1
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    fastio();

    int cases = 1;
//    cin >> cases;
    for (int case_i = 1; case_i <= cases; ++case_i) {
        solve();
    }

    return 0;
}
