#include <locale.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <iterator>
#include <sstream>
#include <map>
#include <math.h>
#include <stdio.h>
#include <stack>
#include <random>  
#include <ctime>  
#include <queue>
#include <set>
using namespace std;
using ld = long double;
using ll = long long;

ll mod = 1e9 + 7;
int const N = 3e5 + 100;

mt19937 rnd;

ll  random(ll  limit)
{
	uniform_int_distribution <ll > uniform_dist(0, limit);
	return uniform_dist(rnd);
}


ll bpow(ll a, ll p) {
	ll res = 1;
	while (p > 0) {
		if (p % 2) {
			res = res * a % mod;
		}
		a = a * a % mod;
		p /= 2;
	}
	return res;
} 


ll inv(ll a) {
	return bpow(a, mod - 2);
}


ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}


void kek(vector<vector<pair<int, int>>> g, vector<int>& d1, vector<int>& mi1, vector<int>& par1, int n, int st) {

	set<vector<int>> s1;
	vector<int> fin1(n, 0);
	d1[st] = 0;
	mi1[st] = 1e9;
	s1 = { {d1[st], (int)1e9, st} };
	fin1[st] = 1;


	while (!s1.empty()) {

		auto p = *(s1.begin());
		int u = p[2];
		fin1[u] = 1;
		s1.erase(p);
		for (auto p1 : g[u]) {
			int w = p1.first;
			if (fin1[w] == 0) {
				if (d1[w] > d1[u] + 1 || (d1[w] == d1[u] + 1 && mi1[w] > min(mi1[u], p1.second))) {

					vector<int> v1 = { d1[w], mi1[w], w };
					s1.erase(v1);

					d1[w] = d1[u] + 1;
					par1[w] = u;
					mi1[w] = min(mi1[u], p1.second);

					v1 = { d1[w], mi1[w], w };
					s1.insert(v1);
				}
			}
		}
	}
}


void solve() {
	
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int,int>>> g(n), mg(n);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		--a;
		--b;
		
		g[a].push_back({ b,c });
		g[b].push_back({ a,c });

		mg[a].push_back({ b,-c });
		mg[b].push_back({ a,-c });
	}

	
	vector<int> d1(n, 1e9), mi1(n, 1e9), par1(n, 1e9);
	
	kek(g, d1, mi1, par1, n, 0);

	vector<int> d2(n, 1e9), mi2(n, 1e9), par2(n, 1e9);

	kek(g, d2, mi2, par2, n, n - 1);


	vector<int> d3(n, 1e9), ma1(n, 1e9), par3(n, 1e9);

	kek(mg, d3, ma1, par3, n, 0);

	vector<int> d4(n, 1e9), ma2(n, 1e9), par4(n, 1e9);

	kek(mg, d4, ma2, par4, n, n - 1);

	int maxdif = 0;
	int bestv = 0;
	int bestq = 1;

	for (int i = 1; i < n - 1; i++) {
		if (-ma2[i] - mi1[i] > maxdif) {
			maxdif = -ma2[i] - mi1[i];
			bestv = i;
			bestq = 1;
		}

		if (-ma1[i] - mi2[i] > maxdif) {
			maxdif = -ma1[i] - mi2[i];
			bestv = i;
			bestq = 2;
		}

	}
	
	vector<int> beg_way;
	vector<int> end_way;

	int cur = bestv;

	while(cur!= 0) {
		if (bestq == 1)
		{
			cur = par1[cur];
			beg_way.push_back(cur);
		}

		else {
			cur = par3[cur];
			beg_way.push_back(cur);
		}
	}


	cur = bestv;

	while (cur != n-1) {
		if (bestq == 1)
		{
			cur = par4[cur];
			end_way.push_back(cur);
		}

		else {
			cur = par2[cur];
			end_way.push_back(cur);
		}
	}

	reverse(beg_way.begin(), beg_way.end());

	cout << beg_way.size() + end_way.size() << '\n';

	for (auto v : beg_way)
		cout << v + 1 << ' ';

	cout << bestv + 1 << ' ';


	for (auto v : end_way)
		cout << v + 1 << ' ';

}



int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	rnd = mt19937(956231);
	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}

}

/*

*/