﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <set>
#include <utility>
#include <iterator>
#include <unordered_set>
#include <map>
#include <random>
#include <climits>
#include <cassert>
#include <queue>
#include <unordered_map>
const int MAXN = 3e5 + 1;
int n,k;
int sz[MAXN], p[MAXN], oldsz[MAXN], deleted[MAXN];
struct node {
    int son[26];
    int term = 0;
    int p = -1;
    int prevCh = -1;
    node() {
        for (int i = 0; i < 26; ++i) {
            son[i] = -1;
        }
    }
    node(int _p, int _prevCh) {
        for (int i = 0; i < 26; ++i) {
            son[i] = -1;
        }
        p = _p;
        prevCh = _prevCh;
    }
};
int it = 1;
node mas[MAXN];
int newNode(int p, int prevCh) {
    mas[it] = node(p, prevCh);
    it++;
    return it - 1;
}
void add(std::string &s) {
    int n = s.size();
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        int c = s[i] - 'a';
        if (mas[cur].son[c] == -1) {
            mas[cur].son[c] = newNode(cur, c);
        }
        cur = mas[cur].son[c];
    }
    mas[cur].term++;
}
std::set<std::pair<int,int>> se;
void dfs(int v, int par = -1) {
    auto cur = mas[v];
    p[v] = par;
    oldsz[v] += cur.term;
    for (int c = 0; c < 26; ++c){
        int sn = cur.son[c];
        if (sn == -1) continue;
        dfs(sn, v);
        oldsz[v] += oldsz[sn];
    }
    if (oldsz[v] <= k)
        se.insert({oldsz[v], -v});
}
void delet(int v){
    if (deleted[v]) return;
    auto cur = mas[v];
    for (int c = 0; c < 26; ++c){
        int sn = cur.son[c];
        if (sn == -1) continue;
        if (deleted[sn]) continue;
        delet(sn);
    }
    deleted[v] = 1;
}
void solve() {
    std::cin >> n >> k;
    for (int i = 0; i < n; ++i){
        std::string s;
        std::cin >> s;
        add(s);
    }
    dfs(0);
    int ans = 0;
    for (int i = 0; i < MAXN; ++i) sz[i] = oldsz[i];
    while(!se.empty()){
        std::pair<int,int> del = *se.rbegin();
        se.erase(del);
        if (deleted[-del.second]) continue;
        delet(-del.second);
        if (del.first == 0) continue;
        ans++;
        int v = -del.second;
        if (p[v] == -1) break;
        sz[p[v]] -= sz[-del.second];
        if (sz[p[v]] <= k) se.insert({sz[p[v]], -p[v]});
        while(p[v] != -1){
            v = p[v];
            if (p[v] == -1) break;
            //if (sz[p[v]] - oldsz[-del.second] > k) break;
            sz[p[v]] -= sz[-del.second];
            if (sz[p[v]] <= k) se.insert({sz[p[v]], -p[v]});
        }
        sz[-del.second] = 0;
    }
    std::cout << ans;
}
signed main(){
    std::ios_base::sync_with_stdio(0); std::cin.tie(0);
    int t = 1;
    while (t--) solve();
    return 0;
}