//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,popcnt,abm,mmx,avx,avx2,tune=native")

#include <bits/stdc++.h>

#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) int((s).size())
#define mkp make_pair
#define pb push_back
#define sqr(s) ((s) * (s))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#ifdef EUGENE
mt19937 rng(1337);
#else
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#endif

int n, m, ans_f, ans_q;
string grid[500];

int f_pat[5][3] = {{1, 1, 1}, {1, 0, 0}, {1, 1, 0}, {1, 0, 0}, {1, 0, 0}};
int q_pat[5][3] = {{1, 1, 1}, {1, 0, 1}, {1, 1, 1}, {0, 0, 1}, {0, 0, 1}};


bool check_for_f(int i, int j) {
    bool ok = true;
    for (int x = 0; x < 5; x++) {
        for (int y = 0; y < 3; y++) {
            if (f_pat[x][y]) {
                ok &= grid[x + i][y + j] == '#';
            }
        }
    }
    if (ok) {
        for (int x = 0; x < 5; x++) {
            for (int y = 0; y < 3; y++) {
                if (f_pat[x][y]) {
                    grid[x + i][y + j] = '.';
                }
            }
        }
        ans_f++;
    }
    return ok;
}

bool check_for_q(int i, int j) {
    bool ok = true;
    for (int x = 0; x < 5; x++) {
        for (int y = 0; y < 3; y++) {
            if (q_pat[x][y]) {
                ok &= grid[x + i][y + j] == '#';
            }
        }
    }
    if (ok) {
        for (int x = 0; x < 5; x++) {
            for (int y = 0; y < 3; y++) {
                if (q_pat[x][y]) {
                    grid[x + i][y + j] = '.';
                }
            }
        }
        ans_q++;
    }
    return ok;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> grid[i];

    for (int x = 0; x <= n - 5; x++) {
        for (int y = 0; y <= m - 3; y++) {
            check_for_f(x, y) || check_for_q(x, y);
        }
    }

    cout << ans_q << " " << ans_f << endl;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
//    cout << fixed << setprecision(12);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}