#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define add push_back
#define f first
#define s second
#define pw(x) (1ll << (x))
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ll INF = (ll)1e9 + 2021;

const int N = 1e5 + 10;
vector <pair <int, int>> gr[N], gr2[N], rgr2[N];
int d[N], dp[N], pred[N], rdp[N], rpred[N];
bool used[N];

void bfs(int n) {
	fill(d, d + n, -24);
	queue <int> q;
	q.push(0);
	d[0] = 0;
	while (sz(q)) {
		int v = q.front(); q.pop();
		for (auto &w : gr[v]) {
			int u = w.f;
			if (d[u] == -24) {
				d[u] = d[v] + 1;
				q.push(u);
			}
		}
	}
}

void calc_dp(int s, int n, vector <pair <int, int>> *gr, int *dp, int *pr) {
	fill(dp, dp + n, INF);
	fill(pr, pr + n, -1);
	fill(used, used + n, 0);
	queue <int> q;
	q.push(s);
	while (sz(q)) {
		int v = q.front(); q.pop();
		for (auto &w : gr[v]) {
			int u = w.f;
			if (min(dp[v], w.s) < dp[u]) {
				dp[u] = min(dp[v], w.s); pr[u] = v;
			}
			if (!used[u]) {
				used[u] = 1;
				q.push(u);
			}
		}
	}
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		gr[u].add({v, c}); gr[v].add({u, c});
	}
	bfs(n);
	for (int i = 0; i < n; i++) {
		for (auto &w : gr[i]) {
			int v = w.f;
			if (d[i] != -24 && d[i] + 1 == d[v]) {
				gr2[i].add({v, w.s}); rgr2[v].add({i, w.s});
			}
		}
	}
	calc_dp(0, n, gr2, dp, pred);
	calc_dp(n - 1, n, rgr2, rdp, rpred);
	/*for (int i = 0; i < n; i++) {
		cerr << d[i] << " ";
	}
	cerr << endl;
	for (int i = 0; i < n; i++) {
		cerr << dp[i] << " ";
	}
	cerr << endl;
	for (int i = 0; i < n; i++) {
		cerr << rdp[i] << " ";
	}
	cerr << endl;*/
	pair <int, pair <int, int>> ans = {-1, {-1, -1}};
	for (int i = 0; i < n; i++) {
		for (auto &w : gr[i]) {
			int v = w.f;
			if (d[i] != -24 && d[i] + 1 == d[v]) {
				int curans = w.s, kek = w.s;
				if (i != 0) {
					kek = min(kek, dp[i]);
				}
				if (v != n - 1) {
					kek = min(kek, rdp[v]);
				}
				curans -= kek;
				ans = max(ans, {curans, {i, v}});
			}
		}
	}
	cout << d[n - 1] << endl;
	vector <int> hui1, hui2;
	int t = ans.s.f;
	while (t != -1) {
		hui1.add(t); t = pred[t];
	}
	reverse(all(hui1));
	t = ans.s.s;
	while (t != -1) {
		hui2.add(t); t = rpred[t];
	}
	for (int i : hui1) {
		cout << i + 1 << " ";
	}
	for (int i : hui2) {
		cout << i + 1 << " ";
	}
}