#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()
 
int n, k;

const int MAX_N = 300'000 + 5, ALPHA = 26;

int go[MAX_N][ALPHA];
bool is_leaf[MAX_N];
int pred[MAX_N];
int answer[MAX_N];
int upped[MAX_N];

int next_id = 1;

void cool_solve(int v) {
    for (int u : go[v]) {
        if (u != 0) {
            cool_solve(u);
        }
    }
    vector<pair<int, int>> children;
    for (int u : go[v]) {
        if (u != 0) {
            children.emplace_back(make_pair(upped[u], u));
        }
    }
    int total_sum = is_leaf[v];
    sort(ALL(children));
    int last_pos = 0;
    int our_ans = 0;
    for (; last_pos < children.size(); ++last_pos) {
        if (total_sum + children[last_pos].first > k) {
            break;
        }
        our_ans += answer[children[last_pos].second];
        total_sum += children[last_pos].first;
    }
    for (; last_pos < children.size(); ++last_pos) {
        our_ans += answer[children[last_pos].second];
        if (children[last_pos].first > 0) {
            our_ans++;
        }
    }
    if (total_sum == k) {
        our_ans++;
        total_sum = 0;
    }
    upped[v] = total_sum;
    answer[v] = our_ans;
}
 
int solve() {
    if (!(cin >> n >> k))
        return 1;

    vector<int> leaves;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int cur_v = 0;
        for (char j : s) {
//            sz[cur_v]++;
            if (go[cur_v][j - 'a'] == 0) {
                go[cur_v][j - 'a'] = next_id++;
            }
            pred[go[cur_v][j - 'a']] = cur_v;
            cur_v = go[cur_v][j - 'a'];
        }
//        sz[cur_v]++;
        is_leaf[cur_v] = true;
        leaves.emplace_back(cur_v);
    }

    cool_solve(0);
    if (upped[0] > 0) {
        answer[0]++;
    }
    cout << answer[0] << '\n';


    return 0;
}
 
signed main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
    freopen("C.out", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1e9;
//    cin >> tests;
    for (int i = 1; i <= tests; i++) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "------------------------------\n";
#endif
    }
}
