#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <iterator>
#include <fstream>
#include <math.h>

#include <vector>
#include <string>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <list>
#include <bitset>
#include <unordered_set>
#include <unordered_map>

#include <random>
#include <ctime>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;
typedef long double ld;

#define FOR(i, from, to) for (int i = from; i < to; i++)
#define ROF(i, from, to) for (int i = from; i > to; i--)

const double PI = 3.141592653589793238463;
const int INF = 0x3f3f3f3f;
const int INFS = 1000000001;
const ll LLINF = 9223372036854775807;
const ll M = 998244353;
const double EPS = 1e-8;

typedef long long int lli;

#define int long long

struct node {
    vector<node *> a = vector<node *>(26, nullptr);
    int sz = 0;
    char val = '*';
    bool used = false;
};

void add(node * curr, string & s, int d) {
    ++curr->sz;
    if (d == s.size()) {
        curr->used = true;
        return;
    }
    if (curr->a[s[d] - 'a'] == nullptr) {
        curr->a[s[d] - 'a'] = new node;
        curr->a[s[d] - 'a']->val = s[d];
    }
    add(curr->a[s[d] - 'a'], s, d + 1);
}

int k, ans = 0;

int dfs(node * v) {
    vector<int> tmp = {};
    int got;
    if (v->used)
        tmp.push_back(1);
    for (auto u : v->a) {
        if (u == nullptr)
            continue;
        got = dfs(u);
        tmp.push_back(got);
    }
    int sum = 0;
    sort(tmp.begin(), tmp.end());
    for (auto x : tmp) {
        sum += x;
    }
    while (sum > k) {
        sum -= tmp.back();
        tmp.pop_back();
        ++ans;
    }
    return sum;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n >> k;
    node * trie = new node;
    string s;
    FOR(i, 0, n) {
        cin >> s;
        add(trie, s, 0);
    }
    int sum = dfs(trie);
    if (sum > 0)
        ++ans;
    cout << ans << "\n";

    return 0;
}
