#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    ll n, m, c;
    cin >> n >> m >> c;

    ll best = -1;
    ll M = 0, C = 0;

    for (ll i = 0; m * i <= n + m; ++i) {
        ll rem = (n - i * m);
        if (rem < 0) rem = 0;
        ll x = rem / c;
        for (ll j = x; j <= x + 1; ++j) {
            ll len = i * m + j * c;
            ll score = abs(len - n);
            if (best == -1 || score < best) {
                best = score;
                M = i;
                C = j;
            }
        }
    }

    cout << M << " " << C << endl;
    return 0;
}
