#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <string>
#include <cmath>
#include <map>
#include <random>
#include <chrono>
#include <fstream>
#include <array>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <list>

using namespace std;

#define pb push_back
#define f first
#define s second
#define ull unsigned long long


typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair<int, int> pii;


const int MAXN = 6 * 1e5 + 10;
const int MAXM = 21;
ll INF = 1e9 + 10;
ll MOD = 1e9 + 7;
ld EPS = 1e-12;


void fastIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

// struct Node {
//     Node to[26];
    
//     Node() {
//         fill(to, to + 26, -1);    
//     }

//     int sz;
// };

int n, k, ver = 1;
int sz[MAXN], cnt[MAXN], to[MAXN][26], par[MAXN];

void add(int u, string s, int pos) {
    sz[u]++;
    if (pos == s.length()) {
        cnt[u]++;
        return;
    }
    int c = s[pos] - 'a';
    if (to[u][c] == -1) {
        to[u][c] = ver++;
        par[to[u][c]] = u;
    }
    add(to[u][c], s, pos + 1);
}

set <pii> st;

void del(int u) {
    st.erase({sz[u], -u});
    for (int i = 0; i < 26; i++) {
        if (to[u][i] != -1) {
            del(to[u][i]);
            to[u][i] = -1;
        }
    }
}

int main() {
    fastIO();
    cin >> n >> k;
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < 26; j++)
            to[i][j] = -1;
    }
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(0, s, 0);
    }
    for (int i = 0; i < ver; i++) {
        if (sz[i] <= k) {
            //cout << sz[i] << ' ' << i << endl;
            st.insert({sz[i], -i});
        }
    }
    par[0] = -1;
    int ans = 0;
    while (true) {
        pii mx = *st.rbegin();
        int ver = -mx.s;
        ans++;
        if (ver == 0)
            break;
        del(ver);
        sz[ver] = 0;
        ver = par[ver];
        while (ver != -1) {
            sz[ver] = cnt[ver];
            for (int i = 0; i < 26; i++) {
                if (to[ver][i] != -1)
                    sz[ver] += sz[to[ver][i]];
            }
            if (sz[ver] <= k) {
                st.insert({sz[ver], -ver});
                ver = par[ver];
            }
            else
                break;
        }
        //return 0;
    }
    cout << ans << endl;
    
    



    return 0;
}

