﻿#define _CRT_SECURE_NO_WARNINGS
#pragma GCC Optimize("Ofast")
#include <string.h>
#include <iostream>
#include <vector>
#include <set>
#include <chrono>
#include <string>
#include <time.h>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <sstream>
#include <cstddef>
#include <cstdio>
#include <memory>
#include <stdexcept>
#include <complex>
#include <array>

using namespace std;
typedef long long ll;

const int maxn = 1e2 + 14, lg = 15;

#define MAXN 500

#include <random>
mt19937 gener(1231512);
#define vec vector
#define vi vector<int>
#define pii pair<int, int>
//#define int long long

bool is_poly(vi& a) {
	for (int i = 0; i < a.size() / 2; ++i)
		if (a[i] != a[a.size() - 1 - i]) return false;
	return 1;
}

int popcount(int x) {
	int z = 0;
	while (x) z += x & 1, x >>= 1;
	return z;
}

const int PRIMEN = 1000000;
int lp[PRIMEN + 1];
vector<int> pr;
void sieve() {
	for (int i = 2; i <= PRIMEN; ++i) {
		if (!lp[i]) {
			lp[i] = i;
			pr.push_back(i);
		}
		for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && i * pr[j] <= PRIMEN; ++j)
			lp[i * pr[j]] = pr[j];
	}
}

bool check(int i, int j, vec<pii>& let, vec<string>& a) {
	for (auto& e : let) {
		int ni = i + e.first, nj = j + e.second;
		if (ni < a.size() && nj < a[0].size()) {
			if (a[ni][nj] != '#') {
				return false;
			}
		}
		else return false;
	}
	return true;
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vec<string> a(n);
	for (auto& e : a) cin >> e;
	vec<pii> f = { {0, 0}, {1, 0}, {2, 0}, {0, 1}, {0,2}, {1, 2}, {0, 3}, {0, 4} },
		q = { {0, 0}, {1, 0},{2, 0}, {0, 1}, {2, 1}, {0, 2}, {1, 2}, {2, 2}, {2, 3}, {2, 4} };
	for (auto& e : f) swap(e.first, e.second);
	for (auto& e : q) swap(e.first, e.second);
	int fcnt = 0, qcnt = 0;
	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; ++i) {
			if (check(i, j, f, a)) {
				++fcnt;
				for (auto& e : f) a[i + e.first][j + e.second] = '.';
			}
			else if (check(i, j, q, a)) {
				++qcnt;
				for (auto& e : q) a[i + e.first][j + e.second] = '.';
				//break;
			}

		}
	}

	cout << qcnt << " " << fcnt << "\n";
}
