#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef long long ll;

vector <pair <int, int>> st[110];
int varcount = 0;
unordered_map <string, int> varid;
vector <int> ass, skip;

int main() {
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    int totalsize = 0;
    for (int i = 0; i < t; i++) {
        int len;
        cin >> len;
        totalsize += len;
        for (int j = 0; j < len; j++) {
            string s;
            cin >> s;
            string sp[2];
            int id = 0;
            for (char c : s) {
                if (c == '=') {
                    id = 1;
                    continue;
                }
                sp[id].push_back(c);
            }
            if (!varid.count(sp[0])) {
                varid[sp[0]] = varcount++;
            }
            st[i].emplace_back(varid[sp[0]], stoi(sp[1]));
        }
    }
    int vc;
    cin >> vc;
    assert(vc == varcount);
    ass.resize(vc, 0);
    skip.resize(vc, 0);
    for (int i = 0; i < vc; i++) {
        string s;
        cin >> s;
        int a;
        cin >> a;
        ass[varid[s]] = a;
    }
    vector <int> ex;
    ex.reserve(totalsize);
    while (totalsize--) {
        bool done = false;
        for (int i = 0; i < t; i++) if (!st[i].empty()) {
            auto [var, val] = st[i].back();
            if (skip[var]) {
                st[i].pop_back();
                ex.push_back(i);
                done = true;
                break;
            }
            if (val == ass[var]) {
                skip[var] = 1;
                st[i].pop_back();
                ex.push_back(i);
                done = true;
                break;
            }
        }
        if (!done) {
            cout << "No\n";
            return 0;
        }
    }
    reverse(ex.begin(), ex.end());
    cout << "Yes\n";
    for (int i : ex) cout << i + 1 << ' ';
    return 0;
}