#include <iostream>
#include <set>
#include <map>
#include <utility>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <cmath>
#define all(x) (x).begin(), (x).end()
#define vcin(a) for (auto& e : a) cin >> e;
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll inf = 1e18 + 0.5;
const ll mod = 998244353;

int isF(int i, int j, vector<vector<bool>>& a) {
	if (a[i][j] && a[i + 1][j] && a[i + 2][j] && a[i + 3][j] && a[i + 4][j] &&
		a[i][j + 1] && a[i + 2][j + 1] &&
		a[i][j + 2]) {
		a[i][j] = a[i + 1][j] = a[i + 2][j] = a[i + 3][j] = a[i + 4][j] =
			a[i][j + 1] = a[i + 2][j + 1] =
			a[i][j + 2] = false;
		return 1;
	}
	return 0;
}

int isQ(int i, int j, vector<vector<bool>>& a) {
	if (a[i][j] && a[i + 1][j] && a[i + 2][j] &&
		a[i][j + 1] && a[i + 2][j + 1] &&
		a[i][j + 2] && a[i + 1][j + 2] && a[i + 2][j + 2] && a[i + 3][j + 2] && a[i + 4][j + 2])
	{
		a[i][j] = a[i + 1][j] = a[i + 2][j] =
			a[i][j + 1] = a[i + 2][j + 1] =
			a[i][j + 2] = a[i + 1][j + 2] = a[i + 2][j + 2] = a[i + 3][j + 2] = a[i + 4][j + 2] = false;
		return 1;
	}
	return 0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m; cin >> n >> m;
	vector<vector<bool>> a(n + 4, vector<bool>(m + 4));
	for (int i = 2; i <= n + 1; ++i)
		for (int j = 2; j <= m + 1; ++j)
		{
			char c; cin >> c;
			a[i][j] = c == '#';
		}
	int ansF = 0, ansQ = 0;
	for (int j = 2; j <= m + 1; ++j)
		for (int i = 2; i <= n + 1 - 4; ++i)
		{
			ansF += isF(i, j, a);
			ansQ += isQ(i, j, a);
		}
	cout << ansQ << " " << ansF;
}