#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <complex>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <cstdio>

#define ll long long
#define ld long double
#define pll pair<ll,ll>
#define pii pair<ll,ll>
#define X first
#define Y second
#define int ll

using namespace std;

vector<int> raz;
vector<set<int>> mn(30);

int gcd(int a, int b) {
    if (a < b)
        swap(a,b);
    while (b) {
        a %= b;
        swap(a,b);
    }
    return a;
}

int phi (int fixed) {
    int result = fixed;
    for (int i = 0; i < mn.size(); i++) {
        for (ll item : mn[i]) {
            if (!(i % 2))
                result -= fixed/item;
            else
                result += fixed/item;
        }
    }
    return result;
}

void brute(int n) {
    int cur = 0;
    for (int i = 1; i <= n; i++) {
        if (gcd(i, n) == 1) {
            cur++;
            cout << cur << " " << i << " " << phi(i) << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        raz.clear();
        int cn = n;
        for (int i = 2; i * i <= n; i++) {
            if (cn % i == 0) {
                raz.push_back(i);
                while (cn % i == 0) {
                    cn /= i;
                }
            }
        }
        if (cn != 1) {
            raz.push_back(cn);
        }
        for (int i = 0; i < 30; i++) {
            mn[i].clear();
        }
        for (int i = 0; i < raz.size(); i++) {
            mn[0].insert(raz[i]);
        }
        bool fl = true;
        for (int j = 0; fl; j++) {
            bool nxt = false;
            for (int i = 0; i < raz.size(); i++) {
                for (ll item : mn[j]) {
                    if (item * raz[i] < n) {
                        if (gcd(item,raz[i]) == 1 && !mn[j + 1].count(item * raz[i])) {
                            mn[j + 1].insert(item * raz[i]);
                            nxt = true;
                        }
                    }
                }
            }
            if (!nxt) {
                fl = false;
            }
        }
        int l = 0;
        int startval = phi(n);
        int r = n + 10;
        //brute(n);
        while (l + 1 < r) {
            int m = (l + r)/2;
            if (phi(m) < (startval + 1)/2) {
                l = m;
            } else {
                r = m;
            }
        }
        cout << r << endl;
    }
}