#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <cmath>
#include <complex>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <cstdio>

#define ll long long
#define ld long double
#define pll pair<ll,ll>
#define pii pair<ll,ll>
#define X first
#define Y second
#define int ll

using namespace std;

vector<set<int>> mn(30);

int gcd(int a, int b) {
    if (a < b)
        swap(a,b);
    while (b) {
        a %= b;
        swap(a,b);
    }
    return a;
}

int phi (int fixed) {
    int result = fixed;
    for (int i = 0; i < mn.size(); i++) {
        for (ll item : mn[i]) {
            if (!(i % 2))
                result -= fixed/item;
            else
                result += fixed/item;
        }
    }
    return result;
}

void brute(int n) {
    int cur = 0;
    for (int i = 1; i <= n; i++) {
        if (gcd(i, n) == 1) {
            cur++;
            cout << cur << " " << i << " " << phi(i) << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int i = n/2; i >= 0; i--) {
            if (gcd(i, n) == 1) {
                cout << i << endl;
                break;
            }
        }
    }
}