#include<bits/stdc++.h>

using namespace std;

#define all(d) d.begin(), d.end()

using vint = vector < int >;
using vvint = vector < vint >;
using vpint = vector < pair < int, int > >;
using ll = long long;
const int INF = 1e9 + 7;

using niyqueue = priority_queue < pair < int, int > , vector < pair < int, int > >, greater < pair < int, int > > >;

struct pt{
    double x, y;
};

int n, m, ansf, ansq;

void rec(vector < vector < bool > > &v, int i, int j, int q, int f){
    if(i == n - 1 && j == m - 1){
        ansf = f;
        ansq = q;
        return;
    }
    //if(i >= n || j >= m) return;
    if(v[i][j] == 1){
        if(i + 4 >= n && j + 2 >= m) return;
        if(v[i + 1][j] == 1 && //q
                v[i + 2][j] == 1 &&
                v[i][j + 2] == 1 &&
                v[i + 1][j + 2] == 1 &&
                v[i + 2][j + 2] == 1 &&
                v[i + 3][j + 2] == 1 &&
                v[i + 4][j + 2] == 1 &&
                v[i][j + 1] == 1 &&
                v[i + 2][j + 1] == 1){
            v[i][j] = 0;
            v[i + 1][j] = 0;
            v[i + 2][j] = 0;
            v[i][j + 2] = 0;
            v[i + 1][j + 2] = 0 ;
            v[i + 2][j + 2] = 0 ;
            v[i + 3][j + 2] = 0 ;
            v[i + 4][j + 2] = 0 ;
            v[i][j + 1] = 0;
            v[i + 2][j + 1] = 0 ;
            if(j + 1 == m) rec(v, i + 1, 0, q + 1, f);
            else rec(v, i, j + 1, q + 1, f);
            v[i][j] = 1;
            v[i + 1][j] = 1;
            v[i + 2][j] = 1;
            v[i][j + 2] = 1;
            v[i + 1][j + 2] = 1 ;
            v[i + 2][j + 2] = 1 ;
            v[i + 3][j + 2] = 1 ;
            v[i + 4][j + 2] = 1 ;
            v[i][j + 1] = 1;
            v[i + 2][j + 1] = 1 ;
        }
        if(v[i + 1][j] == 1 && //f
                v[i + 2][j] == 1 &&
                v[i + 3][j] == 1 &&
                v[i + 4][j] == 1 &&
                v[i + 2][j + 1] == 1 &&
                v[i][j + 1] == 1 &&
                v[i][j + 2] == 1){
            v[i][j] = 0;
            v[i + 1][j] = 0;
            v[i + 2][j] = 0;
            v[i + 3][j] = 0;
            v[i + 4][j] = 0;
            v[i + 2][j + 1] = 0;
            v[i][j + 1] = 0;
            v[i][j + 2] = 0;
            if(j + 1 == m) rec(v, i + 1, 0, q, f + 1);
            else rec(v, i, j + 1, q, f + 1);
            v[i][j] = 1;
            v[i + 1][j] = 1;
            v[i + 2][j] = 1;
            v[i + 3][j] = 1;
            v[i + 4][j] = 1;
            v[i + 2][j + 1] = 1;
            v[i][j + 1] = 1;
            v[i][j + 2] = 1;
        }
    }else{
        if(j + 1 == m) rec(v, i + 1, 0, q, f);
        else rec(v, i, j + 1, q, f);
    }

}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


    cin >> n >> m;

    vector < vector < bool > > v(n, vector < bool > (m));

    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            char c;
            cin >> c;
            if(c == '.') v[i][j] = 0;
            else v[i][j] = 1;
        }
    }

    rec(v, 0, 0, 0, 0);

    cout << ansq << " " << ansf;

    return 0;
}

/*
764165441
500
169

11 7
###....
#.###..
###....
#.#####
#.#.#.#
..#.###
..###.#
..#.#.#
..###..
....#..
....#..
    *. *****. *****. *****. *****. *   *. *****.     *. *****. *****. *****. *****.
   **.     *.     *. *   *.    * . *   *. *    .    * .    * . *   *. *   *. *   *.
  * *.     *.     *. *   *.   *  . *   *. *    .   *  .   *  . *   *. *   *. *   *.
 *  *.     *.     *. *   *.  *   . *   *. *    .  *   .  *   . *   *. *   *. *   *.
*   *.     *.     *. *****. *****. *****. *****. *****. *    . *****. *****. *   *.
    *.    * .    * . *   *.    * .     *.     *. *   *. *    . *   *.    * . *   *.
    *.   *  .   *  . *   *.   *  .     *.     *. *   *. *    . *   *.   *  . *   *.
    *.  *   .  *   . *   *.  *   .     *.     *. *   *. *    . *   *.  *   . *   *.
    *. *****. *****. *****. *    .     *. *****. *****. *    . *****. *    . *****.
  */
