#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

int main() {
    int t;
    size_t n;
    cin >> t;

    while (t--) {
        cin >> n;
        size_t result = 0;
        size_t sqrtn = sqrt(n);
        for (size_t i = 0; i <= sqrtn; i++) {
            size_t cur_n = n;
            size_t cur_i = n / 2 - i;
            while (cur_n && cur_i) {
                if (cur_n > cur_i)
                    cur_n %= cur_i;
                else
                    cur_i %= cur_n;
            }

            if (cur_n + cur_i == 1) {
                result = n / 2 - i;
                break;
            }
        }

        cout << result << std::endl;
    }

    return 0;
}