﻿#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include<sstream>
#include<cassert>
#include<chrono>
#include<complex>

//by Skeef79

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define forn(i,n) for(int i = 0;i<n;i++)
#define for0(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define szof(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;

vec<int> min1, max1, minn, maxn;
vec<int> pmin1, pmax1, pminn, pmaxn;
map<pii, int> price;

vec<int> bfs(vec<vec<int>> &g, vec<int> &mini, vec<int> &maxi, vec<int> &pmini, vec<int> &pmaxi, int source) {
	queue<int> q;
	q.push(source);
	int n = mini.size();
	vec<int> d(n, INF);
	d[source] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto to : g[v]) {
			if (d[to] != INF) {
				if (d[to] == d[v] - 1) {
					if (mini[to] < mini[v] || price[{v, to}] < mini[v]) {
						mini[v] = min(mini[to], price[{v, to}]);
						pmini[v] = to;
					}
					if (maxi[to] > maxi[v] || price[{v, to}] > maxi[v]) {
						maxi[v] = max(maxi[to], price[{v, to}]);
						pmaxi[v] = to;
					}
				}
			}
			else {
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}
	return d;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	
	min1.resize(n, INF);
	minn.resize(n, INF);
	maxn.resize(n, -INF);
	max1.resize(n, -INF);
	pmin1.resize(n,-1); pminn.resize(n,-1), pmax1.resize(n,-1), pmaxn.resize(n,-1);
	vec<vec<int>> g = vec<vec<int>>(n);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		if (min(a, b) == 0 && max(a, b) == n - 1) {
			cout << 1 << en;
			cout << 1 << ' ' << n;
			return;
		}
		price[{a, b}] = c;
		price[{b, a}] = c;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	vec<int> d1 = bfs(g, min1, max1, pmin1, pmax1, 0);
	vec<int> d2 = bfs(g, minn, maxn, pminn, pmaxn, n-1);

	int frommin, tomin, frommax, tomax;
	int v;
	int ans = 0;
	for (int i = 1; i < n-1; i++) {
		if (d1[i] + d2[i] == d1[n - 1]) {
			if (abs(min1[i] - maxn[i]) > ans) {
				v = i;
				frommin = 0, frommax = n - 1;
				ans = abs(min1[i] - maxn[i]);
			}
			if (abs(max1[i] - minn[i]) > ans) {
				v = i;
				frommax = 0;
				frommin = n - 1;
				ans = abs(max1[i] - minn[i]);
			}
		}
	}
	int vv = v;
	if (frommin == 0) {
		vec<int> path1;
		while (v != -1) {
			path1.push_back(v);
			v = pmin1[v];
		}
		reverse(all(path1));
		path1.pop_back();

		vec<int> path2;
		v = vv;
		while (v != -1) {
			path2.push_back(v);
			v = pmaxn[v];
		}
		cout << int(path1.size() + path2.size()) - 1 << en;
		for (int i = 0; i < path1.size(); i++) {
			cout << path1[i] + 1 << ' ';
		}
		for (int i = 0; i < path2.size(); i++) {
			cout << path2[i] + 1 << ' ';
		}
	}

	else {
		vec<int> path1;
		while (v != -1) {
			path1.push_back(v);
			v = pmax1[v];
		}
		reverse(all(path1));
		path1.pop_back();

		vec<int> path2;
		v = vv;
		while (v != -1) {
			path2.push_back(v);
			v = pminn[v];
		}
		cout << int(path1.size() + path2.size()) - 1 << en;
		for (int i = 0; i < path1.size(); i++) {
			cout << path1[i] + 1 << ' ';
		}
		for (int i = 0; i < path2.size(); i++) {
			cout << path2[i] + 1 << ' ';
		}
	}


	

}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

		#ifdef _DEBUG
			freopen("input.txt", "r", stdin);
		#endif

	int tst = 1;
	//cin >> tst;

	while (tst--) {
		solve();
	}

}