﻿#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include<sstream>
#include<cassert>
#include<chrono>
#include<complex>

//by Skeef79

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define forn(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define szof(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;


template<typename T> void input(vec<T> &a) {
	for (auto &to : a)
		cin >> to;
}

template<typename T> void print(vec<T> &a) {
	for (auto to : a)
		cout << to << ' ';
	cout << en;
}


void solve() {
	int t;
	cin >> t;
	vector<vector<pair<string, string>>>a(t);

	int total = 0;

	for (int i = 0; i < t; i++) {
		int k;
		cin >> k;
		vec<pair<string, string>>cur(k);
		total += k;
		for (int j = 0; j < k; j++) {
			string s;
			cin >> s;
			int pos = s.find('=');
			string variable = s.substr(0, pos);
			string value = s.substr(pos + 1);
			cur[j] = { variable,value };
		}
		a[i] = cur;
	}

	int k;
	cin >> k;
	map<string, string>need;

	for (int i = 0; i < k; i++) {
		string variable, value;
		cin >> variable >> value;

		need[variable] = value;
	}
	
	vec<int>ans;
	set<string>done;

	for (int _ = 0; _ < total; _++) {
		bool ok = false;
		for (int i = 0; i < t; i++) {
			if (!a[i].empty()) {
				if (done.count(a[i].back().first)) {
					ans.pb(i);
					a[i].pop_back();
					ok = true;
					break;					
				}

				if (need[a[i].back().first] == a[i].back().second) {
					done.insert(a[i].back().first);
					ans.pb(i);
					a[i].pop_back();
					ok = true;
					break;
				}
			}
		}

		if (!ok) {
			cout << "No";
			return;
		}

	}

	cout << "Yes" << en;
	reverse(all(ans));
	for (auto to : ans)
		cout << to + 1 << ' ';

}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int tst = 1;
	//cin >> tst;

	while (tst--) {
		solve();
	}

}