﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <stack>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <queue>

using namespace std;

int main() {
    std::ios::sync_with_stdio(false);

    long long n, m, c, M, C, MN(INT_MAX), s(0);

    cin >> n >> m >> c;

    if (n < m && n < c) {
        cout << 0 << " " << 1 << "\n";
        return 0;
    }
    
    if (n % c == 0) {
        cout << 0 << " " << n / c << "\n";
        return 0;
    }

    if (n % m == 0) {
        cout << n / m << " " << 0 << "\n";
        return 0;
    }

    for (long long i(0); i * c <= n; i ++) {
        s = 0;
        for (long long j(0); j * m <= n; j ++) {
            if (i != 0 || j != 0) {
                s = abs(m * j + c * i - n);
                if (s < MN) {
                    MN = s;
                    M = j;
                    C = i;
                }
            }
        }
    }

    cout << M << " " << C << "\n";

    return 0;
}