import math

def divisorGenerator(n):
  large_divisors = []
  for i in range(1, int(math.sqrt(n)+1)):
    if n % i == 0:
      yield i
      if i * i != n:
        large_divisors.append(n / i)
  for divisor in reversed(large_divisors):
    yield divisor
  
for i in range(int(input())):
  number = int(input())
  result = list(divisorGenerator(number))
  result.pop(0)

  if len(result) == 1:
    print(int(result[0]) // 2)
  else:
    numbers = set(int(item*x)
                for item in result
                for x in range(1, int(number // item) +1)
                )
    numbers = [x for x in range(number) if x not in numbers]

    le = len(numbers)
    if le % 2 == 0:
      print(numbers[le // 2 - 1])
    else:
      print(numbers[le // 2])
