#define _CRT_SECURE_NO_WARNINGS
#define All(x) x.begin(), x.end()
#define ln '\n'
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <assert.h>
#include <set>
#include <fstream>
#include <map>
#include <string>
#include <conio.h>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;

class String
{
public:
	static vector<ll> Z_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}
	template <typename T>
	static vector<ll> Z_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}

	static vector<ll> PI_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
	template<typename T>
	static vector<ll> PI_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
};

class Math
{
public:
	static long long gcd(ll a, ll b)
	{
		return b ? gcd(b, a % b) : a;
	}
	static long long fast_pow(ll a, ll n)
	{
		if (n == 0)
			return 1;
		if (n == 1)
			return a;
		ll res = fast_pow(a, n / 2);
		res *= res;
		if (n % 2 == 0)
			return res;
		return res * a;
	}
};
void ask()
{

	cout.flush();
}

void answer()
{

	cout.flush();
}

void solve()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<vector<pair<ll, ll>>>g(n + 1, vector<pair<ll, ll>>(m + 1));
	for (int i = 0; i < m; i++)
	{
		ll v, u, c;
		cin >> v >> u >> c;
		g[v].push_back({ u,c });
		g[u].push_back({ v,c });
	}
	vector<ll>dp(n + 1, 1e9);
	vector < pair < ll, ll>>kal(n + 1, { 1e18, -1e18 });
	vector <map <ll, set < pair < ll, ll> > > >  mapka(n + 1, map < ll, set < pair < ll, ll> >>());
	vector<ll>vost(n + 1, -1);
	dp[1] = 0;
	set<pair<ll, ll>>q;
	q.insert({ dp[1], 1 });
	mapka[1][-1].insert({ 1e18, -1e18 });
	while (!q.empty())
	{
		ll w = q.begin()->first;
		ll v = q.begin()->second;
		q.erase({ w,v });
		for (auto to : g[v])
		{
			if (dp[v] + 1 < dp[to.first])
			{
				q.erase({ dp[to.first], to.first });
				dp[to.first] = dp[v] + 1;
				q.insert({ dp[to.first], to.first });
				continue;
			}
		}
	}
}

struct node
{
	node* child[27];
	node* parent;
	ll val = 0;
};

ll mx = -1e18;
node* found;
ll ans = 0;
void rec(node* v, ll& x, ll j = 0)
{
	if (j == 0)
	{
		if (v->val <= x)
		{
			cout << ans + 1 << ln;
			exit(0);
			return;
		}
		for (int i = 0; i <= 26; i++)
		{
			if (v->child[i] != nullptr)
				rec(v->child[i], x, j + 1);
		}
		return;
	}
	if (v->val <= x && v->val > mx)
	{
		mx = v->val;
		found = v;
		return;
	}
	for (int i = 0; i <= 26; i++)
	{
		if (v->child[i] != nullptr)
			rec(v->child[i], x, j + 1);
	}
	return;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, k;
	cin >> n >> k;
	vector<string>s(n);
	map<string, ll>m;
	node* root = new node;
	root->val = 0;
	for (int i = 0; i <= 26; i++)
	{
		root->child[i] = nullptr;
		
	}
	root->parent = nullptr;
	for (int i = 0; i < n; i++)
	{
		cin >> s[i];
		string q = "";
		ll next = s[i][0] - 'a';
		if (root->child[next] == nullptr)
		{
			root->child[next] = new node;
			root->child[next]->parent = root;
			for (int i = 0; i <= 26; i++)
			{
				root->child[next]->child[i] = nullptr;
			}
			
		}
		//root->child[next]->val++;
		q += s[i][0];
		node* start = root->child[next];
		for (int t = 1; t < s[i].size(); t++)
		{
			q += s[i][t];
			if (start->child[s[i][t] - 'a'] != nullptr)
			{
				start = start->child[s[i][t] - 'a'];
				//start->val++;
			}
			else
			{
				start->child[s[i][t] - 'a'] = new node;
				start->child[s[i][t] - 'a']->parent = start;
				start = start->child[s[i][t] - 'a'];
				//start->val++;
				for (int i = 0; i <= 26; i++)
				{
					start->child[i] = nullptr;
				}
			}
		}
		start->val++;
		while (start->parent != nullptr)
		{
			start->parent->val += start->val;
			start = start->parent;
		}
	}
	ans = 0;
	for (int i = 0; i <= 26; i++)
	{
		if (root->child[i] != nullptr)
			root->val += root->child[i]->val;
	}
	while (n > k)
	{
		mx = -1e18;
		ans++;
		node* start = root;
		rec(root, k);
		n -= found->val;
		ll w = found->val;
		while (found->parent != nullptr)
		{
			found->val -= w;
			found = found->parent;
		}
		root->val -= w;
	}
	cout << ans + 1 << ln;
}