﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;
using System.Xml.Xsl;

namespace ACM
{
    class Program
    {
        static void Main(string[] args)
        {
            var n = int.Parse(Console.ReadLine());
            var m = int.Parse(Console.ReadLine());
            var c = int.Parse(Console.ReadLine());
            (int mCount, int cCount)[] arr = Enumerable.Repeat((int.MinValue, int.MinValue), n + 1).ToArray();
            arr[0] = (0, 0);
            for (int i = 0; i <= n; i++)
            {
                if (arr[i].mCount >= 0)
                {
                    var mMove = i + m;
                    if (mMove <= n) arr[mMove] = (mCount: arr[i].mCount + 1, cCount: arr[i].cCount);
        
                    var cMove = i + c;
                    if (cMove <= n) arr[cMove] = (mCount: arr[i].mCount, cCount: arr[i].cCount + 1);
                }
            }
        
            var result = arr.Last(x => x.mCount >= 0);
            Console.WriteLine($"{result.mCount} {result.cCount}");
        }
    }
}