from sys import stdin, setrecursionlimit


def dfs(v, path, visited, min_val, max_val):
    global best_path, best_l, best_val
    if len(path) <= best_l:
        if v == n:
            if max_val-min_val > best_val:
                best_path = path
                best_l = len(best_path)
                best_val = max_val-min_val
            return
        for u in g[v]:
            u_v, u_c = u
            if u_v not in visited:
                dfs(u_v, path + [u_v], visited | {v}, min(min_val, u_c), max(max_val, u_c))
    return


def solve():
    dfs(1, [], set(), float('inf'), -1)
    print(len(best_path))
    print(' '.join(str(s) for s in ([1]+best_path)))


if __name__ == '__main__':
    setrecursionlimit(300005)
    g = {}
    n, m = [int(s) for s in stdin.readline().split()]

    for i in range(m):
        v, u, c = [int(s) for s in stdin.readline().split()]
        g[v] = g.get(v, []) + [(u, c)]
        g[u] = g.get(u, []) + [(v, c)]

    best_path = []
    best_l = float('inf')
    best_val = -1
    solve()
