﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace icpcsharp
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            long a, b;
            a = Convert.ToInt64(s[0]);
            b = Convert.ToInt64(s[1]);
            Custom c = new Custom();
            for (int i = 0; i < a; i++)
            {
                c.Add(Console.ReadLine());
            }
            int count = 0;
            while (!c.Empty)
            {
                c.DeleteMaxWords(b);
                count++;
            }
        }
    }
    class Custom
    {
        public bool Ended = false;
        public bool Empty = false;
        public Dictionary<string, Custom> dict = new Dictionary<string,Custom>();

        public void Add(string word)
        {
            if (word == "") dict.Add("", new Custom { Ended = true });
            else
            {
                if (!dict.ContainsKey(word[0].ToString())) dict[word[0].ToString()] = new Custom();
                dict[word[0].ToString()].Add(word.Substring(1, word.Length - 1));
            }
        }
        public int GetWordsCount()
        {
            if (Empty) return 0;
            if (Ended) return 1;
            int count = 0;
            foreach (var i in dict)
            {
                if (i.Key == "") count++;
                else
                {
                    count += i.Value.GetWordsCount();
                }
            }
            return count;
        }

        public long GetMaxWordsCount(long max)
        {
            int s = GetWordsCount();
            if (s <= max) return s;
            else
            {
                long mm = 0;
                foreach (var i in dict)
                {
                    mm = Math.Max(mm, i.Value.GetMaxWordsCount(max));
                }
                return mm;
            }
        }
        public void DeleteMaxWords(long max)
        {
            int s = GetWordsCount();
            if (s<=max)
            {
                Empty = true;
            }
            else
            {
                long mm = 0;
                string h = "";
                foreach (var i in dict)
                {
                    if (i.Value.Empty) continue;
                    if (mm < i.Value.GetMaxWordsCount(max))
                    {
                        h = i.Key;
                        mm = i.Value.GetMaxWordsCount(max);
                    }
                }
                dict[h].DeleteMaxWords(max);
            }
        }
    }
}
