﻿using System;
using System.Linq;

namespace Contest
{
    class Contest
    {
        private static void Main()
        {
            var n = long.Parse(Console.ReadLine());
            var m = long.Parse(Console.ReadLine());
            var c = long.Parse(Console.ReadLine());
            var bestDistance = long.MaxValue;
            var result =  new long[2];

            for (long mCap = 0; mCap < m + n / m; mCap++)
            {
                var cCap = (n - mCap * m) / (double)c;
                if (cCap < 0)
                    continue;
                
                var floorCCap = (long)decimal.Floor((decimal)cCap);
                var ceilCCap = (long)decimal.Ceiling((decimal)cCap);
                var calculations = new [] { 
                    Math.Abs(mCap * m + floorCCap * c - n),
                    Math.Abs(mCap * m + ceilCCap * c - n)
                };
                var minDistance = calculations.Min();

                if (minDistance >= bestDistance) continue;
                
                bestDistance = minDistance;
                result[0] = mCap;
                result[1] = calculations[0] == minDistance ? floorCCap : ceilCCap;
            }
            Console.WriteLine(string.Join(" ", result));
        }
    }
}
