﻿using System;
using System.Linq;

namespace Contest
{
    class Contest
    {
        private static void Main()
        {
            var n = decimal.Parse(Console.ReadLine());
            var m = decimal.Parse(Console.ReadLine());
            var c = decimal.Parse(Console.ReadLine());
            var bestDistance = (decimal)long.MaxValue;
            var result =  new decimal[2];

            for (long mCap = 0; mCap < 2 * (n / m); mCap++)
            {
                var cCap = (n - mCap * m) / c;
                if (cCap < 0)
                    continue;
                
                var floorCCap = decimal.Floor(cCap);
                var ceilCCap = decimal.Ceiling(cCap);
                var calculations = new [] { 
                    Math.Abs(mCap * m + floorCCap * c - n),
                    Math.Abs(mCap * m + ceilCCap * c - n)
                };
                var minDistance = calculations.Min();

                if (minDistance >= bestDistance) continue;
                
                bestDistance = minDistance;
                result[0] = mCap;
                result[1] = calculations[0] == minDistance ? floorCCap : ceilCCap;
            }
            Console.WriteLine(string.Join(" ", result));
        }
    }
}
