﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace Test_Csh
{
    class Program
    {
        static int n;
        static bool end;
        static List<List<int>>[] optim(List<List<int>>[] roads, int[,] road)
        {
            List<List<int>>[] newroads = new List<List<int>>[n];
            for (int i = 0; i < n; i++)
                newroads[i] = new List<List<int>>(roads[i]);
            end = false;
            for (int i = 1; i < n; i++)
            {
                if (roads[i].Count != 0)
                    continue;
                end = true;
                for (int j = 0; j < n; j++)
                {
                    if (road[i, j] == -1)
                        continue;
                    if (roads[j].Count == 0)
                        continue;
                    foreach (List<int> r in roads[j])
                    {
                        List<int> t = new List<int>(r);
                        t.Add(i);
                        newroads[i].Add(t);
                    }
                }
            }
            return newroads;
        }

        static void Main(string[] args)
        {
            end = true;
            string s = Console.ReadLine();
            n = Convert.ToInt32(s.Split(' ')[0]);
            int m = Convert.ToInt32(s.Split(' ')[1]);
            int[,] road = new int[n, n];
            for (int i = 1; i < n; i++)
                for (int j = 0; j < n; j++)
                    road[i, j] = -1;
            for (int i = 0; i < m; i++)
            {
                string[] j = Console.ReadLine().Split(' ');
                road[Convert.ToInt32(j[0]) - 1, Convert.ToInt32(j[1]) - 1] = Convert.ToInt32(j[2]);
                road[Convert.ToInt32(j[1]) - 1, Convert.ToInt32(j[0]) - 1] = Convert.ToInt32(j[2]);
            }
            List<List<int>>[] roads = new List<List<int>>[n];
            for (int i = 0; i < n; i++)
                roads[i] = new List<List<int>>();
            roads[0].Add(new List<int>());
            roads[0][0].Add(0);
            while (end)
                roads = optim(roads, road);

            int bestd= -1;
            int best = -1;
            foreach(List<int> r in roads[5])
            {
                int dif = r.Max() - r.Min();
                if (dif > bestd)
                    best = roads[5].IndexOf(r);
            }
            Console.WriteLine(roads[5][best].Count - 1);
            foreach (int i in roads[5][best])
                Console.Write($"{i+1} ");
        }
    }
}