// probX.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>


bool findQ(char** p, int n, int m, int i, int j)
{
	for (size_t k = 0; k < 3; ++k)
	{
		if (p[i][j + k] != '#' || p[i + 2][j + k] != '#')
		{
			return false;
		}

	}
	if (p[i + 1][j] != '#' || p[i + 1][j + 2] != '#')
	{
		return false;
	}
	if (p[i + 3][j + 2] != '#' || p[i + 4][j + 2] != '#')
	{
		return false;
	}
	return true;
}

bool findF(char** p, int n, int m, int i, int j)
{
	for (size_t k = 0; k < 5; ++k)
	{
		if (p[i + k][j] != '#')
		{
			return false;
		}
	}
	if (p[i][j+1] != '#' || p[i][j + 2] != '#' || p[i + 1][j + 1] != '#')
	{
		return false;
	}
	return true;

}

int main()
{

	int counterQ = 0, counterF = 0;
	int n, m;
	std::cin >> n >> m;
	char** t = new char* [n];
	for (size_t i = 0; i < n; ++i)
	{
		t[i] = new char[m];
	}

	for (size_t i = 0; i < n; ++i)
	{
		for (size_t j = 0; j < m; ++j)
		{
			std::cin >> t[i][j];
		}
	}

	size_t i = 0, j = 0;
	while ( (i + 4 < n) && (j + 2 < m) )
	{
		while (t[i][j] != '#' && i < n && j < m)
		{
			++j;
			if (j == m)
			{
				j = 0;
				++i;
			}                                                   
		}
		
		
		
		if (t[i][j] == '#')
		{
			if (findQ(t, n, m, i, j))
			{
				++counterQ;
				j += 3;
				if (j >= m)
				{
					j = 0;
					i += 5;
				}
			}
			else if (findF(t, n, m, i, j))
			{
				++counterF;
				j += 3;
				if (j >= m)
				{
					j = 0;
					i += 5;
				}
			}


		}
	}
	std::cout << counterQ << counterF << std::endl;
}

