#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize(/*"Ofast",*/"O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2",/*"sse3","ssse3","sse4","popcnt"*/,"abm",/*"mmx","avx",*/"tune=native","arch=native"")

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <functional>

using namespace std;

#define sqr(x) ((x)*(x))

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-9;
const ld pi = acos(-1.);

ll gcd(ll a1, ll b1) {
	ll a = a1, b = b1;
	if (a < b) swap(a, b);
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void solve() {
	ll n;
	cin >> n;

	if (n == 2)
		cout << "1\n";
	else {
		ll anes = n / 2;
		while (1) {
			if (!(gcd(n, anes) - 1)) {
				cout << anes << '\n';
				return;
			}
			else
				anes--;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	srand(time(0));
	cout.precision(10);

	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}