#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

long long phi(long long n) {
	long long result = n;
	for (long long i = 2; i * i <= n; ++i)
		if (n % i == 0) {
			while (n % i == 0)
				n /= i;
			result -= result / i;
		}
	if (n > 1)
		result -= result / n;
	return result;
}
inline int gcd(int a, int b) {
	if (b == 0)
		return a;
	else
		return gcd(b, a % b);
}
int main()
{
	long long t;
	cin >> t;
	for (int i = 0; i < t; ++i)
	{
		long long val;
		cin >> val;
		if (val == 2)
		{
			cout << 1 << '\n';
			continue;
		}
		long long res = phi(val);
		if (res == val - 1)
		{
			cout << (val - 1) / 2 << '\n';
			continue;
		}
		if (res == 2)
		{
			cout << 1 << '\n';
			continue;
		}
		for (long long j = (val - 1) / 2; j > 0; --j)
		{
			if (gcd(j, val) == 1)
			{
				cout << j << '\n';
				break;
			}
		}
	}
	return 0;
}