#include <iostream>
#include <vector>
#include <utility>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

int main() {
    ll n, m;
    cin >> n >> m;
    vector<vector<bool>> b(n, vector<bool>(m, false));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c == '#') {
                b[i][j] = true;
            }
        }
    }
    ll f = 0, q = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (b[i][j]) {
                if (b[i][j + 1] && b[i][j + 2]
                    && b[i + 1][j] && b[i + 2][j]
                    && b[i + 2][j + 1]
                    && b[i + 3][j] && b[i + 4][j]) {
                    f++;
                    b[i][j] = false;
                    b[i][j + 1] = false;
                    b[i][j + 2] = false;
                    b[i + 1][j] = false;
                    b[i + 2][j] = false;
                    b[i + 2][j + 1] = false;
                    b[i + 3][j] = false;
                    b[i + 4][j] = false;
                } else {
                    q++;
                    b[i][j] = false;
                    b[i][j + 1] = false;
                    b[i][j + 2] = false;
                    b[i + 1][j] = false;
                    b[i + 2][j] = false;
                    b[i + 2][j + 1] = false;
                    b[i + 1][j + 2] = false;
                    b[i + 2][j + 2] = false;
                    b[i + 3][j + 2] = false;
                    b[i + 4][j + 2] = false;
                }
            }
        }
    }
    cout << q << " " << f;
}