import java.util.ArrayList;
import java.util.Scanner;
import java.util.TreeSet;

public class App {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        while(t --> 0) {
            foo(sc);
        }
    }

    public static void foo(Scanner sc) {

        long n = sc.nextLong();

        TreeSet<Long> factors = new TreeSet<>();

        for(long i = 2; i < n; i++) {
            if(n % i == 0) {
                factors.add(i);
            }
        }
        if(factors.size() == 0) {
            System.out.println((n - 1) / 2);
            return;
        }

        ArrayList<Long> coprimes = new ArrayList<>();
        for(long i = 1; i < n; i++) {
            boolean member = true;
            for(long factor : factors.headSet(i, true)) {
                if(i % factor == 0) {
                    member = false;
                    break;
                }
            }
            if(member) coprimes.add(i);
        }

        int medianIndex = coprimes.size() % 2 == 0 ? (coprimes.size() / 2 - 1) : coprimes.size() / 2;
        System.out.println(coprimes.get(medianIndex));

    }
}
