#include <bits/stdc++.h>

using namespace std;

int n, k;
vector<int> cnt;
vector<vector<int>> bohr;

inline void add_new_node() {
 cnt.push_back(0);
 bohr.push_back(vector<int>(26, -1));
}

void add(const string& s) {
 int v = 0;

 for (const char c : s) {
  cnt[v]++;
  if (bohr[v][c - 'a'] == -1) {
   bohr[v][c - 'a'] = bohr.size();
   add_new_node();
  }
  v = bohr[v][c - 'a'];
 }

 cnt[v]++;
}

pair<int,int> dfs (int v) {
 if (cnt[v] <= k)
  return {0,cnt[v]};

 int res = 0, cur = cnt[v];

 vector<pair<int, int>> a, vertex;
 
 for (int i = 0; i < 26; ++i) {
  	if(bohr[v][i]!=-1){
  		vertex.push_back({-cnt[bohr[v][i]],bohr[v][i]});
  	}
 }
 
 sort(vertex.begin(),vertex.end());
 
 vector<int> left;
 
 for(int i=0;i<(int)vertex.size();i++){
 	pair<int,int> x=dfs(vertex[i].second);
 	cur+=vertex[i].first;
 	cur+=x.second;
 	res+=x.first;
 	if(cur<=k){
 		return {res,cur};
 	}
 	left.push_back(-x.second);
 }
 
 sort(left.begin(),left.end());
 
 for(int i=0;i<(int)left.size();i++){
 	res++;
 	cur+=left[i];
 	if(cur<=k){
 		break;
 	}
 }
 return {res,cur};
}

int main() {
 cin >> n >> k;

 add_new_node();

 for (int i = 0; i < n; ++i) {
  string s;
  cin >> s;
  add(s);
 }

 pair<int,int> ans=dfs(0);

 if(ans.second!=0)ans.first++;
 
 cout << ans.first << endl;
 
	return 0;
}