/*
          ,     \    /      ,
         / \    )\__/(     / \
        /   \  (_\  /_)   /   \
   ____/_____\__\@  @/___/_____\____
  |             |\../|              |
  |              \VV/               |
  |        ------hoi-------         |
  |_________________________________|
   |    /\ /      \\       \ /\    |
   |  /   V        ))       V   \  |
   |/     `       //        '     \|
   `              V                '
*/

#include <bits/stdc++.h>

#define ld long double
#define ll long long
#define ull unsigned long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define Speedforce boost();
#define fop(s1, s2) freopen(s1, "r", stdin);freopen(s2, "w", stdout);

using namespace std;

void boost(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

//mt19937_64 mt(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e6;
const ll inf = 1e9+7;
const ld PI = acos(-1);

ll bin_pow(ll x, ll y, ll mod = inf){
    ll res = 1, base = x;
    while(y){
        if(y & 1){
            res *= base;
            res %= mod;
        }
        base *= base;
        base %= mod;
        y /= 2;
    }
    return res;
}

ll n, m;
vector <pair <ll, ll> > g[N];
queue <int> q1,q2;
ll d1[N], pr1[N];
ll mx1[N], mn1[N];
ll d2[N], pr2[N];
ll mx2[N], mn2[N];

int main(){
    Speedforce
    //fop("bad.in", "bad.out");
    //cout << -inf - inf << endl;
    cin >> n >> m;
    for(int i = 1;i <= m;i ++){
        int x, y, z;
        cin >> x >> y >> z;
        g[x].pb(mp(y,z));
        g[y].pb(mp(x,z));
    }
    for(int i = 1;i <= n;i ++){
        d1[i] = inf;
        mx1[i] = -inf;
        mn1[i] = inf;
        d2[i] = inf;
        mx2[i] = -inf;
        mn2[i] = inf;
    }
    q1.push(1);
    d1[1] = 1;
    while(!q1.empty()){
        ll v = q1.front();
        if(v == n){
            break;
        }
        q1.pop();
        for(int i = 0;i < g[v].size();i ++){
            ll to = g[v][i].f, cl = g[v][i].s;
            if(d1[to] <= d1[v]){
                continue;
            }
            if(d1[to] == d1[v] + 1){
                if(mx1[to] - mn1[to] < max(mx1[v],cl) - min(mn1[v],cl)){
                    mx1[to] = max(mx1[v],cl);
                    mn1[to] = min(mn1[v],cl);
                    pr1[to] = v;
                }
                continue;
            }
            mx1[to] = max(mx1[v],cl);
            mn1[to] = min(mn1[v],cl);
            pr1[to] = v;
            d1[to] = d1[v] + 1;
            q1.push(to);
        }
    }
    q2.push(n);
    d2[n] = 1;
    while(!q2.empty()){
        ll v = q2.front();
        if(v == 1){
            break;
        }
        q2.pop();
        for(int i = 0;i < g[v].size();i ++){
            ll to = g[v][i].f, cl = g[v][i].s;
            if(d2[to] <= d2[v]){
                continue;
            }
            if(d2[to] == d2[v] + 1){
                if(mx2[to] - mn2[to] < max(mx2[v],cl) - min(mn2[v],cl)){
                    mx2[to] = max(mx2[v],cl);
                    mn2[to] = min(mn2[v],cl);
                    pr2[to] = v;
                }
                continue;
            }
            mx2[to] = max(mx2[v],cl);
            mn2[to] = min(mn2[v],cl);
            pr2[to] = v;
            d2[to] = d2[v] + 1;
            q2.push(to);
        }
    }
    /*for(int i = 1;i <= n;i ++){
        cout << mx[i] << " " << mn[i] << endl;
    }*/
    cout << d1[n] - 1 << endl;
    vector <int> path;
    if(mx1[n] - mn1[n] > mx2[1]-mn2[1]){
        int x = n;
        while(x != 1){
            path.pb(x);
            x = pr1[x];
        }
        path.pb(1);
        reverse(path.begin(), path.end());
    }
    else{
        int x = 1;
        while(x != n){
            path.pb(x);
            x = pr2[x];
        }
        path.pb(n);
    }
    for(int i = 0;i < d1[n];i ++){
        cout << path[i] << " ";
    }
}
