#include <stdio.h>             
#include <bits/stdc++.h>

#define f first                                                           
#define s second
#define pb push_back
#define ppb pop_back
#define mp make_pair

using namespace std;

typedef long long ll;

const int N = (int) 3e5 + 123, inf = (int) 2e9 + 123, mod = (int) 1e9 + 7;
const ll INF = (ll) 2e18 + 123;

int n, m;
char a[350][350];

bool Check_F(int x, int y) {
  if (x - 4 <= 0 || y + 2 > m) {
    return 0;
  }
  return (a[x - 3][y + 1] == '.' && a[x - 1][y] == '#' && a[x - 2][y] == '#' && a[x - 3][y] == '#' && a[x - 4][y] == '#' && a[x - 2][y + 1] == '#' && a[x - 4][y + 1] == '#' && a[x - 4][y + 2] == '#');
}

void Clear_F(int x, int y) {
  a[x - 1][y] = a[x - 2][y] = a[x - 3][y] = a[x - 4][y] = a[x - 2][y + 1] = a[x - 4][y + 1] = a[x - 4][y + 2] = '.';
}

bool Check_Q(int x, int y) {
  if (x - 4 <= 0 || y - 2 <= 0) {
    return 0;
  }
  return (a[x - 1][y] == '#' && a[x - 2][y] == '#' && a[x - 3][y] == '#' && a[x - 4][y] == '#' && a[x - 2][y - 1] == '#' && a[x - 4][y - 1] == '#' && a[x - 4][y - 2] == '#' && a[x - 2][y - 2] == '#' && a[x - 3][y - 2] == '#');
}

void Clear_Q(int x, int y) {
  a[x - 1][y] = a[x - 2][y] = a[x - 3][y] = a[x - 4][y] = a[x - 2][y - 1] = a[x - 4][y - 1] = a[x - 4][y - 2] = a[x - 2][y - 2] = a[x - 3][y - 2] == '.';
}

int main() {            
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(NULL);
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      cin >> a[i][j];
    }
  }
  int ans_Q = 0, ans_F = 0;
  for (int i = n; i >= 1; i--) {
    for (int j = m; j >= 1; j--) {
      if (a[i][j] == '#') {
        if (Check_F(i, j)) {
          Clear_F(i, j);
          ans_F++;  
        }
        if (Check_Q(i, j)) {
          Clear_Q(i, j);
          ans_Q++;
        } 
      }
    }
  }
  cout << ans_Q << ' ' << ans_F;
  return 0;        
}                              