import org.omg.CORBA.MARSHAL;

import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        FastReader scan = new FastReader();
        PrintWriter out = new PrintWriter(System.out);
        Solution solve = new Solution();
        int t = 1;
        //t = scan.nextInt();
        for (int qq = 0; qq < t; qq++) {
            solve.solve(scan, out);
            out.println();
        }
        out.close();
    }

    static class Solution {
        /*
         * think and coding
         */
        static long MOD = (long) (1e9 + 7);

        public void solve(FastReader scan, PrintWriter out) {
            String s = scan.nextLine(), s2 = scan.nextLine();
            if (s.startsWith("AD") && s2.startsWith("AD")) {
                int first = Integer.parseInt(s.replace("AD", "").trim());
                int second = Integer.parseInt(s2.replace("AD", "").trim());
                out.print(Math.abs(first - second));
            } else if (s.contains("BC") && s2.contains("BC")) {
                int first = Integer.parseInt(s.replace("BC", "").trim());
                int second = Integer.parseInt(s2.replace("BC", "").trim());
                out.print(Math.abs(first - second));
            } else if (s.contains("BC") && s2.contains("AD")) {
                int first = Integer.parseInt(s.replace("BC", "").trim());
                int second = Integer.parseInt(s2.replace("AD", "").trim());
                out.print(Math.abs(first + second) - 1);
            }else if (s.contains("AD") && s2.contains("BC")) {
                int first = Integer.parseInt(s.replace("AD", "").trim());
                int second = Integer.parseInt(s2.replace("BC", "").trim());
                out.print(Math.abs(first + second) - 1);
            }
        }

    }

    static class FastReader {
        private final BufferedReader br;
        private StringTokenizer st;

        public FastReader() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        public FastReader(String s) throws FileNotFoundException {
            br = new BufferedReader(new FileReader(new File(s)));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }
}