#include <iostream>
#include <vector>
#include <string>

using namespace std;
vector< vector<char> > vv;
vector< vector<char> > vv2;

bool is_F(int i, int j) {
	if (!(j + 2 < vv[i].size() && i + 4 < vv.size())) return false;
	
	if (vv[i][j + 1] == '#' && vv[i][j + 2] == '#') {
		for	(int k = 1; k <= 4; k++) if (vv[i + k][j] != '#') return false;
		if (vv[i + 2][j + 1] != '#') return false;
		return true;
	}
	
	return false;
}

void clear_F(int i, int j) {
	vv[i][j] = '.';
	vv[i][j + 1] = '.';
	vv[i][j + 2] = '.';
	vv[i + 1][j] = '.';
	vv[i + 2][j] = '.';
	vv[i + 3][j] = '.';
	vv[i + 4][j] = '.';
	vv[i + 2][j + 1] = '.';
}

void clear_Q(int i, int j) {
	vv[i][j] = '.';
	vv[i][j + 1] = '.';
	vv[i][j + 2] = '.';
	
	vv[i + 1][j] = '.';
	vv[i + 2][j] = '.';
	vv[i + 2][j + 1] = '.';
	
	vv[i + 1][j + 2] = '.';
	vv[i + 2][j + 2] = '.';
	vv[i + 3][j + 2] = '.';
	vv[i + 4][j + 2] = '.';
	
	vv[i + 2][j + 1] = '.';
}

bool is_Q(int i, int j) {
	if (!(j + 2 < vv[i].size() && i + 4 < vv.size())) return false;
	
	if (vv[i][j + 1] == '#' && vv[i][j + 2] == '#') {
		if (vv[i + 1][j] == '#' && vv[i + 2][j] == '#' && vv[i + 2][j + 1] == '#') {
			for	(int k = 1; k <= 4; k++) if (vv[i + k][j + 2] != '#') return false;
			return true;
		}
	}
	return false;
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); 
	cout.tie(0);
 
 	int n, m; cin >> n >> m;
 	vv.resize(n);
 	for	(int i = 0; i < vv.size(); i++) vv[i].resize(m);
 	
 	for	(int i = 0; i < vv.size(); i++)
		for	(int j = 0; j < vv[i].size(); j++)
			cin >> vv[i][j];
	
	int q_counter = 0, f_counter = 0;
	bool last_f = false, last_q = false;
	for	(int i = 0; i < vv.size(); i++) {
		for	(int j = 0; j < vv[i].size(); j++) {
			if (vv[i][j] == '#') {
				if (is_F(i, j)) {
					if (last_f) {
						j++;
						last_f = false;
						continue;
					}
					f_counter++;
					clear_F(i, j);
					last_f = true;
				}
				else if (is_Q(i, j)) {
					q_counter++;
					clear_Q(i, j);
				} else {
					last_f = false;
					last_q = false;
				}
			}
		}
	}
	
	
	for	(int i = 0; i < vv.size(); i++){
		for	(int j = 0; j < vv[i].size(); j++)
			cout << vv[i][j];
		cout << endl;
	}
		
	
	cout << q_counter << ' ' << f_counter << endl;
	
	
 	return false;
}
