#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_set>

using namespace std;

const int N = int(2e5) + 7;

vector < pair < int, int > > g[N];
set < pair < int, pair < int, set < pair < int, int > > > > > q; // {val, {dist, vector{min, max}}}
map < int, pair < int, set < pair < int, int > > > > ans;
map < int, int > pr, add_info;

int main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1, x, y, c; i <= m; i++) {
        cin >> x >> y >> c;
        g[x].emplace_back(y, c);
        g[y].emplace_back(x, c);
    }
//    for(int i = 1; i <= n; i++){
//        for(auto j : g[i]){
//            cout << j.first << ' ' << j.second << '\n';
//        }
//        cout << '\n';
//    }

    for (int i = 1; i <= n; i++) {
        ans[i] = {INT_MAX, {{INT_MAX, INT_MIN}}}; // {dist, {min, max}}
        add_info[i] = INT_MIN;
    }

    q.insert({1, {0, {{INT_MAX, INT_MIN}}}});
    ans[1] = {0, {{INT_MAX, INT_MIN}}};
    pr[1] = -1;

//    cout << "A";

    while (!q.empty()) {
        int v = q.begin()->first;
        q.erase(q.begin());
        for (auto i: g[v]) {
            int to = i.first;
            int color = i.second;
//            cout << v << ' ' << to << '\n';
            if (ans[to].first > ans[v].first + 1) {
//                cout << "A";
                q.erase({to, ans[to]});
                pair < int, pair < int, int > > res = {INT_MIN, {0, 0}};
                for(auto cc : ans[v].second){
                    int mn = min(color, cc.first);
                    int mx = max(color, cc.second);
//                    cout << mn << ' ' << mx << '\n';
                    if(res.first < mx - mn){
                        res = {mx - mn, {mn, mx}};
                    }
                }
                ans[to].second = {res.second};
                ans[to].first = ans[v].first + 1;
                q.insert({to, ans[to]});
                if(add_info[to] < res.second.second - res.second.first){
                    add_info[to] = res.second.second - res.second.first;
                    pr[to] = v;
                }
            } else if (ans[to].first == ans[v].first + 1) {
//                cout << "B";
                q.erase({to, ans[to]});
                pair < int, pair < int, int > > res = {INT_MIN, {0, 0}};
                for(auto cc : ans[v].second){
                    int mn = min(color, cc.first);
                    int mx = max(color, cc.second);
//                    cout << mn << ' ' << mx << '\n';
                    if(res.first < mx - mn){
                        res = {mx - mn, {mn, mx}};
                    }
                }
                ans[to].second.insert(res.second);
                q.insert({to, ans[to]});
                if(add_info[to] < res.second.second - res.second.first){
                    add_info[to] = res.second.second - res.second.first;
                    pr[to] = v;
                }
            }
//            cout << "\n\n";
        }
    }

//    cout << add_info[n] << '\n';
//    for(auto i : ans[n].second){
//        cout << i.first << ' ' << i.second << '\n';
//    }

    vector < int > res;
    res.clear();
    int v = n;
    while(true){
        if(v == -1){
            break;
        }
//        cout << v << ' ';
        res.push_back(v);
        v = pr[v];
    }
    reverse(res.begin(), res.end());
    cout << int(res.size()) - 1 << '\n';
    for(auto i : res){
        cout << i << ' ';
    }

//    for (int i = 1; i <= n; i++) {
//        cout << i << " : " << ans[i].first << ' ' << ans[i].second.first << ' ' << ans[i].second.second << '\n';
//    }

//    while(!q.empty()){
//        int v = q.front();
//        q.pop();
//        for(auto i : g[v]){
//            int to = i.first;
//            int color = i.second;
//            if(used[to]){
//                continue;
//            }
//            int mn = min(ans[v].second.first, color);
//            int mx = max(ans[v].second.second, color);
//            ans[to] = {ans[v].first + 1, {mn, mx}};
//            q.push(to);
//            used[to] = true;
//        }
//    }
}