#include <bits/stdc++.h>
#include <map>
using namespace std;
 int answer;
void add_edge(vector<int> adj[],
              int src, int dest)
{
    adj[src].push_back(dest);
    adj[dest].push_back(src);
}
 
void find_paths(vector<vector<int> >& paths,
                vector<int>& path,
                vector<int> parent[],
                int n, int u)
{
    if (u == -1) {
        paths.push_back(path);
        return;
    }
 
    for (int par : parent[u]) {
 
        path.push_back(u);
 
        find_paths(paths, path, parent,
                   n, par);
 
        path.pop_back();
    }
}
 
void bfs(vector<int> adj[],
         vector<int> parent[],
         int n, int start)
{
    vector<int> dist(n, INT_MAX);
 
    queue<int> q;
 
    q.push(start);
    parent[start] = { -1 };
    dist[start] = 0;
 
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (int v : adj[u]) {
            if (dist[v] > dist[u] + 1) {
 
                dist[v] = dist[u] + 1;
                q.push(v);
                parent[v].clear();
                parent[v].push_back(u);
            }
            else if (dist[v] == dist[u] + 1) {
 
                parent[v].push_back(u);
            }
        }
    }
}
 
void print_paths(vector<int> adj[],
                 int n, int start, int end,  map <long long, int> mapa)
{
    vector<vector<int> > paths;
    vector<int> path;
    vector<int> parent[n];
 
    bfs(adj, parent, n, start);
 
    find_paths(paths, path, parent, n, end);

    int tempind=0;
    int maxDif=0;
    for (auto v : paths) {
 
        reverse(v.begin(), v.end());
 
        bool tempb=1;int prev,mini=2000000000,maxi=0;
        for (int u : v)
        {
            if(tempb)
            {
                prev=u;
                tempb=0;
            }
            else{
                maxi=max(mapa[(long long)(prev)*1000000000+(long long)(u)],maxi);
                mini=min(mapa[(long long)(prev)*1000000000+(long long)(u)],mini);
                //cout<<prev<<' '<<u<<' '<<mapa[(long long)(prev)*1000000000+(long long)(u)]<<' '<<mini<<' '<<maxi<<endl;
                prev = u;
            }
        }
        //cout<<endl<<maxDif<<endl;
        if(maxDif<maxi-mini){maxDif = maxi-mini;
            answer = tempind;
        }
        tempind++;
    }
    reverse(paths[answer].begin(), paths[answer].end());
    cout<<paths[answer].size()-1<<endl;
    for (int u : paths[answer])
        {cout<<u+1<<' ';}
}
 
int main()
{
    int n,m,a,b,c;cin>>n>>m;
 
    vector<int> adj[n];
    map <long long, int> mp;
    for(int i=0;i<m;i++){
        cin>>a>>b>>c;
        add_edge(adj, a-1, b-1);
        mp[(long long)(a-1)*1000000000+(long long)(b-1)]=c;
        mp[(long long)(a-1)+(long long)(b-1)*1000000000]=c;
    }
 
    int src = 0;
    int dest = n - 1;
 
    print_paths(adj, n, src, dest, mp);
 
    return 0;
}