#include <iostream>
#include <map>
#include <unordered_map>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int N = (int) 1e6 + 7;

int best = INT_MAX, ans_m = 0, ans_c = 0;
int n;
int m, c;

void relax(int cur, int pos_c, int i) {
  int now = abs(cur + pos_c * c - n);
  if (now < best) {
    ans_m = i;
    ans_c = pos_c;
    best = now;
  }
}

int main() {
  cin >> n >> m >> c;
  int res = n / m + 1;
  for (int i = 0; i <= res; ++i) {
    int cur = i * m;
    int pos_c = max(0, n - cur) / c;
    relax(cur, pos_c, i);
    relax(cur, pos_c + 1, i);
    relax(cur, max(0, pos_c - 1), i);
  }
  cout << ans_m << ' ' << ans_c << endl;
  return 0;
}
