#include <bits/stdc++.h>

using namespace std;

vector<vector<char>> F(5, vector<char>(3));

// ###
// #..
// ##.
// #..
// #..

// ###
// #.#
// ###
// ..#
// ..#

inline void solve(){
    vector<vector<char>> F(5, vector<char>(3, '.')), Q(5, vector<char>(3, '.'));

    F[0][0] = '#';
    F[0][1] = '#';
    F[0][2] = '#';
    F[1][0] = '#';
    F[2][0] = '#';
    F[2][1] = '#';
    F[3][0] = '#';
    F[4][0] = '#';

    Q[0][0] = '#';
    Q[0][1] = '#';
    Q[0][2] = '#';
    Q[1][0] = '#';
    Q[1][2] = '#';
    Q[2][0] = '#';
    Q[2][1] = '#';
    Q[2][2] = '#';
    Q[3][2] = '#';
    Q[4][2] = '#';

    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int qCount = 0, fCount = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] == '#' && i >= 4 && j >= 2) {
                bool isQ = 1;
                for (int I = i; I >= i - 4; --I) {
                    for (int J = j; J >= j - 2; --J) {
                        int X = 4 - (i - I), Y = 2 - (j - J);
                        if (a[I][J] == '.' && Q[X][Y] == '#') {
                            isQ = 0;
                        }
                    }
                }

                if (isQ) {
                    qCount++;
                    for (int I = i; I >= i - 4; --I) {
                        for (int J = j; J >= j - 2; --J) {
                            int X = 4 - (i - I), Y = 2 - (j - J);
                            if (a[I][J] == '#' && Q[X][Y] == '#') {
                                a[I][J] = '.';
                            }
                        }
                    }
                }
            } 
            if (a[i][j] == '#' && i >= 4 && m - j >= 3) {
                bool isF = 1;
                for (int I = i; I >= i - 4; --I) {
                    for (int J = j; J <= j + 2; ++J) {
                        int X = 4 - (i - I), Y = J - j;
                        if (a[I][J] == '.' && F[X][Y] == '#') {
                            isF = 0;
                        }
                    }
                }

                if (isF) {
                    fCount++;
                    for (int I = i; I >= i - 4; --I) {
                        for (int J = j; J <= j + 2; ++J) {
                            int X = 4 - (i - I), Y = J - j;
                            if (a[I][J] == '#' && F[X][Y] == '#') {
                                a[I][J] = '.';
                            }
                        }
                    }
                    // for (int I = 0; I < n; ++I) {
                    //     for (int J = 0; J < m; ++J) {
                    //         cout << a[I][J];
                    //     }
                    //     cout << "\n";
                    // }
                    // cout << "\n";
                }
            }
        }
    }
    cout << qCount << " " << fCount;
}

int main(){
    #ifdef nurik
    freopen("in", "r", stdin);
    #endif

    ios_base::sync_with_stdio(0);

    solve();

    return 0;
}
