#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int n, m;
vector<pair<int, int>> g[100005];
int mn[100005][2], mx[100005][2], pr[100005][2][2];
int ds[100005][2];
vector<int> path[100005];

void bfs(bool isS) {
	int s = 1;
	if (isS)
		s = n;

	for (int i = 1; i <= n; ++i)
		ds[i][isS] = -1;
	ds[s][isS] = 0;

	queue<int> q;
	q.push(s);
	while (!q.empty()) {
		int cur = q.front();
		q.pop();

		for (auto it : g[cur]) {
			int to = it.first;
			int val = it.second;

			if (ds[to][isS] == -1) {
				ds[to][isS] = ds[cur][isS] + 1;
				mn[to][isS] = min(mn[cur][isS], val);
				mx[to][isS] = max(mx[cur][isS], val);
				pr[to][0][isS] = cur;
				pr[to][1][isS] = cur;
				q.push(to);
			}
			if (ds[to][isS] == ds[cur][isS] + 1) {
				if (mn[cur][isS] < mn[to][isS]) {
					mn[to][isS] = mn[cur][isS];
					pr[to][0][isS] = cur;
				}
				if (mx[cur][isS] > mx[to][isS]) {
					mx[to][isS] = mx[cur][isS];
					pr[to][1][isS] = cur;
				}
			}
		}
	}
}

int main() {
	#ifdef Madi
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
	#endif

	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		mn[i][0] = mn[i][1] = INF;
		mx[i][0] = mx[i][1] = 0;
	}
	for (int i = 1; i <= m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;

		g[a].push_back(make_pair(b, c));
		g[b].push_back(make_pair(a, c));
	}

	bfs(0);	
	bfs(1);

	if (ds[n][0] == 1) 
		return cout << "1\n1 " << n, 0;	

	vector<int> res, res1;
	
	int dx = -1;
	for (int i = 2; i < n; ++i) {
		if (ds[i][0] + ds[i][1] == ds[n][0] && mx[i][1] - mn[i][0] > dx) {
//			cout << i << " 0\n";
//			cout << mn[i][0] << ' ' << mx[i][1] << "\n";
			dx = mx[i][1] - mn[i][0];

			res.clear();
			int x = i;
			while (x != 1) {
				res.push_back(x);
				x = pr[x][0][0];
			}
			reverse(res.begin(), res.end());
			
			res1.clear();
			x = i;
			while (x != n) {
				x = pr[x][1][1];
				res1.push_back(x);				
			}
			for (auto it : res1)	
				res.push_back(it);
		}
		if (ds[i][0] + ds[i][1] == ds[n][0] && mx[i][0] - mn[i][1] > dx) {
//			cout << i << " 1\n";
//			cout << mx[i][0] << ' ' << mn[i][1] << "\n";
			dx = mx[i][0] - mn[i][0];

			res.clear();
			int x = i;
			while (x != 1) {
				res.push_back(x);
				x = pr[x][1][0];
			}
			reverse(res.begin(), res.end());
			
			res1.clear();
			x = i;
			while (x != n) {
				x = pr[x][0][1];
				res1.push_back(x);
			}
			for (auto it : res1)	
				res.push_back(it);
		}
	}
	
	cout << res.size() << "\n" << 1 << ' ';	
	for (auto it : res)
		cout << it << ' ';
	return 0;
}