#include <bits/stdc++.h>
using namespace std;

template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
} 
string to_string(const string& s) {
    return '"' + s + '"';
}
string to_string(const char* s) {
    return to_string((string) s);
}
string to_string(bool b) {
    return (b ? "true" : "false");
}
string to_string(vector<bool> v) {
    bool first = true;
    string res = "[";
    for (int i = 0; i < static_cast<int>(v.size()); i++) {
      if (!first) {
        res += ", ";
      }
      first = false;
      res += to_string(v[i]);
    }
    res += "]";
    return res;
}
template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "[";
    for (const auto &x : v) {
      if (!first) {
        res += ", ";
      }
      first = false;
      res += to_string(x);
    }
    res += "]";
    return res;
}
void debug_out() { cerr << endl; }
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: ", debug_out(__VA_ARGS__);

template<typename T>
T gcd(T x, T y) {
    while (y > 0) {
        x %= y;
        swap(x, y);
    }
    return x;
}

template<class T>
T lcm(T a, T b) {
    return a / gcd(a, b) * b;
}

#define clr(x) memset((x), 0, sizeof(x))
#define mem(a, b) memset(a, b, sizeof(a))
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define fi first
#define se second
#define eps 1e-9

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<vector<int>> vvi;
typedef vector<int> vi;

const int mod = 1e9 + 7;
const int N = 300 + 17;

int a[N][N];

int n, m;
int cF = 0, cQ = 0;
void checkF(int i, int j){
    if(i + 4 < n && j + 2 < m){
        if(a[i][j + 1] && a[i][j + 2] && a[i + 1][j] && a[i + 2][j + 1] 
            && a[i + 2][j] && a[i + 3][j] && a[i + 4][j]){
            a[i][j] = 0;
            a[i][j + 1] = 0;
             a[i][j + 2] = 0;
             a[i + 1][j] = 0;
             a[i + 2][j + 1] = 0;
             a[i + 2][j] = 0;
             a[i + 3][j] = 0;
             a[i + 4][j] = 0;
             cF++;
        }
    }
}

void checkQ(int i, int j){
    if(i + 4 < n && j + 2 < m){
        if(a[i][j + 1] && a[i][j + 2] && a[i + 1][j] && a[i + 1][j + 2] 
            && a[i + 2][j] && a[i + 2][j + 1] && a[i + 2][j + 2] &&
            a[i + 3][j + 2] && a[i +4][j + 2]){
            a[i][j] = 0;
        a[i][j + 1] = 0;
        a[i][j + 2] = 0;
        a[i + 1][j] = 0;
        a[i + 1][j + 2] = 0;
        a[i + 2][j] = 0;
        a[i + 2][j + 1] = 0;
        a[i + 2][j + 2] = 0;
        a[i + 3][j + 2] = 0;
        a[i + 4][j + 2] = 0;
        cQ++;
        }
    }
}   
int main(){
    ios::sync_with_stdio(0); 
    cin.tie(0); 
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            char c; cin >> c;
            if(c == '.'){
                a[i][j] = 0;
            }
            else a[i][j] = 1;
        }
    }
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n; j++){
            if(a[j][i]){
                checkF(j, i);
                checkQ(j, i);
            }
        }
    }
    cout << cQ << " " << cF << endl;
}
