#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;
const int maxn = (int) 4e6 + 1;

string s[maxn];

struct node{
    node *child[30];
    int cnt;
};

node *get(){
    node *p=new node();
    p->cnt=0;
    for(int i=0;i<27;i++){
        p->child[i]=nullptr;
    }
    return p;
}

node *head;
void add(string s){
    node *cur=head;
    for(int i=0;i<s.size();i++){
        int p = s[i]-'a';
        if(cur->child[p]==nullptr){
            cur->child[p]=get();
        }
        cur=cur->child[p];
        cur->cnt++;
    }
}

int n,m;
int mx=0;
node *tmp;
void search(node *root){
    if(root->cnt==0) return ;
    if(root->cnt<=m){
        mx = max(mx,root->cnt);
        tmp = root;
        return ;
    }
    for(int i=0;i<26;i++){
        if(root->child[i]!=NULL){
            search(root->child[i]);
        }
    }
}

int main(){
    cin>>n>>m;
    head = get();
    head->cnt = n;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        add(s[i]);
    }
    if(n<=m){
        cout<<1;
        return 0;
    }
    int ans = 0;
    while(n>m){
        mx = 0;
        ans++;
        tmp = nullptr;
        search(head);
        n -= mx;
        tmp->cnt = 0;
    }
    cout << ans+(n>0);
}