#include <bits/stdc++.h>

#define file ""

#define all(x) x.begin(), x.end()

#define sc second
#define fr first

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int inf = 1e9;
const ll mod = 1e9 + 7;

const int dx[] = {+1, -1, 0, 0};
const int dy[] = {0, 0, +1, -1};

const int N = 1e6 + 5;

int n, k;
int timer = 0;
int d[N], p[N];
int nxt[N][30];
int cnt[N];

vector<int> g[N];

void add(string& s) {
	int cur = 0;
 	for (int i = 0; i < s.size(); i++) {
 	 	if (nxt[cur][s[i] - 'a'] == 0) {
 	 		g[cur].pb(timer + 1);
 	 		g[timer + 1].pb(cur);
 	 	 	nxt[cur][s[i] - 'a'] = ++timer;
 	 	 	cur = timer;
 	 	}
 	 	else {
 	 	 	cur = nxt[cur][s[i] - 'a'];
 	 	}
 	}
 	cnt[cur]++;
}

void go(int x, int pr = -1, int deep = 1) {
	d[x] = deep;
	p[x] = pr;
 	for (int to : g[x]) {
 		if (to != pr) {
 			go(to, x, deep + 1);
 			cnt[x] += cnt[to]; 	
 		}
 	}
}

void rebuild(int x, int pr) {
	cnt[x] = 0;
 	for (int to : g[x]) {
  	if (to != pr) {
  	 	rebuild(to, x);
  	}
  }	
}

void update() {
	int pos = -1;
 	for (int i = 0; i <= timer; i++) {
 		if (pos == -1 && cnt[i] <= k) {
 			pos = i;
 		 	continue;
 		}

 		if (pos == -1) continue;

 		if (cnt[i] == cnt[pos] && cnt[i] <= k) {
 		 	if (d[i] > d[pos]) {
 		 	 	pos = i;
 		 	}
 		} 
 		else if (cnt[i] > cnt[pos] && cnt[i] <= k){
 			pos = i;
 		}
 	}
 	int x = pos;
 	
 	int v = cnt[x];

 	rebuild(x, p[x]);

 	

 	while (x != -1) {
 	 	cnt[x] -= v;
 	 	x = p[x];
 	}
}

int main() {    /* 
#ifdef ONLINE_JUDGE
  freopen(file".in", "r", stdin);
  freopen(file".out", "w", stdout);  
#endif            */
  ios_base :: sync_with_stdio(false);
  cin.tie(NULL);
  srand(time(NULL));
  cin >> n >> k;
  for (int i = 1; i <= n; i++) {
   	string s;
   	cin >> s;
   	add(s);
  }
  go(0);
  int ans = 0;
  while (true) {
   	if (cnt[0] <= 0)
   		break;

   	ans++;
   	update();
  }
  cout << ans;
 	return 0;
}